#!/bin/sh

. /lib/functions.sh

multilan_on()
{
	[ "$(get_version multilan)" == "1" ] && return 0
	return 1
}

vnet_on()
{
	[ -e /lib/vnet/vnet.sh ]
}

# max number of wan
global_wan_max()
{
	local wanmax=$(uci -c /etc/profile.d get profile.@interface[0].wan_max)

	[ -z "$wanmax" ] && wanmax=4

	echo -n "$wanmax"
}

# all wan numbers, include disabled wans.
global_wan_number_list()
{
	local wanmax=$(uci -c /etc/profile.d get profile.@interface[0].wan_max)

	[ -z "$wanmax" ] && wanmax=4

	echo -n "$(seq 1 1 $wanmax)"
}

# all wan names, include disabled wans.
global_wan_name_list()
{
	local wanmax=$(uci -c /etc/profile.d get profile.@interface[0].wan_max)
	local wanlist=""

	[ -z "$wanmax" ] && wanmax=4

	for i in $(seq 1 1 $wanmax)
	do
		wanlist="${wanlist} WAN${i}"
	done
	
	echo -n "$wanlist"
}

# only enabled wan numbers.
global_wan_effect_number_list()
{
	local wannumbers=$(uci get network.global.wan_numbers)
	
	echo -n "$wannumbers"
}

# only enabled wan names.
global_wan_effect_name_list()
{
	local wannumbers=$(uci get network.global.wan_numbers)
	local wanlist=""

	for i in ${wannumbers}
	do
		wanlist="${wanlist} WAN${i}"
	done
	
	echo -n "$wanlist"
}