/*! Copyright(c) 2008-2010 Shenzhen TP-LINK Technologies Co.Ltd.
 *
 *\file     sfe_ipstat.h
 *\brief    
 *\details  
 *
 *\author   
 *\version  
 *\date          
 *
 *\warning  
 *
 *\history  \arg    , , , Create the file.
 */

#ifndef _SFE_IPSTAT_H_
#define _SFE_IPSTAT_H_
/**************************************************************************************************/
/*                                      CONFIGURATIONS                                            */
/**************************************************************************************************/

/**************************************************************************************************/
/*                                      INCLUDE_FILES                                             */
/**************************************************************************************************/
#include <linux/netdevice.h>
#include <linux/if_ether.h>

#ifdef __cplusplus
extern "C" 
{
#endif  /* __cplusplus */

/**************************************************************************************************/
/*                                      DEFINES                                                   */
/**************************************************************************************************/
#define SFE_CONNMARK_STAT 1
#define IPSTAT_SUPPORT_IPV6 1
#define SFE_FILE_PATH "/tmp/sfe_ipstat"
/**************************************************************************************************/
/*                                      TYPES                                                     */
/**************************************************************************************************/
struct sfe_ipv4_stat_info
{
        int protocol;
        struct net_device *in;
        struct net_device *out;
        uint32_t src_ip;
        uint32_t dst_ip;
        uint8_t dst_mac[ETH_ALEN];
#ifdef SFE_CONNMARK_STAT
	uint32_t connmark;
#endif
};
#ifdef IPSTAT_SUPPORT_IPV6
struct sfe_ipv6_stat_info
{
        int protocol;
        struct net_device *in;
        struct net_device *out;
        struct sfe_ipv6_addr src_ip;
        struct sfe_ipv6_addr dst_ip;
        uint8_t dst_mac[ETH_ALEN];
#ifdef SFE_CONNMARK_STAT
        uint32_t connmark;
#endif
};
#endif
/**************************************************************************************************/
/*                                      VARIABLES                                                 */
/**************************************************************************************************/

/**************************************************************************************************/
/*                                      FUNCTIONS                                                 */
/**************************************************************************************************/
void sfe_ipstat_in(const struct sfe_ipv4_stat_info *sist,
                          const struct sk_buff *skb);
#ifdef IPSTAT_SUPPORT_IPV6
void sfe_ipstat_in6(const struct sfe_ipv6_stat_info *sist,
                          const struct sk_buff *skb);
#endif
void sfe_ipstat_update(u_int32_t ipaddr, u_int64_t src_bytes, u_int64_t src_pkts,
                          u_int64_t dst_bytes, u_int64_t dst_pkts);
#ifdef SFE_CONNMARK_STAT
void sfe_connmark_update(u_int32_t connmark, bool clientFlag, u_int64_t src_bytes, u_int64_t src_pkts,
                          u_int64_t dst_bytes, u_int64_t dst_pkts);
#endif
int sfe_ipstat_init(void);
int sfe_ipstat_exit(void);
int sfe_ipstat_flush(void);

#ifdef __cplusplus
}
#endif  /* __cplusplus */


#endif  /* _SFE_IPSTAT_H_ */

