/** @file      plugin_events.h
  * @brief     PLUG-IN event body definition
  * @copyright Copyright (C) 2014 by ipoque GmbH, a Rohde & Schwarz company. All rights reserved.
  *            See also the DISCLAIMER file that is part of your delivery. */

#ifndef PLUGIN_EVENTS_H
#define PLUGIN_EVENTS_H

/* Includes *********************************************************************/
#include "common_event_defs.h"

/* Event Group ******************************************************************/
/**
 * @brief Public define for the assigned metadata group of PLUG-IN events.
 */
#define PACE2_PLUGIN_EVENT_GROUP PACE2_CUSTOM_DEFINED_EVENT_GROUP


/* Event Structures *************************************************************/

/**
 * @brief Data structure for user defined PLUG-IN events.
 */
typedef struct {
    /** Global event type, has to be @ref PACE2_PLUGIN_EVENT for this structure. */
    PACE2_EVENT_COMMON_FIELDS;

    PACE2_plugin_id_struct plugin_id;   /*!< ID of the PLUG-IN generating the event. */
    u32 plugin_event_id;                /*!< PLUG-IN-specific ID of the event. Each different event of a single PLUG-IN must have a different plugin_event_id. */
    u8 plugin_data[];                   /*!< Data of the PLUG-IN event. */
} PACE2_plugin_event;

#endif /* PLUGIN_EVENTS_H */

/*********************************************************************************
 ** EOF
 ********************************************************************************/
