/** @file      zero_events.h
  * @brief     Zero event definitions.
  * @copyright Copyright (C) 2014 by ipoque GmbH, a Rohde & Schwarz company. All rights reserved.
  *            See also the DISCLAIMER file that is part of your delivery. */

#ifndef PACE2_INCLUDE_IPOQUE_EVENT_TYPES_ZERO_EVENTS_H_
#define PACE2_INCLUDE_IPOQUE_EVENT_TYPES_ZERO_EVENTS_H_

/* Includes *********************************************************************/
#include "common_event_defs.h"

/* Event Groups *****************************************************************/
/**
 * @brief Public define for the assigned metadata group of the basic ZERO Server Name Indication event.
 */
#define PACE2_BASIC_ZERO_SNI_EVENT_GROUP PACE2_BASIC_PROTOCOL_META_DATA_GROUP

/* Event Types ******************************************************************/

/**
 * @brief Data structure of a ZERO Server Name Indication metadata event.
 */
typedef struct {
    /** Global event type, has to be @ref PACE2_BASIC_ZERO_SNI_EVENT for this structure. */
    PACE2_EVENT_COMMON_FIELDS;
    PACE2_byte_buffer content;                      /**< ZERO Server Name Indication content. */
} PACE2_ZERO_sni_event;

#endif /* PACE2_INCLUDE_IPOQUE_EVENT_TYPES_ZERO_EVENTS_H_ */

/*********************************************************************************
 ** EOF
 ********************************************************************************/
