/** @file      ipd_charset.h
  * @brief     Definition for the structure ipd_charset_string and declaration of some helper function for it.
  * @copyright Copyright (C) 2014 by ipoque GmbH, a Rohde & Schwarz company. All rights reserved.
  *            See also the DISCLAIMER file that is part of your delivery. */

/* DO NOT EDIT
 * This file has been automatically generated from the registered charset list maintained by IANA
 * (http://www.iana.org/assignments/character-sets).
 */

#ifndef __IPOQUE_DECODER_CHARSET_INCLUDE_FILE__
#define __IPOQUE_DECODER_CHARSET_INCLUDE_FILE__

#include <stdio.h>

#include "ipd_public_structures.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Enumeration of charsets known to PACE2.
 *
 * These are *not* the MIBenum values from the IANA charset registry. The function #ipd_get_charset_from_iana
 * can be used to look up the ipd_charset value, given a MIBenum value.
 *
 * @see struct ipd_charset_string::charset
 */
enum ipd_charset {
    CHARSET_STRING_CHARSET_UNKNOWN = 0,
    CHARSET_STRING_CHARSET_BINARY = 1,
    CHARSET_STRING_CHARSET_ASCII = 2,
    CHARSET_STRING_CHARSET_ISO8859_1 = 3,
    CHARSET_STRING_CHARSET_ISO8859_2 = 4,
    CHARSET_STRING_CHARSET_ISO8859_3 = 5,
    CHARSET_STRING_CHARSET_ISO8859_4 = 6,
    CHARSET_STRING_CHARSET_ISO8859_5 = 7,
    CHARSET_STRING_CHARSET_ISO8859_6 = 8,
    CHARSET_STRING_CHARSET_ISO8859_7 = 9,
    CHARSET_STRING_CHARSET_ISO8859_8 = 10,
    CHARSET_STRING_CHARSET_ISO8859_9 = 11,
    CHARSET_STRING_CHARSET_ISO8859_10 = 12,
    CHARSET_STRING_CHARSET_ISO6937_2_ADD = 13,
    CHARSET_STRING_CHARSET_JIS_X0201 = 14,
    CHARSET_STRING_CHARSET_JIS_ENCODING = 15,
    CHARSET_STRING_CHARSET_SHIFT_JIS = 16,
    CHARSET_STRING_CHARSET_EUC_JP = 17,
    CHARSET_STRING_CHARSET_EXTENDED_UNIX_CODE_FIXED_WIDTH_FOR_JAPANESE = 18,
    CHARSET_STRING_CHARSET_BS4730 = 19,
    CHARSET_STRING_CHARSET_SEN850200_C = 20,
    CHARSET_STRING_CHARSET_IT = 21,
    CHARSET_STRING_CHARSET_ES = 22,
    CHARSET_STRING_CHARSET_DIN66003 = 23,
    CHARSET_STRING_CHARSET_NS4551_1 = 24,
    CHARSET_STRING_CHARSET_NF_Z_62_010 = 25,
    CHARSET_STRING_CHARSET_ISO10646_UTF_1 = 26,
    CHARSET_STRING_CHARSET_ISO646_BASIC_1983 = 27,
    CHARSET_STRING_CHARSET_INVARIANT = 28,
    CHARSET_STRING_CHARSET_ISO646_IRV_1983 = 29,
    CHARSET_STRING_CHARSET_NATS_SEFI = 30,
    CHARSET_STRING_CHARSET_NATS_SEFI_ADD = 31,
    CHARSET_STRING_CHARSET_NATS_DANO = 32,
    CHARSET_STRING_CHARSET_NATS_DANO_ADD = 33,
    CHARSET_STRING_CHARSET_SEN850200_B = 34,
    CHARSET_STRING_CHARSET_KS_C_5601_1987 = 35,
    CHARSET_STRING_CHARSET_ISO2022_KR = 36,
    CHARSET_STRING_CHARSET_EUC_KR = 37,
    CHARSET_STRING_CHARSET_ISO2022_JP = 38,
    CHARSET_STRING_CHARSET_ISO2022_JP_2 = 39,
    CHARSET_STRING_CHARSET_JIS_C6220_1969_JP = 40,
    CHARSET_STRING_CHARSET_JIS_C6220_1969_RO = 41,
    CHARSET_STRING_CHARSET_PT = 42,
    CHARSET_STRING_CHARSET_GREEK7_OLD = 43,
    CHARSET_STRING_CHARSET_LATIN_GREEK = 44,
    CHARSET_STRING_CHARSET_ISO_IR_25 = 45,
    CHARSET_STRING_CHARSET_LATIN_GREEK_1 = 46,
    CHARSET_STRING_CHARSET_ISO5427 = 47,
    CHARSET_STRING_CHARSET_JIS_C6226_1978 = 48,
    CHARSET_STRING_CHARSET_BS_VIEWDATA = 49,
    CHARSET_STRING_CHARSET_INIS = 50,
    CHARSET_STRING_CHARSET_INIS8 = 51,
    CHARSET_STRING_CHARSET_INIS_CYRILLIC = 52,
    CHARSET_STRING_CHARSET_ISO5427_1981 = 53,
    CHARSET_STRING_CHARSET_ISO5428_1980 = 54,
    CHARSET_STRING_CHARSET_GB1988_80 = 55,
    CHARSET_STRING_CHARSET_GB2312_80 = 56,
    CHARSET_STRING_CHARSET_NS4551_2 = 57,
    CHARSET_STRING_CHARSET_VIDEOTEX_SUPPL = 58,
    CHARSET_STRING_CHARSET_PT2 = 59,
    CHARSET_STRING_CHARSET_ES2 = 60,
    CHARSET_STRING_CHARSET_MSZ7795_3 = 61,
    CHARSET_STRING_CHARSET_JIS_C6226_1983 = 62,
    CHARSET_STRING_CHARSET_GREEK7 = 63,
    CHARSET_STRING_CHARSET_ASMO449 = 64,
    CHARSET_STRING_CHARSET_ISO_IR_90 = 65,
    CHARSET_STRING_CHARSET_JIS_C6229_1984_A = 66,
    CHARSET_STRING_CHARSET_JIS_C6229_1984_B = 67,
    CHARSET_STRING_CHARSET_JIS_C6229_1984_B_ADD = 68,
    CHARSET_STRING_CHARSET_JIS_C6229_1984_HAND = 69,
    CHARSET_STRING_CHARSET_JIS_C6229_1984_HAND_ADD = 70,
    CHARSET_STRING_CHARSET_JIS_C6229_1984_KANA = 71,
    CHARSET_STRING_CHARSET_ISO2033_1983 = 72,
    CHARSET_STRING_CHARSET_ANSI_X3_110_1983 = 73,
    CHARSET_STRING_CHARSET_T61_7BIT = 74,
    CHARSET_STRING_CHARSET_T61_8BIT = 75,
    CHARSET_STRING_CHARSET_ECMA_CYRILLIC = 76,
    CHARSET_STRING_CHARSET_CSA_Z243_4_1985_1 = 77,
    CHARSET_STRING_CHARSET_CSA_Z243_4_1985_2 = 78,
    CHARSET_STRING_CHARSET_CSA_Z243_4_1985_GR = 79,
    CHARSET_STRING_CHARSET_ISO8859_6_E = 80,
    CHARSET_STRING_CHARSET_ISO8859_6_I = 81,
    CHARSET_STRING_CHARSET_T101_G2 = 82,
    CHARSET_STRING_CHARSET_ISO8859_8_E = 83,
    CHARSET_STRING_CHARSET_ISO8859_8_I = 84,
    CHARSET_STRING_CHARSET_CSN369103 = 85,
    CHARSET_STRING_CHARSET_JUS_I_B1_002 = 86,
    CHARSET_STRING_CHARSET_IEC_P27_1 = 87,
    CHARSET_STRING_CHARSET_JUS_I_B1_003_SERB = 88,
    CHARSET_STRING_CHARSET_JUS_I_B1_003_MAC = 89,
    CHARSET_STRING_CHARSET_GREEK_CCITT = 90,
    CHARSET_STRING_CHARSET_NC_NC00_10_81 = 91,
    CHARSET_STRING_CHARSET_ISO6937_2_25 = 92,
    CHARSET_STRING_CHARSET_GOST19768_74 = 93,
    CHARSET_STRING_CHARSET_ISO8859_SUPP = 94,
    CHARSET_STRING_CHARSET_ISO10367_BOX = 95,
    CHARSET_STRING_CHARSET_LATIN_LAP = 96,
    CHARSET_STRING_CHARSET_JIS_X0212_1990 = 97,
    CHARSET_STRING_CHARSET_DS2089 = 98,
    CHARSET_STRING_CHARSET_US_DK = 99,
    CHARSET_STRING_CHARSET_DK_US = 100,
    CHARSET_STRING_CHARSET_KSC5636 = 101,
    CHARSET_STRING_CHARSET_UNICODE1_1_UTF_7 = 102,
    CHARSET_STRING_CHARSET_ISO2022_CN = 103,
    CHARSET_STRING_CHARSET_ISO2022_CN_EXT = 104,
    CHARSET_STRING_CHARSET_UTF8 = 105,
    CHARSET_STRING_CHARSET_ISO8859_13 = 106,
    CHARSET_STRING_CHARSET_ISO8859_14 = 107,
    CHARSET_STRING_CHARSET_ISO8859_15 = 108,
    CHARSET_STRING_CHARSET_ISO8859_16 = 109,
    CHARSET_STRING_CHARSET_GBK = 110,
    CHARSET_STRING_CHARSET_GB18030 = 111,
    CHARSET_STRING_CHARSET_OSD_EBCDIC_DF04_15 = 112,
    CHARSET_STRING_CHARSET_OSD_EBCDIC_DF03_IRV = 113,
    CHARSET_STRING_CHARSET_OSD_EBCDIC_DF04_1 = 114,
    CHARSET_STRING_CHARSET_ISO11548_1 = 115,
    CHARSET_STRING_CHARSET_KZ1048 = 116,
    CHARSET_STRING_CHARSET_ISO10646_UCS_2 = 117,
    CHARSET_STRING_CHARSET_ISO10646_UCS_4 = 118,
    CHARSET_STRING_CHARSET_ISO10646_UCS_BASIC = 119,
    CHARSET_STRING_CHARSET_ISO10646_UNICODE_LATIN1 = 120,
    CHARSET_STRING_CHARSET_ISO_UNICODE_IBM_1261 = 121,
    CHARSET_STRING_CHARSET_ISO_UNICODE_IBM_1268 = 122,
    CHARSET_STRING_CHARSET_ISO_UNICODE_IBM_1276 = 123,
    CHARSET_STRING_CHARSET_ISO_UNICODE_IBM_1264 = 124,
    CHARSET_STRING_CHARSET_ISO_UNICODE_IBM_1265 = 125,
    CHARSET_STRING_CHARSET_UNICODE1_1 = 126,
    CHARSET_STRING_CHARSET_SCSU = 127,
    CHARSET_STRING_CHARSET_UTF7 = 128,
    CHARSET_STRING_CHARSET_UTF16BE = 129,
    CHARSET_STRING_CHARSET_UTF16LE = 130,
    CHARSET_STRING_CHARSET_UTF16 = 131,
    CHARSET_STRING_CHARSET_CESU8 = 132,
    CHARSET_STRING_CHARSET_UTF32 = 133,
    CHARSET_STRING_CHARSET_UTF32BE = 134,
    CHARSET_STRING_CHARSET_UTF32LE = 135,
    CHARSET_STRING_CHARSET_BOCU1 = 136,
    CHARSET_STRING_CHARSET_ISO8859_1_WINDOWS_3_0_LATIN_1 = 137,
    CHARSET_STRING_CHARSET_ISO8859_1_WINDOWS_3_1_LATIN_1 = 138,
    CHARSET_STRING_CHARSET_ISO8859_2_WINDOWS_LATIN_2 = 139,
    CHARSET_STRING_CHARSET_ISO8859_9_WINDOWS_LATIN_5 = 140,
    CHARSET_STRING_CHARSET_HP_ROMAN8 = 141,
    CHARSET_STRING_CHARSET_ADOBE_STANDARD_ENCODING = 142,
    CHARSET_STRING_CHARSET_VENTURA_US = 143,
    CHARSET_STRING_CHARSET_VENTURA_INTERNATIONAL = 144,
    CHARSET_STRING_CHARSET_DEC_MCS = 145,
    CHARSET_STRING_CHARSET_IBM850 = 146,
    CHARSET_STRING_CHARSET_IBM852 = 147,
    CHARSET_STRING_CHARSET_IBM437 = 148,
    CHARSET_STRING_CHARSET_PC8_DANISH_NORWEGIAN = 149,
    CHARSET_STRING_CHARSET_IBM862 = 150,
    CHARSET_STRING_CHARSET_PC8_TURKISH = 151,
    CHARSET_STRING_CHARSET_IBM_SYMBOLS = 152,
    CHARSET_STRING_CHARSET_IBM_THAI = 153,
    CHARSET_STRING_CHARSET_HP_LEGAL = 154,
    CHARSET_STRING_CHARSET_HP_PI_FONT = 155,
    CHARSET_STRING_CHARSET_HP_MATH8 = 156,
    CHARSET_STRING_CHARSET_ADOBE_SYMBOL_ENCODING = 157,
    CHARSET_STRING_CHARSET_HP_DESKTOP = 158,
    CHARSET_STRING_CHARSET_VENTURA_MATH = 159,
    CHARSET_STRING_CHARSET_MICROSOFT_PUBLISHING = 160,
    CHARSET_STRING_CHARSET_WINDOWS31J = 161,
    CHARSET_STRING_CHARSET_GB2312 = 162,
    CHARSET_STRING_CHARSET_BIG5 = 163,
    CHARSET_STRING_CHARSET_MACINTOSH = 164,
    CHARSET_STRING_CHARSET_IBM037 = 165,
    CHARSET_STRING_CHARSET_IBM038 = 166,
    CHARSET_STRING_CHARSET_IBM273 = 167,
    CHARSET_STRING_CHARSET_IBM274 = 168,
    CHARSET_STRING_CHARSET_IBM275 = 169,
    CHARSET_STRING_CHARSET_IBM277 = 170,
    CHARSET_STRING_CHARSET_IBM278 = 171,
    CHARSET_STRING_CHARSET_IBM280 = 172,
    CHARSET_STRING_CHARSET_IBM281 = 173,
    CHARSET_STRING_CHARSET_IBM284 = 174,
    CHARSET_STRING_CHARSET_IBM285 = 175,
    CHARSET_STRING_CHARSET_IBM290 = 176,
    CHARSET_STRING_CHARSET_IBM297 = 177,
    CHARSET_STRING_CHARSET_IBM420 = 178,
    CHARSET_STRING_CHARSET_IBM423 = 179,
    CHARSET_STRING_CHARSET_IBM424 = 180,
    CHARSET_STRING_CHARSET_IBM500 = 181,
    CHARSET_STRING_CHARSET_IBM851 = 182,
    CHARSET_STRING_CHARSET_IBM855 = 183,
    CHARSET_STRING_CHARSET_IBM857 = 184,
    CHARSET_STRING_CHARSET_IBM860 = 185,
    CHARSET_STRING_CHARSET_IBM861 = 186,
    CHARSET_STRING_CHARSET_IBM863 = 187,
    CHARSET_STRING_CHARSET_IBM864 = 188,
    CHARSET_STRING_CHARSET_IBM865 = 189,
    CHARSET_STRING_CHARSET_IBM868 = 190,
    CHARSET_STRING_CHARSET_IBM869 = 191,
    CHARSET_STRING_CHARSET_IBM870 = 192,
    CHARSET_STRING_CHARSET_IBM871 = 193,
    CHARSET_STRING_CHARSET_IBM880 = 194,
    CHARSET_STRING_CHARSET_IBM891 = 195,
    CHARSET_STRING_CHARSET_IBM903 = 196,
    CHARSET_STRING_CHARSET_IBM904 = 197,
    CHARSET_STRING_CHARSET_IBM905 = 198,
    CHARSET_STRING_CHARSET_IBM918 = 199,
    CHARSET_STRING_CHARSET_IBM1026 = 200,
    CHARSET_STRING_CHARSET_EBCDIC_AT_DE = 201,
    CHARSET_STRING_CHARSET_EBCDIC_AT_DE_A = 202,
    CHARSET_STRING_CHARSET_EBCDIC_CA_FR = 203,
    CHARSET_STRING_CHARSET_EBCDIC_DK_NO = 204,
    CHARSET_STRING_CHARSET_EBCDIC_DK_NO_A = 205,
    CHARSET_STRING_CHARSET_EBCDIC_FI_SE = 206,
    CHARSET_STRING_CHARSET_EBCDIC_FI_SE_A = 207,
    CHARSET_STRING_CHARSET_EBCDIC_FR = 208,
    CHARSET_STRING_CHARSET_EBCDIC_IT = 209,
    CHARSET_STRING_CHARSET_EBCDIC_PT = 210,
    CHARSET_STRING_CHARSET_EBCDIC_ES = 211,
    CHARSET_STRING_CHARSET_EBCDIC_ES_A = 212,
    CHARSET_STRING_CHARSET_EBCDIC_ES_S = 213,
    CHARSET_STRING_CHARSET_EBCDIC_UK = 214,
    CHARSET_STRING_CHARSET_EBCDIC_US = 215,
    CHARSET_STRING_CHARSET_UNKNOWN8BIT = 216,
    CHARSET_STRING_CHARSET_MNEMONIC = 217,
    CHARSET_STRING_CHARSET_MNEM = 218,
    CHARSET_STRING_CHARSET_VISCII = 219,
    CHARSET_STRING_CHARSET_VIQR = 220,
    CHARSET_STRING_CHARSET_KOI8_R = 221,
    CHARSET_STRING_CHARSET_HZ_GB_2312 = 222,
    CHARSET_STRING_CHARSET_IBM866 = 223,
    CHARSET_STRING_CHARSET_IBM775 = 224,
    CHARSET_STRING_CHARSET_KOI8_U = 225,
    CHARSET_STRING_CHARSET_IBM00858 = 226,
    CHARSET_STRING_CHARSET_IBM00924 = 227,
    CHARSET_STRING_CHARSET_IBM01140 = 228,
    CHARSET_STRING_CHARSET_IBM01141 = 229,
    CHARSET_STRING_CHARSET_IBM01142 = 230,
    CHARSET_STRING_CHARSET_IBM01143 = 231,
    CHARSET_STRING_CHARSET_IBM01144 = 232,
    CHARSET_STRING_CHARSET_IBM01145 = 233,
    CHARSET_STRING_CHARSET_IBM01146 = 234,
    CHARSET_STRING_CHARSET_IBM01147 = 235,
    CHARSET_STRING_CHARSET_IBM01148 = 236,
    CHARSET_STRING_CHARSET_IBM01149 = 237,
    CHARSET_STRING_CHARSET_BIG5_HKSCS = 238,
    CHARSET_STRING_CHARSET_IBM1047 = 239,
    CHARSET_STRING_CHARSET_PTCP154 = 240,
    CHARSET_STRING_CHARSET_AMIGA1251 = 241,
    CHARSET_STRING_CHARSET_KOI7_SWITCHED = 242,
    CHARSET_STRING_CHARSET_BRF = 243,
    CHARSET_STRING_CHARSET_TSCII = 244,
    CHARSET_STRING_CHARSET_WINDOWS1250 = 245,
    CHARSET_STRING_CHARSET_WINDOWS1251 = 246,
    CHARSET_STRING_CHARSET_WINDOWS1252 = 247,
    CHARSET_STRING_CHARSET_WINDOWS1253 = 248,
    CHARSET_STRING_CHARSET_WINDOWS1254 = 249,
    CHARSET_STRING_CHARSET_WINDOWS1255 = 250,
    CHARSET_STRING_CHARSET_WINDOWS1256 = 251,
    CHARSET_STRING_CHARSET_WINDOWS1257 = 252,
    CHARSET_STRING_CHARSET_WINDOWS1258 = 253,
    CHARSET_STRING_CHARSET_TIS620 = 254,

    IPD_NUMBER_OF_CHARSETS = 255
};

struct ipd_charset_string {
    struct ipd_string content;
    enum ipd_charset charset;
};
typedef struct ipd_charset_string charset_string;

/**
 * Function to return a character set code that can be used in the charset_string.charset field
 *
 * @param name charset name (eg, "UTF-8" or "latin1")
 * @return internal index of charset
 */
enum ipd_charset ipd_charset_for_name(const struct ipd_string *name);

/**
 * Function to return a character set code that can be used in the charset_string.charset field
 *
 * If contenttype is empty, the return value is CHARSET_STRING_CHARSET_UNKNOWN.
 * If contenttype is non-empty but contains no charset parameter
 *   and starts with "text/", the return value is CHARSET_STRING_CHARSET_UNKNOWN,
 *   otherwise, the return value is CHARSET_STRING_CHARSET_BINARY.
 * Otherwise, the value of the charset parameter is used to look up a charset code.
 *
 * @param contenttype MIME content-type line (eg, "text/xml; charset=utf-8")
 * @return internal index of charset
 */
enum ipd_charset ipd_charset_for_contenttype(const struct ipd_string *contenttype);

/**
 * Function to return the canonical name of charset based on internal indexation
 *
 * @param cs internal index of charset
 * @return charset_name in reference to official IANA list
 */
const char *ipd_charset_name(enum ipd_charset cs);

/**
 * Function to return the canonical name of charset based on official IANA indexation
 *
 * @param val official index
 * @return charset_name in reference to official IANA list
 */
const char *ipd_charset_name_from_iana_no(u64 val);

/**
 * Function to return internal index of charset based on official IANA indexation
 *
 * @param val official index of charset
 * @return internal index of charset
 */
int ipd_get_charset_from_iana(u64 val);

/**
 * Function to write output to given address and in given charset
 *
 * @param f pointer to a FILE object that identifies the stream
 * @param s charset for output
 */
void ipd_csprint(FILE *f, const struct ipd_charset_string *s);

#ifdef __cplusplus
}
#endif
#endif /* __IPOQUE_DECODER_CHARSET_INCLUDE_FILE__ */
