/** @file      ipd_postproc_protocols.h
  * @brief     Declaration for the HTTP post processing protocols. This means the protocol number definition for all
  *            website decoders.
  * @copyright Copyright (C) 2014 by ipoque GmbH, a Rohde & Schwarz company. All rights reserved.
  *            See also the DISCLAIMER file that is part of your delivery. */

#ifndef __IPOQUE_DECODER_POSTPROC_PROTOCOLS_INCLUDE_FILE__
#define __IPOQUE_DECODER_POSTPROC_PROTOCOLS_INCLUDE_FILE__

/* this file contains definitions for protocols that are not part of the list of protocols
 * provided by the PACE library but are decoded as part of the post-processing of other protocols
 */

#define IPD_POSTPROC_PROTOCOL_ICQ_WEBCHAT       0x10002
#define IPD_POSTPROC_PROTOCOL_HI5               0x1000A
#define IPD_POSTPROC_PROTOCOL_JAVASCRIPT        0x10015

#endif                          /* __IPOQUE_DECODER_POSTPROC_PROTOCOLS_INCLUDE_FILE__ */

