/** @file      ipq_config.h
  * @brief     PACE configuration definitions
  * @copyright Copyright (C) 2014 by ipoque GmbH, a Rohde & Schwarz company. All rights reserved.
  *            See also the DISCLAIMER file that is part of your delivery. */

#ifndef IPQ_CONFIG_H
#define IPQ_CONFIG_H

/* if defined: add support for OS detection */
#define IPOQUE_SUPPORT_OS_DETECTION

/* if defined: build library that requires a license to work */
#define IPOQUE_ENABLE_LICENSING

/* if defined: build demo library */
#define IPOQUE_DEMO_VERSION

/* if defined: library for kernel space */
/* #undef PACE_KERNEL_LIB */

/* if defined: build PACE 2 with rtp performance measurement. */
#define IPOQUE_MEASURE_RTP_PERFORMANCE

/* if defined: build without debug information of AME event_id. */
/* #undef DISABLE_AME_EVENT_ID */

/* length of red zones at the beginning and end of memory blocks, in bytes */
#define IPOQUE_MEM_RZ 0

/* if defined: track peak memory usage (result is written to stderr during ipd_exit) */
/* #undef PROFILE_MEMORY_ALLOCATIONS */

/* if defined: dynamic upgrade feature is enabled */
#define IPOQUE_PACE_DYNAMIC_UPGRADE

/* if defined: decoders are disabled */
/* #undef PACE2_DISABLE_DECODER */

#define PACE2_ML_CLASS_COUNT_INT 0

#endif /* IPQ_CONFIG_H */
