/** @file      ipq_protocol_groups.h
  * @brief     PACE group definition.
  * @copyright Copyright (C) 2014 by ipoque GmbH, a Rohde & Schwarz company. All rights reserved.
  *            See also the DISCLAIMER file that is part of your delivery. */

#ifndef __IPOQUE_API_INCLUDE_FILE__
#error CANNOT INCLUDE THIS .H FILE, INCLUDE IPQ_API.H
#endif

#ifndef IPQ_PROTOCOLS_GROUPS_H
#define IPQ_PROTOCOLS_GROUPS_H

#ifdef __cplusplus
extern "C" {
#endif

enum ipoque_protocol_groups {
    IPOQUE_GROUP_GENERIC = 0,
    IPOQUE_GROUP_STANDARD,
    IPOQUE_GROUP_P2P,
    IPOQUE_GROUP_GAMING,
    IPOQUE_GROUP_TUNNEL,
    IPOQUE_GROUP_BUSINESS,
    IPOQUE_GROUP_VOIP,
    IPOQUE_GROUP_IM,
    IPOQUE_GROUP_STREAMING,
    IPOQUE_GROUP_MOBILE,
    IPOQUE_GROUP_REMOTE_CONTROL,
    IPOQUE_GROUP_VIDEO,
    IPOQUE_GROUP_AUDIO,
    IPOQUE_GROUP_MAIL,
    IPOQUE_GROUP_NETWORK_MANAGEMENT,
    IPOQUE_GROUP_DATABASE,
    IPOQUE_GROUP_FILETRANSFER,
    IPOQUE_GROUP_WEB,
    IPOQUE_GROUP_CONFERENCE,
    IPOQUE_GROUP_SOCIAL_NETWORKING,
    IPOQUE_GROUP_ANTIVIRUS_UPDATE,
    IPOQUE_GROUP_ADVERTISMENT_ANALYTIC_SERVICES, // use only for b2b services
    IPOQUE_GROUP_NEWS,
    IPOQUE_GROUP_HEALTH_FITNESS,
    IPOQUE_GROUP_CLOUD_CDN_SERVICES, // use only for b2b services
    IPOQUE_GROUP_NAVIGATION,
    IPOQUE_GROUP_E_COMMERCE,
    IPOQUE_GROUP_FINANCE,
    IPOQUE_GROUP_TRAVEL_TRANSPORTATION,
    IPOQUE_GROUP_PORNOGRAPHY,
    IPOQUE_GROUP_BOOKS_MAGAZINES,
    IPOQUE_GROUP_AUDIO_ENTERTAINMENT,
    IPOQUE_GROUP_EDUCATION,
    IPOQUE_GROUP_M2M_IOT,
    IPOQUE_GROUP_DEVICE_SECURITY,
    IPOQUE_GROUP_MULTIMEDIA_SERVICES, // use only for b2b services
    IPOQUE_GROUP_ORGANIZERS,
    IPOQUE_GROUP_ENTERPRISE_SERVICES, // use only for b2b services and providers
    IPOQUE_GROUP_APPSTORES_UPDATES,
    IPOQUE_GROUP_BROWSERS,

    IPOQUE_NUMBER_OF_GROUPS
};

#ifdef __cplusplus
}
#endif
#endif /* IPQ_PROTOCOLS_GROUPS_H */
