#!/bin/sh

local configdir="/etc/config"
local file="dnsproxy"
local tmpdir="/tmp/dnsproxy"

mkdir -p $tmpdir

cp -f $configdir/$file $tmpdir/$file

case ${ACTION} in
	ADDBR)
		[ -n "${CONFIF2}" -a -n "${BRIF}" ] && {
			cnt1=`sed -rn "/option\s+service_if\s+'*${CONFIF2}'*/p"  ${tmpdir}/$file | wc -l`
			cnt2=`sed -rn "/option\s+out_if\s+'*${CONFIF2}'*/p"  ${tmpdir}/$file | wc -l`
			[ $cnt1 = '0' ] && [ $cnt2 = '0'] && return;
			sed -ri "s/option\s+service_if\s+'*${CONFIF2}'*/option service_if '${BRIF}'/g"  ${tmpdir}/$file
			sed -ri "s/option\s+out_if\s+'*${CONFIF2}'*/option out_if '${BRIF}'/g"  ${tmpdir}/$file

			cntx=`uci get network.${CONFIF2}.t_reference`
			cntx=${cntx:-0}
			let cntx=cntx-cnt1
			let cntx=cntx-cnt2
			[ ${cntx} -lt 0 ] && cntx=0
			uci set network.${CONFIF2}.t_reference=${cntx}
			uci commit network

			cntx=`uci get network.${BRIF}.t_reference`
			cntx=${cntx:-0}
			let cntx=cnt1+cntx
			let cntx=cnt2+cntx
			uci set network.${BRIF}.t_reference=${cntx}
			uci commit network

		}
	;;
	UPDBR)
	;;
	DELBR)
	;;
	*)
	;;
esac

cp -f $tmpdir/$file  $configdir/$file
