#!/bin/sh

. /lib/functions.sh 
. /lib/functions/network.sh

VNET_LIBDIR=/lib/vnet

[ -z "$INTERFACE" ] && exit 0

. ${VNET_LIBDIR}/vnet_init.sh

carrier_connected()
{
	local ifname=$(uci get network.$1.ifname)
	[ -z "$ifname" ] && return 1
	local on_carrier=$(cat /sys/class/net/$ifname/carrier)
	local __state
	__network_ifstatus "__state" "$1" ".state"
	[ "$on_carrier" == "1" -a "$__state" == "connected" ] && return 0
	return 1
}

any_wan_is_up()
{
	local wanmode=$(uci get network.global.wanmode)

	network_flush_cache
	for wan_index in $( seq 1 ${wanmode})
	do
		network_is_up wan${wan_index}_eth && return 0
		network_is_up wan${wan_index}_poe && return 0
		# carrier_connected ${iface} && return 0
	done

	return 1
}

[ "${INTERFACE:0:3}" == "wan" ] && {
	case "$ACTION" in
		ifdown)
			any_wan_is_up || clean_upstream_routes
			;;
	esac
}

[ "$INTERFACE" == "lan" ] && {
	case "$ACTION" in
		ifdown)
			clean_downstream_routes
			clean_redirect_service_rules
			;;
	esac
}
