#!/bin/sh
# This script is executed as part of the hotplug event with
# HOTPLUG_TYPE=iface, triggered by various scripts when an interface
# is configured (ACTION=ifup) or deconfigured (ACTION=ifdown).  The
# interface is available as INTERFACE, the real device as DEVICE.

. /lib/functions.sh
. /lib/net_share.sh

delinfs=

case ${ACTION} in
	ifup)
		[ -n "${INTERFACE}" ] && [ "${INTERFACE}" = "lan" ] && {
			! multilan_on && {
				#config_load ipgroup
				#config_foreach modify_lan rule_ipscope
				#uci_commit ipgroup
				#lua /usr/lib/lua/ipgroup/ipgroup_reload.lua
				local netmask=$(uci get network.lan.netmask)
				local ipaddr=$(uci get network.lan.ipaddr)
				local network=$(ipcalc -n ${ipaddr} ${netmask} | cut -d '=' -f2)
				local prefix=$(ipcalc -p ${ipaddr} ${netmask} | cut -d '=' -f2)
				lua /usr/lib/lua/ipgroup/lanhook.lua "${network}/${prefix}"
				ipset flush "IPGROUP_LAN"
				ipset add "IPGROUP_LAN" "${network}/${prefix}" -exist
			}
		}
	;;
	*)
	;;
esac