#!/bin/sh
# This script is executed as part of the hotplug event with
# HOTPLUG_TYPE=iface, triggered by various scripts when an interface
# is configured (ACTION=ifup) or deconfigured (ACTION=ifdown).  The
# interface is available as INTERFACE, the real device as DEVICE.

. /lib/functions.sh
. /lib/net_share.sh

delinfs=

case ${ACTION} in
	ifup)
		[ -n "${INTERFACE}" ] && [ "${INTERFACE}" = "lanv6" ] && {
			! multilan_on && {
				#config_load ipgroup
				#config_foreach modify_lan rule_ipscope
				#uci_commit ipgroup
				#lua /usr/lib/lua/ipgroup/ipgroup_reload.lua
				local prefix=$(uci get vnetwork.NETWORK1.ipv6_prefixlen)
				local network=$(cat /tmp/.vnet_NETWORK1_ipv6_addr)
				lua /usr/lib/lua/ipv6group/lanhook.lua "${network}/${prefix}"
				ipset flush "ipv6_IPV6GROUP_LAN"
				ipset add "ipv6_IPV6GROUP_LAN" "${network}/${prefix}" -exist
			}
		}
	;;
	*)
	;;
esac
