#!/bin/sh
# This script is executed as part of the hotplug event with
# HOTPLUG_TYPE=iface, triggered by various scripts when an interface
# is configured (ACTION=ifup) or deconfigured (ACTION=ifdown).  The
# interface is available as INTERFACE, the real device as DEVICE.

[ "$DEVICE" == "lo" ] && exit 0

local en=`uci get upnp.default.state 2>/dev/null`
if [[ "$en" == "off" ]]; then
	exit 0
fi

. /lib/upnp/upnp_api.sh

case "$ACTION" in
	ifup) 
		get_wan_ip_for_ipset		
	;;
	ifdown)
		get_wan_ip_for_ipset
	;;
	ifupdate)
		get_wan_ip_for_ipset
	;;
esac