#!/bin/sh 
#/etc/rc.common
# Copyright(c) 2011-2015 Shenzhen TP-LINK Technologies Co.Ltd.
# file    98-ipsec_4napt.sh 
# brief   This script is executed as part of the hotplug event with
#		  HOTPLUG_TYPE=iface, triggered by various scripts when an interface
# 		  is configured (ACTION=ifup) or deconfigured (ACTION=ifdown).  The
# 		  interface is available as INTERFACE, the real device as DEVICE.
# author   Yang xiaoqiang
# version  1.0.0
# date     08June15
# histry   arg 1.0.0, 08June15, Yang xiaoqiang, Create the file. 

. /lib/functions.sh
. /lib/functions/network.sh
. /lib/zone/zone_api.sh
include /lib/network

	  
UCI_IPSEC_UCI_CONFIG_FILE=ipsec
UCI_DEFAULT_SEARCH_DIR=/etc/config
UCI_IPSEC_TO_BE_CHECK_SECTION=connection
UCI_IPSEC_TO_BE_CHECKED_FILE=${UCI_DEFAULT_SEARCH_DIR}/${UCI_IPSEC_UCI_CONFIG_FILE}

debug="off"

MY_ECHO(){
	if [ ${debug} = "on" ]
	then 
		echo "${1}" >> /tmp/log/ipsec_hotplug_4NAPT_.log		
	fi 	
}

case "$MODULE" in
	# NAT itself will make sure postrouting ipsec rules are put before postrouting nat rules
	# so there's no need to reload ipsec settings any more
	# NAPT)
	ABANDONED)
		echo "Got an NAPT hotplug clean=\"${CLEAN}\" " 
	if [ "${CLEAN}" == "on" ]
	then	
		{
			[ -e "${UCI_IPSEC_TO_BE_CHECKED_FILE}" ] || { MY_ECHO "file ${UCI_IPSEC_TO_BE_CHECKED_FILE} doesn't exist." ;exit 1; }
			[ ! -f "/var/log/ipsec_updown_histroy" ] && exit 1
			flock -x 30
			[ $? -eq 1 ] && { MY_ECHO "98-ipsec_4napt.sh get lock fail."; exit 1;}        
		   
			MY_ECHO "98-ipsec_4napt get lock successfully."
		
			while read line ; 
			do
				# echo "${line}"	
				# execute this command
				${line}
			done < /var/log/ipsec_updown_histroy 			
				
			flock -u 30
			MY_ECHO "98-ipsec_4napt release lock successfully."
			conntrack -F
		} 30>>/var/lock/ipsec_updown
	fi 
	;;
esac

