#!/bin/sh

. /lib/functions.sh 

VNET_LIBDIR=/lib/vnet

[ -z "$INTERFACE" -o "$INTERFACE" = "vwan" ] && exit 0

. ${VNET_LIBDIR}/vnet_init.sh
. ${VNET_LIBDIR}/vnet_zone_init.sh
case "$ACTION" in
	add)
		build_downstream_routes "$INTERFACE"
		build_redirect_service_rules "$INTERFACE"
		[ -z "$DELAY_COMMIT" ] && /etc/init.d/zone restart lan
		;;
	delete)
		clean_downstream_routes "$INTERFACE"
		clean_redirect_service_rules "$INTERFACE"
		[ -z "$DELAY_COMMIT" ] && /etc/init.d/zone restart lan
		;;
	commit)
		/etc/init.d/zone restart lan
		;;
esac
