#!/bin/sh

. /lib/functions.sh 

[ -n "$VNET_BOOTING" ] && exit 0

DHCPS_LIBDIR=/lib/dhcps
DHCPS_CONFIGFILE="/etc/config/dhcp"

[ -z "$INTERFACE" ] && exit 0

. ${DHCPS_LIBDIR}/dhcps.sh
case "$ACTION" in
	add)
		config_load vnetwork
		build_dhcps_config $INTERFACE $DHCPS_CONFIGFILE
		build_dhcps_dnsmasq $DHCPS_CONFIGFILE
		[ -z "$DELAY_COMMIT" ] && /etc/init.d/dnsmasq restart
		;;
	delete)
		clean_dhcps_config $INTERFACE $DHCPS_CONFIGFILE
		[ -z "$DELAY_COMMIT" ] && /etc/init.d/dnsmasq restart
		;;
	notify)
		config_load vnetwork
		build_dhcps_config $INTERFACE $DHCPS_CONFIGFILE
		build_dhcps_dnsmasq $DHCPS_CONFIGFILE
		[ -z "$DELAY_COMMIT" ] && /etc/init.d/dnsmasq restart
		;;
	commit)
		/etc/init.d/dnsmasq restart
		;;
esac
