#!/bin/sh
[ -n "$VNET_BOOTING" ] && exit 0
[ "$DEVICE" == "lo" ] && exit 0

WPORTAL_LIBDIR=/lib/wportal
. $WPORTAL_LIBDIR/config.sh

local URL_PREFIX="http://127.0.0.1:"
local auth_port=`uci get wportal.global_set.auth_port`
if [ "$auth_port" == "" ];then
        auth_port="8080"
fi
local ngx_portal_url="$URL_PREFIX""$auth_port""/wifidog/updateauthcfg"

update_wportalEntry_interface_by_zone()
{
sqlite3 /etc/config/portal.db <<EOF
update wportal set interface='$1',gw_id='$1' where zone='$2';
EOF
}

del_wportalEntry_interface_by_zone()
{
sqlite3 /etc/config/portal.db <<EOF
delete from wportal where zone='$1';
EOF
}

case "$ACTION" in
        add)
                config_load "wportal"
                config_get zones dft_wportal zones
                config_get global_enable dft_wportal enable
                zone=`zone_get_zone_byif $INTERFACE`      
                for i in ${zones}
                do
                        if [ "$i" == "$zone" ];then
                                echo "wportal add interface:"$DEVICE > /dev/console
                                uci add_list wportal.dft_wportal.interface=$DEVICE
                                uci add_list wportal.dft_wportal.gw_id=$DEVICE
                                uci commit

                                [ "$global_enable" == "on" ] && update_wportalEntry_interface_by_zone "$DEVICE" "$zone"  ##update database
                        fi
                done
        ;;
        delete)      
                ##delete阶段及时删除network对应的interface，但network对应的zone保留到commit阶段再决定是否删除
                config_load "wportal"
                config_get interfaces dft_wportal interface
                for i in ${interfaces}
                do
                        if [ "$i" == "$DEVICE" ];then
                                echo "wportal delete interface:"$DEVICE > /dev/console
                                uci del_list wportal.dft_wportal.interface=$DEVICE
                                uci del_list wportal.dft_wportal.gw_id=$DEVICE
                                uci commit
                        fi
                done
        ;;
        commit)
                config_load "wportal"
                config_get zones dft_wportal zones
                config_get global_enable dft_wportal enable
                include=0

                for zact in $ZACTION #ZACTION=LAN1=delete,add
                do
                        action=""
                        zn=${zact%%=*}
                        echo "$zones" | grep "$zn"
                        if [ $? -eq 0 ];then
                                include=1
                                op=${zact##*=}
                                for act in ${op//,/ }
                                do
                                        if [ "$act" == "delete" ]; then
                                                action="del"
                                        elif [ "$act" == "add" -a "$action" == "del" ];then
                                                action="set"
                                        fi
                                done
                                [ "$action" == "del" ] && {
                                        uci del_list wportal.dft_wportal.zones=$zn
                                        uci commit
                                        [ "$global_enable" == "on" ] && del_wportalEntry_interface_by_zone "$zn"
                                }
                        fi
                done

                if [ "$global_enable" == "on" -a "$include" == "1" ]
                then
                        echo "[hotplug vnet] wifidog restarting..." > /dev/console
                        set_wifidog_conf
                        vnete wifidog-init restart
                        vnete curl $ngx_portal_url    ##update share memory
                fi        
        ;;
        *)
                # do nothing
        ;;
esac
