#!/bin/sh

[ -n "$VNET_BOOTING" ] && exit 0

[ -z "$INTERFACE" -o "$INTERFACE" = "vwan" ] && exit 0

[ -z "$DELAY_COMMIT" ] && {
	. /lib/ipsec/ipsec_vnet.sh
}
[ "$ACTION" == "commit" ] && {
	. /lib/ipsec/ipsec_vnet.sh
}


case ${ACTION} in
		add)
		local local_vid=$(uci get vnetwork."${INTERFACE}".vlanid)
		if [ -n "${local_vid}" ] ; then
			lua /usr/lib/lua/ipsec/ipsec_utility.lua "mod" ${local_vid}
		fi
		;;
		
		delete)
		;;

		notify)
			local zone=$(uci get vnetwork."${INTERFACE}".zone)
			if [ -n "${zone}" ] ; then
				lua /usr/lib/lua/ipsec/ipsec_utility.lua "update" ${zone}
			fi
		;;

		commit)
			local zone=${ZACTION%%=*}
			if [ -n "${zone}" ] ; then
				lua /usr/lib/lua/ipsec/ipsec_utility.lua "update" ${zone}
			fi
		;;
		
		*)
		;;
esac
