#!/bin/sh

check_iface_exist()
{
	[ -n "$policy_name" ] && return

	iface=`uci get policy_route.$1.use_iface 2>/dev/null`
	if [ "$iface" == "$INTERFACE" ]; then
		policy_name=$1
		uci delete policy_route.$1
		uci_commit policy_route
	fi
}

del_policy_rule()
{
	config_get use_policy $1 use_policy

	if [ "$use_policy" == "$policy_name" ];then
		uci delete policy_route.$1
		uci_commit policy_route
	fi
}

_delete_rule() 
{ 
	local INTERFACE=$1 policy_name="" 

	config_load policy_route
	config_foreach check_iface_exist policy  

	#if the policy name exist and del the rule
	if [ -n "$policy_name" ];then
		config_foreach del_policy_rule policy_rule  
	fi                              
}

case ${ACTION} in
	DELETE)
		[ -n "${interfaces}" ] && { 
		    interfaces=${interfaces//,/ } 
			for element in $interfaces   
			do  
				[ -n "$element" ] && _delete_rule $element 
			done  
		}
	;;
	ADD)
	;;
	*)
	;;
esac