#!/bin/sh

. /lib/functions.sh
. /lib/online_check/online_api.sh

delinfs=

_online_del_zone() 
{                                        
    local zone="$1"
	uci delete online.${zone}
	del_online_check ${zone}
	uci commit online
}

_online_add_zone() 
{
	local zone=${1}

	if [ "$(get_version online)" == "1" ]; then
		uci set online.${zone}=interface
		uci set online.${zone}.mode="$(uci get online.WAN1.mode)"
		uci set online.${zone}.gateway="$(uci get online.WAN1.gateway)"
		uci set online.${zone}.dns="$(uci get online.WAN1.dns)"
		uci commit online
	else
		uci set online.${zone}=interface
		uci set online.${zone}.mode="auto"
		uci set online.${zone}.gateway="0.0.0.0"
		uci set online.${zone}.dns="0.0.0.0"
		uci commit online
	fi

	add_online_check ${zone}

}

_online_update_zone()
{
	local zone=${1}
	local auto="auto"
	local gw="`uci get online.${zone}.gateway`"
	local dns="`uci get online.${zone}.dns`"
	del_online_check ${zone}
	add_online_check ${zone}
	uci set online.${zone}.gateway=${gw}
	uci set online.${zone}.dns=${dns}
	uci set online.${zone}.mode=${auto}

	uci commit online
	update_online_manual_check ${zone} ${auto} ${gw} ${dns}
}

case ${ACTION} in
	DELETE)
		[ -n "${interfaces}" ] && {   
		    echo "DELETE interfaces=$interfaces" >> /tmp/online_wanhook.log    
		    interfaces=${interfaces//,/ } 
		    for element in ${interfaces}; do 
			    _online_del_zone ${element}
		    done
		}
	;;
	ADD)
		[ -n "${interfaces}" ] && {
			echo "ADD interfaces=$interfaces" >> /tmp/online_wanhook.log    
		    #interfaces=${interfaces//,/ } 
		    #for element in ${interfaces}; do 
		    #	_online_add_zone ${element}
		    #done
		}
	;;
	WANMOD)
		[ -n "${interfaces}" ] && {
			echo "WANMOD interfaces=$interfaces" >> /tmp/online_wanhook.log    
		    #interfaces=${interfaces//,/ } 
		    #for element in ${interfaces}; do 
		    	#del_online_check ${element}
		    	#add_online_check ${element}
		    #	_online_update_zone ${element}
		    #done
		}
		
	;;
	*)
	;;
esac
