#!/bin/sh

. /lib/functions.sh

delinfs=

l2tp_client_delete_rule() {                                        
    local section=${1}
	config_get valx ${section} outif
	config_get valx1 ${section} id
	
    for element in $interfaces; do  
		[ "${element}" = "${valx}" ] && {
			delifs="${delifs}${delifs:+,}`config_get ${section} tunnelname`"
			/lib/l2tp/l2tp-reload.sh delete lac ${valx1}
			uci delete l2tp-client.${section}
			#lua /lib/l2tp/l2tp-ipsec-delete.lua  ${valx1}
		}
	done
}

l2tp_server_delete_rule() {                                        
    local section=${1}
	config_get valx ${section} bindif
	config_get valx1 ${section} id
	
    for element in $interfaces; do  
		[ "${element}" = "${valx}" ] && {
			/lib/l2tp/l2tp-reload.sh delete lns ${valx1}
			uci delete l2tp-server.${section}
			#lua /lib/l2tp/l2tp-ipsec-delete.lua  ${valx1}
		}
	done
	
}

pptp_client_delete_rule() {                                        
    local section=${1}
	config_get valx ${section} outif
	
    for element in $interfaces; do  
		[ "${element}" = "${valx}" ] && {
			delifs="${delifs}${delifs:+,}`config_get ${section} tunnelname`"
			/lib/pptp/pptp-client-delete.sh `config_get ${section} confname` 1
			uci delete pptp-client.${section}
		}
	done
	
}

pptp_server_delete_rule() {                                        
    local section=${1}
	config_get valx ${section} bindif
	
    for element in $interfaces; do  
		[ "${element}" = "${valx}" ] && {
			/lib/pptp/delete-service.sh `config_get ${section} server`
			uci delete pptp-server.${section}
		}
	done
	
}


case ${ACTION} in
	DELETE)
		[ -n "${interfaces}" ] && {   
		    interfaces=${interfaces//,/ } 
			
			config_load l2tp-client
			config_foreach l2tp_client_delete_rule lac
			uci commit l2tp-client
			
			config_load pptp-client
			config_foreach pptp_client_delete_rule pnc
			uci commit pptp-client
			
			config_load l2tp-server
			config_foreach l2tp_server_delete_rule lns
			uci commit l2tp-server
			
			config_load pptp-server
			config_foreach pptp_server_delete_rule pns
			uci commit pptp-server
			
			/etc/init.d/zone restart
			[ -n "${delifs}" ] && env -i ACTION=DELETE interfaces=${delifs} /sbin/hotplug-call vpnhook 
		}
	;;
	ADD)
	;;
	*)
	;;
esac