#!/bin/sh 
#/etc/rc.common
# Copyright(c) 2011-2015 Shenzhen TP-LINK Technologies Co.Ltd.
# file    98-ipsec.sh 
# brief   This script is executed as part of the hotplug event, triggered by various scripts when the wan is deleted.
# author   Yang xiaoqiang
# version  1.0.0
# date     08June15
# histry   arg 1.0.0, 08June15, Yang xiaoqiang, Create the file. 

. /lib/functions.sh
. /lib/functions/network.sh
. /lib/zone/zone_api.sh
include /lib/network

UCI_TO_BE_CHECKED_FILE=ipsec
UCI_TO_BE_CHECK_SECTION=connection
local count			
local to_be_deleted_tunnel=""
let index=0


to_be_delete_or_not(){
	local interfaces=${2}	
	config_get local_binding $1 local_binding
	config_get local_binding_type $1 local_binding_type
	
	if [ "${local_binding_type}" = "if_name" ] 
	then 		
		interfaces=${interfaces//,/ } 
		local flag
		let flag=0
		for element in $interfaces   
		do  
			
			if [ "${local_binding}" = "${element}" ]
			then 
				let flag=1
			fi
		done 
		if [ $flag -eq 1 ] 
		then 
			
			if [ -z ${to_be_deleted_tunnel} ] 
			then				
				to_be_deleted_tunnel="${index}"
			else 
				to_be_deleted_tunnel="${to_be_deleted_tunnel},${index}"
			fi 
			
		fi 
	fi 
	let index=${index}+1
}
		#interfaces="GE1"
		#[ -n "${interfaces}" ] && {
		#	config_foreach to_be_delete_or_not ${UCI_TO_BE_CHECK_SECTION} ${interfaces} 			
		#	echo "index=${index} to_be_deleted_tunnel=${to_be_deleted_tunnel}"
		#	lua /lib/ipsec/ipsec_utility.lua "del" ${to_be_deleted_tunnel}
		#}

case ${ACTION} in
	DELETE)
		[ -n "${interfaces}" ] && {
			config_load ${UCI_TO_BE_CHECKED_FILE}
			config_foreach to_be_delete_or_not ${UCI_TO_BE_CHECK_SECTION} ${interfaces} 			
			#echo "index=${index} to_be_deleted_tunnel=${to_be_deleted_tunnel}"
			lua /usr/lib/lua/ipsec/ipsec_utility.lua "del" ${to_be_deleted_tunnel}
		}
	;;
	ADD)
	;;
	*)
	;;
esac
