local sys  = require "luci.sys"
local json = require 'luci.json'
local utl = require "luci.util"
local dbg  = require 'luci.tools.debug'
local form = require "luci.tools.form"
local uci  = require "luci.model.uci"
local error_print = require "luci.tools.error_print"
--local snmp = require 'luci.controller.admin.snmp'
local accesslist = require 'luci.controller.admin.access_ctl'
local ipgroup = require "luci.controller.admin.ipgroup"
local uci_r = uci.cursor()
--缓存UCI目录，才cli进程中创建
local CLI_CFG_PATH = "/tmp/access_config"
local CFG_PATH = "/etc/config"

function get_ipgroup()
	local list = ipgroup.get_ipgroup_list_common()
	--dbg.dumptable(list)
	local list_ipGroup = {}
	for k,v in ipairs(list) do
		table.insert(list_ipGroup,v.name)
	end
	return list_ipGroup
end

function get_lan_list()
	local lan_list = {}
	uci_r:foreach("vnetwork","vinterface",
		function(section)
			if uci_r:get("vnetwork", section[".name"], "name") then
				table.insert(lan_list,uci_r:get("vnetwork", section[".name"], "name"))
			end
		end
	)
	return lan_list
end

local lan_list = get_lan_list()
local ip_list = get_ipgroup()

io.write("If direciton chooses LAN-LAN: "..table.concat(lan_list, ",")..", else: "..table.concat(ip_list, ","))