local sys  = require "luci.sys"
local json = require 'luci.json'
local utl = require "luci.util"
local DBG  = require ('luci.tools.debug')
local form = require "luci.tools.form"
local uci  = require "luci.model.uci"
local switch = require "luci.controller.admin.switch"


local uci_r = uci.cursor()

local CFG_PATH = "/etc/config"

function show_interface_status(cmd)
	local result = "SUCCESS"
	local temp_data ={}
	local phy_type=""
	if cmd ~= "show interface status" then
		return "Failed"
	end
	DBG.print_tty("-------------------------------------------------------------------------------------------------------");
	--打印表头
	DBG.print_tty(string.format("%-15s%-15s%-15s%-15s%-15s%-15s%-15s",
	"Port","Status","Speed","Duplex","FlowCtrl","Mtu","Active-Medium"))

	DBG.print_tty(string.format("%-15s%-15s%-15s%-15s%-15s%-15s%-15s",
	"----","----","----","----","----","----","----"))
	--读取默认参数配置
	all_states = switch.get_state()
	for i,v in ipairs(all_states) do
		temp_data = v
		
		
		if temp_data.state == "connected" then
			temp_data.state = "LinkUp"
		else
			temp_data.state = "LinkDown"
		end
		if temp_data.speed == "---" then
			temp_data.speed = "N/A"
		end
		if temp_data.duplex == "---" then
			temp_data.duplex = "N/A"
		end
		if temp_data.flowcontrol == "---" then
			temp_data.flowcontrol = "N/A"
		elseif temp_data.flowcontrol == "off" then
			temp_data.flowcontrol = "Disable"
		else
			temp_data.flowcontrol = "Enable"
		end
		
		DBG.print_tty(string.format("port%-11s%-15s%-15s%-15s%-15s%-15s%-15s",
		temp_data.port,
		temp_data.state,
		temp_data.speed,
		temp_data.duplex,
		temp_data.flowcontrol,
		"1518",
		temp_data.phy_type))
		
	end
	DBG.print_tty("-------------------------------------------------------------------------------------------------------");
	return result
end


-- 脚本入口
local cmd = arg[1]

local result = "SUCCESS"

result = show_interface_status(cmd)

io.stdout:write(result)
