local sys  = require "luci.sys"
local json = require 'luci.json'
local utl = require "luci.util"
local dbg  = require ('luci.tools.debug')
local form = require "luci.tools.form"
local uci  = require "luci.model.uci"
local json_m = require "luci.json"
local time_mngt = require 'luci.controller.admin.time_mngt'
local error_print = require 'luci.tools.error_print'
local uci_r = uci.cursor()
local CFG_PATH = "/etc/config"
uci_r:set_confdir(CFG_PATH)

-------------------------------------------------------------------show
function show_timeRange()
    local result = "SUCCESS"
    local rules = {}
    uci_r:foreach("time_mngt", "entry",
        function(section)
            rules[#rules + 1] = uci_r:get_all("time_mngt", section[".name"])
        end
    )
    for k, rt in ipairs(rules) do
        dbg.print_tty("---------------------------------------------------------------------")
        rt_slots_jsdecode = json.decode(rt.slots)
        if rt.entry_name ~= nil then
            dbg.print_tty("Time Range Name:    "..rt.entry_name)
        end
        if rt.time_mode == "input" then
            dbg.print_tty("Time Settings:      ".."Manual")
        elseif rt.time_mode == "calendar" then
            dbg.print_tty("Time Settings:      ".."Working Calendar")
        end
        if rt.type ~= nil then
            dbg.print_tty("type:               "..rt.type)
        end
        local day = {"mon","tue","wed","thu","fri","sat","sun"}
        local print_day = {}
        if rt.slots ~= "{}" and rt.slots ~= nil then
            local show_day = ""
            local show_time = ""
            local show_time_flag = 0 --计数，已拼接时间段则置1
            for k,v in ipairs(day) do
                if rt_slots_jsdecode[v] ~= nil then
                    table.insert(print_day,k)
                    if show_time_flag == 0 then
                        for i = 1,#rt_slots_jsdecode[v] do
                            if show_time == "" then
                                show_time = show_time..rt_slots_jsdecode[v][i][1].."-"..rt_slots_jsdecode[v][i][2]
                            else
                                show_time = show_time..","..rt_slots_jsdecode[v][i][1].."-"..rt_slots_jsdecode[v][i][2]
                            end
                        end
                        show_time_flag = 1
                    end
                end
            end
            for i = 1,(#print_day) do
                if i == (#print_day) then
                    if print_day[i] == 1 then
                        show_day = show_day.."mon"
                    elseif print_day[i] == 2 then
                        show_day = show_day.."tue"
                    elseif print_day[i] == 3 then
                        show_day = show_day.."wed"
                    elseif print_day[i] == 4 then
                        show_day = show_day.."thu"
                    elseif print_day[i] == 5 then
                        show_day = show_day.."fri"
                    elseif print_day[i] == 6 then
                        show_day = show_day.."sat"
                    elseif print_day[i] == 7 then
                        show_day = show_day.."sun"
                    end
                else
                    if print_day[i] == 1 then
                        show_day = show_day.."mon"..","
                    elseif print_day[i] == 2 then
                        show_day = show_day.."tue"..","
                    elseif print_day[i] == 3 then
                        show_day = show_day.."wed"..","
                    elseif print_day[i] == 4 then
                        show_day = show_day.."thu"..","
                    elseif print_day[i] == 5 then
                        show_day = show_day.."fri"..","
                    elseif print_day[i] == 6 then
                        show_day = show_day.."sat"..","
                    elseif print_day[i] == 7 then
                        show_day = show_day.."sun"..","
                    end
                end
            end
            dbg.print_tty("day:                "..show_day)
            dbg.print_tty("time:               "..show_time)
        end
        if rt.note ~= nil then
            dbg.print_tty("note:               "..rt.note)
        end
    end
    dbg.print_tty("---------------------------------------------------------------------")
    return result
end

string.split = function(r,p)
    local rt = {}
    string.gsub(r,'[^'..p..']+',function(w) table.insert(rt,w) end )
    return rt
end
---------------------------------------------------------------------add
--当输入的week-date包含天数段时用此函数做拆分补充(eg:2-6 ---> 2，3，4，5，6)
function choose_week_day(week_list)
    local week_day = {} -- 最终包含所有正确天数的数组
    local week_day1 = {} -- week_list被拆分后的首、尾天
    for i=1,#week_list do
        week_day1[i] = string.split(week_list[i],'-')
        if #(week_day1[i]) > 1 then   --#week_day1[i] > 2 ----> data这一个段数有被缩略的星期，例如2-5/1-3/...
            local num_of_days -- 被缩略的天数
            num_of_days = week_day1[i][2]-week_day1[i][1]
            if num_of_days == 1 then
                week_day1[i] = {week_day1[i][1]+1-1,week_day1[i][1]+1}
            elseif num_of_days == 2 then
                week_day1[i] = {week_day1[i][1]+1-1,week_day1[i][1]+1,week_day1[i][1]+2}
            elseif num_of_days == 3 then
                week_day1[i] = {week_day1[i][1]+1-1,week_day1[i][1]+1,week_day1[i][1]+2,week_day1[i][1]+3}
            elseif num_of_days == 4 then
                week_day1[i] = {week_day1[i][1]+1-1,week_day1[i][1]+1,week_day1[i][1]+2,week_day1[i][1]+3,week_day1[i][1]+4}
            elseif num_of_days == 5 then
                week_day1[i] = {week_day1[i][1]+1-1,week_day1[i][1]+1,week_day1[i][1]+2,week_day1[i][1]+3,week_day1[i][1]+4,week_day1[i][1]+5}
            elseif num_of_days == 6 then
                week_day1[i] = {week_day1[i][1]+1-1,week_day1[i][1]+1,week_day1[i][1]+2,week_day1[i][1]+3,week_day1[i][1]+4,week_day1[i][1]+5,week_day1[i][1]+6}
            end
        elseif #(week_day1[i]) == 1 then
            week_day1[i] = {week_day1[i][1]+1-1}
        end
    end
    local actual_num_of_days = 1 -- 辅助存储week_day,即week_day下标
    for k,v in ipairs(week_day1) do
        for i = 1,(#(week_day1[k])) do
            week_day[actual_num_of_days] = week_day1[k][i]
            actual_num_of_days = actual_num_of_days + 1
        end
    end
    return week_day
end
--判断一个时间段是否合法 若后时间节点早于前时间节点(eg:15:00-12:00)则返回FAILED
--fir_time为某时间段第一个时间节点 sec_time为某时间段第二个时间节点
function check_time_slice(fir_time,sec_time)
    local result = "SUCCESS"
    local fir_time_num = string.split(fir_time,':')
    local sec_time_num = string.split(sec_time,':')
    fir_time_num_hour = tonumber(fir_time_num[1])
    fir_time_num_minute = tonumber(fir_time_num[2])
    sec_time_num_hour = tonumber(sec_time_num[1])
    sec_time_num_minute = tonumber(sec_time_num[2])
    if (fir_time_num_hour > sec_time_num_hour) or ((fir_time_num_hour == sec_time_num_hour) and (fir_time_num_minute >= sec_time_num_minute)) then
        dbg.print_tty("Error: The starting time slice should not be greater than the ending time slice.")
        result = "FAILED"
    end
    return fir_time,sec_time,result
end
--对比两个时间段之间是否有重合,有重合则返回FAILED 无重合则返回SUCCESS 若两者可合为一个时间段则返回EQUAL
function check_double_time_slice(time_slice_point_prior,time_slice_point_latter)
    local result = "SUCCESS"
    local time_slice_prior_start = (string.split(time_slice_point_prior[1],':'))
    local time_slice_prior_end = (string.split(time_slice_point_prior[2],':'))
    local time_slice_latter_start = (string.split(time_slice_point_latter[1],':'))
    local time_slice_latter_end = (string.split(time_slice_point_latter[2],':'))
    if (time_slice_latter_end[1] < time_slice_prior_start[1]) or ((time_slice_latter_end[1] == time_slice_prior_start[1]) and (time_slice_latter_end[2] < time_slice_prior_start[2])) then
        result = "SUCCESS"
        return time_slice_point_latter,time_slice_point_prior,result
    elseif ((time_slice_latter_start[1] == time_slice_prior_end[1]) and (time_slice_latter_start[2] == time_slice_prior_end[2])) then
        result = "EQUAL"
        return time_slice_point_prior,time_slice_point_latter,result
    elseif ((time_slice_latter_end[1] == time_slice_prior_start[1]) and (time_slice_latter_end[2] == time_slice_prior_start[2])) then
        result = "EQUAL"
        return time_slice_point_latter,time_slice_point_prior,result
    elseif (time_slice_latter_start[1] > time_slice_prior_end[1]) or ((time_slice_latter_start[1] == time_slice_prior_end[1]) and (time_slice_latter_start[2] > time_slice_prior_end[2])) then
        result = "SUCCESS"
        return time_slice_point_prior,time_slice_point_latter,result
    else
        result = "FAILED"
        return time_slice_point_prior,time_slice_point_latter,result
    end
end
function add_timeRangeName(entry_name,week,slots)
    local result = "SUCCESS"
    local http_form = {}
    --判断将设置条目是否已存在
    local rules = {}
    uci_r:foreach("time_mngt", "entry",
        function(section)
            rules[#rules + 1] = uci_r:get_all("time_mngt", section[".name"])
        end
    )
    for k, rt in ipairs(rules) do
        if entry_name == rt.entry_name then
        dbg.print_tty("Error: The time range name is already occupied.")
        return "FAILED"
        end
    end

    --spilt time-slice 将设置传入的时间段slots进行处理--
    local time_slice_list = string.split(slots,',') --用户输入的week_date按“，”分割所得的时间段
    local time_slice_point = {} --用户输入的每个时间段按“-”分割所得的两个时间点
    -- for four(optional) time-slice: 判断输入各time-slice是否合法或需要合并---
    for i = #(time_slice_list),1,-1 do
        time_slice_point[i] = string.split(time_slice_list[i],'-')
        time_slice_point[i][1],time_slice_point[i][2],result = check_time_slice(time_slice_point[i][1],time_slice_point[i][2])
        if result ==  "FAILED" then
            return "FAILED"
        end
    end
    for i = #(time_slice_list),1,-1 do
        for j = i-1,1,-1 do
            if (time_slice_point[i]) and (#(time_slice_point[i])) ~= 0 then
                time_slice_point[j],time_slice_point[i],flag = check_double_time_slice(time_slice_point[j],time_slice_point[i])
                if flag == "EQUAL" then
                    time_slice_point[j][2] = time_slice_point[i][2]
                    time_slice_point[i] = {}
                end
            end
        end
    end
    for i = #(time_slice_list),1,-1 do
        if (time_slice_point[i]) and (#(time_slice_point[i])) ~= 0 then
            for j = i-1,1,-1 do
                if (time_slice_point[j]) and (#(time_slice_point[j])) ~= 0 then
                    time_slice_point[j],time_slice_point[i],flag = check_double_time_slice(time_slice_point[j],time_slice_point[i])
                    if flag == "FAILED" then
                        dbg.print_tty("Error: The time slices cannot overlap with each other.")
                        return "FAILED"
                    end
                end
            end
        end
    end
    -- for time-slice json 将所有输入的时间段拼接为json格式
    time_slice_json = "[\""..time_slice_point[1][1].."\",\""..time_slice_point[1][2].."\"]" -- 必定存在的第一个时间段
    --拼接可能存在的2、3、4个时间段
    for i = 2,(#time_slice_point) do
        if (#(time_slice_point[i])) ~= 0 then
            time_slice_json = time_slice_json..",[\""..time_slice_point[i][1].."\",\""..time_slice_point[i][2].."\"]"
        end
    end
    -- for time-slice json end --
    -------------------将设置传入的天数week进行处理
    local function get_week_end(week)
        local week_end = "{" -- 拼接获得json格式的输入
        local week_list = string.split(week,',') -- 按“，”分割用户输入的week-date
        week_day = choose_week_day(week_list) -- 包含所有的正确天数
        for i=1,#week_day do
            if (tonumber(week_day[i]) > 7) or (tonumber(week_day[i]) < 1) then
                dbg.print_tty("Error: Invalid week date. Supports sequential input from 1 to 7, and supports shorthand, such as 3-5.")
                return "FAILED"
            end
            if (#week_day) > 1 then -- 查看是否存在重复输入的天数，存在则返回FAILED
                for k=i+1,#week_day do
                    if (week_day[i]+1-1) >= (week_day[k]+1-1) then
                        dbg.print_tty("Error: Invalid week date. Supports sequential input from 1 to 7, and supports shorthand, such as 3-5.")
                        return "FAILED"
                    end
                end
            end
            if i == 1 then
                if week_day[i] == 1 then
                    week_end = week_end.."\"mon\":["..time_slice_json.."]"
                elseif week_day[i] == 2 then
                    week_end = week_end.."\"tue\":["..time_slice_json.."]"
                elseif week_day[i] == 3 then
                    week_end = week_end.."\"wed\":["..time_slice_json.."]"
                elseif week_day[i] == 4 then
                    week_end = week_end.."\"thu\":["..time_slice_json.."]"
                elseif week_day[i] == 5 then
                    week_end = week_end.."\"fri\":["..time_slice_json.."]"
                elseif week_day[i] == 6 then
                    week_end = week_end.."\"sat\":["..time_slice_json.."]"
                elseif week_day[i] == 7 then
                    week_end = week_end.."\"sun\":["..time_slice_json.."]"
                end
            else
                if week_day[i] == 1 then
                    week_end = week_end..",".."\"mon\":["..time_slice_json.."]"
                elseif week_day[i] == 2 then
                    week_end = week_end..",".."\"tue\":["..time_slice_json.."]"
                elseif week_day[i] == 3 then
                    week_end = week_end..",".."\"wed\":["..time_slice_json.."]"
                elseif week_day[i] == 4 then
                    week_end = week_end..",".."\"thu\":["..time_slice_json.."]"
                elseif week_day[i] == 5 then
                    week_end = week_end..",".."\"fri\":["..time_slice_json.."]"
                elseif week_day[i] == 6 then
                    week_end = week_end..",".."\"sat\":["..time_slice_json.."]"
                elseif week_day[i] == 7 then
                    week_end = week_end..",".."\"sun\":["..time_slice_json.."]"
                end
            end
        end
        --for http_form>slot>week_end:
        week_end = week_end.."}"
        return week_end
    end
    local week_end = get_week_end(week)
    if week_end == "FAILED" then
        return "FAILED"
    end
    --for http_form:
    http_form.data = json.encode(
    {
        ["method"] = "add",
        ["params"] =
        {
            ["new"] = {
                ["entry_name"] = entry_name,
                ["time_mode"] = "input",
                ["note"] = "",
                ["slots"] = week_end,
            }
        }
    })
    http_form.form = "timeobj"
    ret = time_mngt.dispatch(http_form)
    if (not ret) or (ret.error_code ~= "0") then
        dbg.print_tty(error_print.check_error(ret))
        return "FAILED"
    end
    return result
end
-------------------------------------------------------------------del
function del_timeRangeName(entry_name)
    local result = "SUCCESS"
    local index = 0
    local delete_index = 0
    uci_r:foreach("time_mngt", "entry",--循环
    function(section)
        if (section.entry_name == entry_name) then
            delete_index = index
        end
        index = index + 1
    end
)
    if delete_index == 0 then
        dbg.print_tty("Error: The entry does not exist.")
        return "FAILED"
    end
    local http_form = {}
    http_form.form = "timeobj"
    http_form.data = json.encode(
    {
        ["method"] = "delete",
        ["params"] =
        {
            ["key"] = "key-"..delete_index,
            ["index"] = tostring(delete_index)
        }
    }
    )
    ret = time_mngt.dispatch(http_form)
    if (not ret) or (ret.error_code ~= "0") then
        dbg.print_tty(error_print.check_error(ret))
        return "FAILED"
    end
    return result
end
-------------------------------------------------------------------cli cmd
if arg[1] == "time-range week-date time-slice" then
    local entry_name = arg[2]
    local week = arg[3]
    local slots = arg[4]
    if arg[5] ~= nil then
        slots = slots..","..arg[5]
    end
    if arg[6] ~= nil then
        slots = slots..","..arg[6]
    end
    if arg[7] ~= nil then
        slots = slots..","..arg[7]
    end
    
    result = add_timeRangeName(entry_name,week,slots)
elseif arg[1] == "no time-range" then
    local entry_name = arg[2]
    result = del_timeRangeName(entry_name)
elseif arg[1] == "show time-range" then
    result = show_timeRange()
end
io.stdout:write(result)