local dbg = require "luci.tools.debug"
local uci = require "luci.model.uci"
local ip  = require "luci.ip"
local sys = require "luci.sys"
local utl = require "luci.util"

local uci_r = uci.cursor()

local option_addr ={"dhcp_option7","dhcp_option9","dhcp_option16","dhcp_option21","dhcp_option28","dhcp_option32",
"dhcp_option33","dhcp_option41","dhcp_option44","dhcp_option45","dhcp_option48","dhcp_option49",
"dhcp_option50","dhcp_option54","dhcp_option65","dhcp_option68","dhcp_option69","dhcp_option70","dhcp_option71","dhcp_option74"}
local option_internal ={"dhcp_option43","dhcp_option52","dhcp_option53","dhcp_option55","dhcp_option56","dhcp_option57","dhcp_option61","dhcp_option81","dhcp_option82","dhcp_option118"}

function showAll(args)
    for key,val in pairs(args) do
        print(val)
    end
end

function get_option(network)
    local options = uci_r:get_all("vnetwork",network)
    local all = {}
    local flag=0
    for index , val in pairs(options) do
        flag=0
        local ret = string.match(index,"dhcp_option")
        if  ret  then
            for i,option in pairs(option_addr) do
                if tostring(option) == tostring(index) then
                    flag=1
                    if ip.IPv4(val) then
                        all[#all+1] = index
                    end
                    break
                end
            end
            for i,option in pairs(option_internal) do
                if tostring(option) == tostring(index) then
                    flag=1
                    if not tonumber(val,10) then
                        all[#all+1] = index
                    end
                    break
                end
            end
            if flag==0 then
                all[#all+1] = index
            end
        end
    end
    return all
end

if #arg < 1 then
    return false
end

local network = arg[1]
local ret = get_option(network)
showAll(ret)
return ret


