#!/bin/sh
local rootkey="/etc/unbound/root.key"
local log="/tmp/dnssecquery.log"
local tmp_conf="/tmp/dnssecquery.conf"
local conf="/etc/unbound/unbound.conf.back"
local domain=$1
local version=$2
local servers=$3 #8.8.8.8,9.9.9.9

[ -f "$log" ] && rm $log
[ -f "$tmp_conf" ] && rm $tmp_conf
echo $domain,$version,$servers

[ -z "$domain" ] || [ -z "$version" ] || [ -z "$servers" ] && exit 0

cp $conf $tmp_conf
servers=`echo $servers | sed 's/,/ /g'`
for server in $servers
do
    sed -i "/.*forward-zone*/a\        forward-addr: ${server}" $tmp_conf
done

sed -i '/chroot/d' $tmp_conf
sed -i '/directory/d' $tmp_conf

unbound-anchor -a $rootkey
local type="TYPE1"
[ "$version" = "6" ] && type="TYPE28"
local result=`unbound-host -C $tmp_conf -t $type -f $rootkey -v $domain`
echo $result
local loop=`echo $result|grep address`
while [ -n "$loop" ]
do
    result=${result#*address}
    #echo result $result
    status=`echo $result|cut -d  '('  -f2|cut -d  ')'  -f1`
    ip=`echo ${result%%"(${status}"*} | xargs`
    #status=`echo $result | cut -d' ' -f2`
    #status=`echo $status | sed 's/(//g;s/)//g'`
    #status=`echo $status | sed 's/(//g;s/)//g'`
    [ -n "$ip" ] && [ -n "$status" ] && {
        echo $ip $status >> $log
    }
    loop=`echo $result|grep address`
    #echo loop $loop
done
[ -f "$log" ] && {
    echo 1
}
[ ! -f "$log" ] &&{
    echo 0
}