#!/bin/sh

. /lib/dnsproxy/api.sh

local dnssec_switch=`uci get dnsproxySecurity.dnsproxy.dnssec_switch`
local dot_switch=`uci get dnsproxySecurity.dnsproxy.dot_switch`
local doh_switch=`uci get dnsproxySecurity.dnsproxy.doh_switch`

{
    flock -x 172
    if [ ! -f "/var/unbound/unbound.conf" ] ;then
        echo "dnsproxy: no conf file, exit!" >/dev/console
        flock -u 172
        return
    fi
    if [ "$1" == "flush_cache" ];then
        flush_cache
    elif [ "$1" == "dump_v4" ];then
        dump_v4
    elif [ "$1" == "dump_v6" ];then
        dump_v6
    elif [ "$1" == "update_cache" ];then
        update_cache "$2" "$3"
    elif [ "$1" == "reload" ];then
        dns_reload
    fi

    [ "$dnssec_switch" = "on" ] || [ "$dot_switch" = "on" ] || [ "$doh_switch" = "on" ] && flock -u 172 && return

    if [ "$1" == "add" ] ;then
        shift
        add_dns_server "$@"
    elif [ "$1" == "delete" ] ;then
        shift
        del_dns_server "$@"
    elif [ "$1" == "delete_all" ];then
        del_all_dns_server
    fi

    flock -u 172
} 172<>/var/unbound/unbound.lock
