. /lib/gre/gre_common.sh

case $PLUTO_VERB in
	up-*)
		action="up";;
	down-*)
		action="down";;
	*)
		exit 1;;
esac

gre_ipsec_prefix="X_gre_"

id=${PLUTO_CONNECTION##${gre_ipsec_prefix}}

TUNNEL_NAME=$gre_ipsec_prefix$id
WAN_NAME=`uci get gre.$id.bindif`
remote_ip=`uci get gre.$id.remote_ip`
local_subnet=`uci get gre.$id.local_subnet`
remote_subnet=`uci get gre.$id.remote_subnet`
local_gre_ip=`uci get gre.$id.local_gre_ip`
remote_gre_ip=`uci get gre.$id.remote_gre_ip`
tunnel_status=`uci get gre.$id.status`
ipsec_encryption=`uci get gre.$id.ipsec_encryption`

if [ "${action}" = "up" ]; then
	gre_create $TUNNEL_NAME $WAN_NAME $remote_ip $local_subnet $remote_subnet $local_gre_ip $remote_gre_ip $ipsec_encryption
	set_gre_link $TUNNEL_NAME $tunnel_status $remote_subnet $local_gre_ip
    exit 0
fi

if [ "${action}" = "down" ]; then
	gre_delete $TUNNEL_NAME $remote_ip 
    exit 0
fi






