#!/bin/sh 
#/etc/rc.common
# Copyright(c) 2011-2015 Shenzhen TP-LINK Technologies Co.Ltd.
# file    ipsec_failover_process.sh 
# brief     
# author   Gao Jie
# version  1.0.0
# date     11Sep22
# histry   arg 1.0.0, 11Sep22, Gao Jie, Create the file. 

# $1 operation: add | del
# $2 group_name: 
# $3 pri_conn
# $4 sec_conn

operation=$1
group_name=$2
##echo "operation: $1 group_name: $2" > /dev/console

PROCESS_FAILOVER_="/usr/lib/lua/ipsec/ipsec_failover_process.lua"
AUTO_FAILBACK_="/usr/lib/lua/ipsec/ipsec_auto_failback.lua"
DETECT_DIR="/tmp/failover_detect"


if [ "$operation" = "add" ]; then
    [ ! -d "${DETECT_DIR}/$2" ] && mkdir "${DETECT_DIR}/$2"
    [ ! -f "${DETECT_DIR}/$2/ping" ] && touch "${DETECT_DIR}/$2/ping"
    [ ! -f "${DETECT_DIR}/$2/read_ipsec_none_cnt" ] && touch "${DETECT_DIR}/$2/read_ipsec_none_cnt"
    [ ! -f "${DETECT_DIR}/$2/read_ipsec_none_cnt_1" ] && touch "${DETECT_DIR}/$2/read_ipsec_none_cnt_1"
    lua /usr/lib/lua/ipsec/ipsec_failover_process.lua $1 $2
fi

if [ "$operation" = "del" ]; then
    ##kill failover process
    FAILOVER_PIDS=`ps -w | grep "${PROCESS_FAILOVER_}" | grep "${group_name}" | grep -v grep | awk '{print $1}'`
    for PID in $FAILOVER_PIDS 
    do
        ##echo "failover PID: $PID" > /dev/console
        [ -n "$PID" ] && kill -9 $PID
    done
    
    ##kill auto_failback process
    AUTO_PIDS=`ps -w | grep "${AUTO_FAILBACK_}" | grep "${group_name}" | grep -v grep | awk '{print $1}'`
    for PID in $AUTO_PIDS 
    do
        ##echo "auto PID: $PID" > /dev/console
        [ -n "$PID" ] && kill -9 $PID
    done
    ##clean group backup list
    ##echo "lua /usr/lib/lua/ipsec/ipsec_failover_process.lua $1 $2 $3 $4 " > /dev/console 
    lua /usr/lib/lua/ipsec/ipsec_failover_process.lua $1 $2 $3 $4
    [ -f "${DETECT_DIR}/$2" ] && rm -R "${DETECT_DIR}/$2"
fi