#!/bin/sh /etc/rc.common
# Copyright(c) 2011-2015 Shenzhen TP-LINK Technologies Co.Ltd.
# file     ipv6group core.sh
# brief    
# author   Chen chen
# version  1.0.0
# date     11June15
# histry   arg 1.0.0, 08June15, Chen chen, Create the file.

IPV6GRP_LIBDIR=${IPV6GRP_LIBDIR:-/lib/ipv6group}
. $IPV6GRP_LIBDIR/config.sh

ipv6group_start() 
{
	ipv6group_init

	
	echo "load ipv6group "
	ipv6group_load
	ipv6group_check_modify

	echo "load Me Set"
	ipv6group_load_default_ifaces_set
	
	[ -x /usr/sbin/conntrack ] && conntrack -D -m 0x1000
	return 0
}

ipv6group_init()
{
	[ -z "$IPV6GROUP_INITIALIZED" ] || return 0

	for file in $IPV6GRP_LIBDIR/core_*.sh; do
		. $file
	done
	IPV6GROUP_INITIALIZED=1
	return 0
}

ipv6group_stop()
{
	echo ""
}

ipv6group_restart()
{
	ipv6group_stop
	ipv6group_start
}

ipv6group_reload()
{
	ipv6group_restart
}

ipv6group_interface_event()
{
	ipv6group_load_default_ifaces_set
}
