#!/bin/sh /etc/rc.common
# Copyright(c) 2011-2015 Shenzhen TP-LINK Technologies Co.Ltd.
# file     ipv6group core.sh
# brief    
# author   Wang Wenjing
# version  1.0.0
# date     21July22
# histry   arg 1.0.0, 21July22, Wang Wenjing, Create the file.

. /lib/zone/zone_api.sh
. /lib/functions/network.sh

ipv6group_load()
{
	{
		flock -w 30 166
		lua /usr/lib/lua/ipv6group/ipv6group_reload.lua
	} 166<>/tmp/ipv6group_lock
}

ipv6group_check_modify()
{

    while read root_group
    do
		
        local index=`ipset list "ipv6_$root_group" | grep -n Members`
	index=${index//:*/}
	ipset list "ipv6_$root_group" | tail -n +$index > "/tmp/ipset_v6_new_content_$root_group" 
        local old_content="/tmp/ipset_v6_old_content_${root_group}"
        local new_content="/tmp/ipset_v6_new_content_${root_group}"       
        if [ -e "$old_content" ]
            then
            local is_update=`cmp "$old_content" "$new_content"`
            if [ "$is_update" != "" ]
                then
                echo "hotplug-call $root_group update"
                export action="update"
                export update_group="$root_group"
                env -i ACTION=update group_name="$root_group" /sbin/hotplug-call ipv6group
            fi
        fi 
        rm "$old_content"
        rm "$new_content"
    done < /tmp/ipv6group_name.tmp   
}

ipv6group_load_default_ifaces_set()
{
	anete ipset create ipv6_Me hash:ip family inet6 -exist
	anete ipset flush ipv6_Me
	device6=$(zone_get_wan_devices "LAN")
	ip6addrMe=$(ip -6 address show $device6 | grep inet6 | awk '{print $2}' | cut -d'/' -f1)
	anete ipset add ipv6_Me $ip6addrMe -exist

	#ipset create IPGROUP_LAN hash:net -exist
	#ipset flush IPGROUP_LAN
	#ifaces=$(zone_get_effect_ifaces "LAN")

	#for iface in $ifaces;do
	#	network_get_ipaddr if_ipaddr "$iface"
	#	if_ipaddr=${if_ipaddr%[0-9]}
	#	if_ipaddr=$if_ipaddr"0"
    #
	#	network_get_subnet if_mask "$iface"
	#	if_mask=${if_mask#*/}
	#				
	#	ipset add IPGROUP_LAN $if_ipaddr/$if_mask -exist
					
	#done
}


