#!/bin/sh 
#/etc/rc.common
# Copyright(c) 2011-2015 Shenzhen TP-LINK Technologies Co.Ltd.
# file   ldap_query 
# brief  
# author   Wang Wenjing
# version  1.0.0
# date     03Aug22
# histry   arg 1.0.0, 03Aug22, Wang Wenjing, Create the file. 

. /lib/functions.sh
. /lib/ldap-tplink/api.sh

	UCI_LDAP_QUERY_RESULT=ldap_query_result
	
	USAGE(){
		echo "Uage: ldap_query.sh <User-Name> <Password> <key>"		
		echo ""
		echo "For example: "
		echo "	./ldap_query.sh admin 1234567 1"
	}

	if [ $# -ne 3 ]
	then	
		USAGE
		exit 0
	fi 
        local key=$3
        local uid=$1
        local passwd=$2

        if [ ! -e /etc/config/${UCI_LDAP_QUERY_RESULT} ]
        then
            touch /etc/config/${UCI_LDAP_QUERY_RESULT}
        fi
        local status=$(uci get ${UCI_LDAP_QUERY_RESULT}.${key}.status)
        test "${status}"

        if [ $? -eq 1 ]
        then
                uci set ${UCI_LDAP_QUERY_RESULT}.${key}="LDAP_QUERY"
                uci set ${UCI_LDAP_QUERY_RESULT}.${key}."status"="waiting"
                uci set ${UCI_LDAP_QUERY_RESULT}.${key}."timeout"=""
                uci commit ${UCI_LDAP_QUERY_RESULT}
        fi

	local ret=""
	ret=$(auth "$uid" "$passwd")
	if [ $ret != "success" ];then
		echo "Authentication failure" >/dev/console
		uci set ${UCI_LDAP_QUERY_RESULT}.${key}."status"="fail"
        else
		echo "Authentication success" >/dev/console
		local cmd_Session_Timeout_start="'BEGIN {match(\"${ret}\",\"Session-Timeout                  =\");print RSTART}'"	
		local ret_Session_Timeout_start=$(eval awk ${cmd_Session_Timeout_start})
		
		local cmd_Session_Timeout_length="'BEGIN {match(\"${ret}\",\"Session-Timeout                  =\");print RLENGTH}'"	
		local ret_Session_Timeout_length=$(eval awk ${cmd_Session_Timeout_length})
		
		test "${ret_Session_Timeout_start}" 
		if [ $? -ne 1 -a ${ret_Session_Timeout_length} -ne -1 ]
		then 
			local Session_Timeout_val_pos_start=${ret_Session_Timeout_start}+${ret_Session_Timeout_length}+1
			
			local cmd_Session_Timeout_remain="'BEGIN {print substr(\"${ret}\",${Session_Timeout_val_pos_start});}'"
			local ret_Session_Timeout_remain=$(eval awk ${cmd_Session_Timeout_remain})	
			
			local cmd_Session_Timeout_end="'BEGIN {match(\"${ret_Session_Timeout_remain}\",\" \");print RSTART}'"
			local ret_Session_Timeout_end=$(eval awk ${cmd_Session_Timeout_end})	
		
			local cmd_Session_Timeout_val
			local ret_Session_Timeout_val
			
			if [ ${ret_Session_Timeout_end} -ne 0 ]
			then 
				cmd_Session_Timeout_val="'BEGIN {print substr(\"${ret_Session_Timeout_remain}\",1,${ret_Session_Timeout_end}-1);}'"	
			else 
				cmd_Session_Timeout_val="'BEGIN {print substr(\"${ret_Session_Timeout_remain}\",1);}'"	
			fi 
			ret_Session_Timeout_val=$(eval awk ${cmd_Session_Timeout_val})	

	
			uci set ${UCI_LDAP_QUERY_RESULT}.${key}."timeout"="${ret_Session_Timeout_val}"	
			echo "Authentication success with Session-Timeout=${ret_Session_Timeout_val}."			
		else 
			echo "Authentication success without Session-Timeout."
		fi 
		uci set ${UCI_LDAP_QUERY_RESULT}.${key}."status"="success"
	fi
	
	uci commit ${UCI_LDAP_QUERY_RESULT}
	








