#!/bin/sh /etc/rc.common
MACGRP_LIBDIR=${MACGRP_LIBDIR:-/lib/macgroup}

macgroup_start() 
{
	macgroup_init

	echo "load macgroup "
	macgroup_load
	
	[ -x /usr/sbin/conntrack ] && anete conntrack -D -m 0x1000
}

macgroup_init()
{
	[ -z "$MACGROUP_INITIALIZED" ] || return 0

	for file in $MACGRP_LIBDIR/core_*.sh; do
		. $file
	done
	MACGROUP_INITIALIZED=1
	return 0
}

macgroup_stop()
{
	echo ""
}

macgroup_restart()
{
	macgroup_stop
	macgroup_start
}

macgroup_reload()
{
	macgroup_restart
}

