#!/bin/sh
#ER8411(UN) 1.0的调速策略调整为如下：
#       风扇的档位有三档：停转、低速、高速。
#如果cpu、南桥芯片或（switch-10）的内部温度传感器读到的3个温度值的最大值低于80℃且SFP附近的温度传感器的温度低于62℃，风扇停转；
#如果cpu、南桥芯片或（switch-10）的内部温度传感器读到的3个温度值的最大值为80-95℃且SFP附近的温度传感器的温度小于66℃，或者，SFP附近的温度传感器的温度为62-66℃且cpu、南桥芯片或（switch-10）的内部温度传感器读到的3个温度值的最大值小于95℃，两者满足任何一个或者均满足，风扇转速均为低转速；
#如果cpu、南桥芯片或（switch-10）的内部温度传感器读到的3个温度值的最大值高于95℃或SFP附近的温度传感器的温度高于66℃，如果cpu、南桥芯片或（switch-10）的内部温度传感器读到的3个温度值的最大值高于80℃且插入的两个万兆电模块处于10G速率下的link/Act状态，上述三种情况风扇转速均为高转速；
#其余状态和样机初始化时，风扇转速为高转速。
#高转速，风扇控制电压：11.1V 低转速时风扇控制电压：7.2V
#不同风扇转速之间的切换的阈值窗口为4℃。

#fan speed gpio value
fan_speed1=$(uci get monitor.fan.speed1)
fan_speed2=$(uci get monitor.fan.speed2)

standard_sfp1=$(uci get monitor.fan.standard_sfp1)
standard_sfp2=$(uci get monitor.fan.standard_sfp2)
standard_chip1=$(uci get monitor.fan.standard_chip1)
standard_chip2=$(uci get monitor.fan.standard_chip2)
standard_switch1=$(uci get monitor.fan.standard_switch1)
standard_switch2=$(uci get monitor.fan.standard_switch2)
threshold=$(uci get monitor.fan.threshold)

speed=0
chip=100
sfp=100
southbridge=100
switch=100 

set_fan_init(){
	echo $fan_speed1 > /sys/class/gpio/export
	echo $fan_speed2 > /sys/class/gpio/export
	echo "out" > /sys/class/gpio/gpio$fan_speed1/direction
	echo "out" > /sys/class/gpio/gpio$fan_speed2/direction
}


#$1: 0: stop; 1: low; 2: high
set_fan_speed(){

	if [ $1 = "0" ];then
		#echo "set_fan_speed 0" > /dev/console
		echo 1 > /sys/class/gpio/gpio$fan_speed1/value
		echo 1 > /sys/class/gpio/gpio$fan_speed2/value
		
	elif [ $1 = "1" ];then
		#echo "set_fan_speed 1" > /dev/console
		echo 1 > /sys/class/gpio/gpio$fan_speed1/value
		echo 0 > /sys/class/gpio/gpio$fan_speed2/value
		
	else
		#echo "set_fan_speed 2" > /dev/console
		echo 0 > /sys/class/gpio/gpio$fan_speed1/value
		echo 0 > /sys/class/gpio/gpio$fan_speed2/value
		
	fi
	speed=$1
}

fan_state_check() {
	
	#local gpio=$(uci get system.fan_state.gpio)
	local fan_speed=$(cat /tmp/fan_speed)  
	local fan_pin_1=$(cat /sys/class/gpio/gpio$fan_speed1/value)
	local fan_pin_2=$(cat /sys/class/gpio/gpio$fan_speed2/value)
	if [ "$fan_speed" == "0" ]; then
		if [  $fan_pin_1 = 1 ]  && [ $fan_pin_2 = 1 ]; then
			echo 1 > /tmp/fan_state
		else
			echo 0 > /tmp/fan_state
		fi
	elif [ "$fan_speed" == "1" ]; then
		if [ $fan_pin_1 = 1 ]  && [ $fan_pin_2 = 0 ]; then
			echo 1 > /tmp/fan_state
		else
			echo 0 > /tmp/fan_state
		fi
	else
		if [ $fan_pin_1 = 0 ]  && [ $fan_pin_2 = 0 ]; then
			echo 1 > /tmp/fan_state
		else
			echo 0 > /tmp/fan_state
		fi
	fi

}

set_fan_main(){
	
	cat /sys/class/gpio/gpio$fan_speed2/value 
	if [ $? != 0 ];then
		set_fan_init
		set_fan_speed 0
	fi
	while(true)
	do
		/lib/monitor/get_temperature.sh
		chip=$(cat /tmp/temperature_max)
		if [ $? -ne 0 ]; then
			sleep 1
			continue
		fi
		sfp=$(cat /tmp/temperature_board)
		if [ $? -ne 0 ]; then
			sleep 1
			continue
		fi
		if [ $speed -eq 0 ]; then
			if [ $sfp -lt $(($standard_sfp1+$threshold)) ] &&  [ $chip -ge $(($standard_chip1+$threshold)) ] && [ $chip -le $standard_chip2 ]; then 
				speed=1
				set_fan_speed $speed
				#echo "speed 0 to 1" > /dev/console
				continue
			fi
			if [ $sfp -ge $(($standard_sfp1+$threshold)) ] && [ $sfp -lt $standard_sfp2 ]; then
				speed=1
				set_fan_speed $speed
				continue
			fi
			if [ $sfp -gt $(($standard_sfp2+$threshold)) ]; then 
				speed=2
				reason=1
				set_fan_speed $speed
				#echo "speed 0 to 2" > /dev/console
				continue
			fi 
			if [ $chip -gt $(($standard_chip2+$threshold)) ]; then
				speed=2
				reason=2
				set_fan_speed $speed
				#echo "speed 0 to 2" > /dev/console
				continue
			fi 
		elif [ $speed -eq 1 ]; then
			if [ $sfp -lt $(($standard_sfp1-$threshold)) ] && [ $chip -lt $(($standard_chip1-$threshold)) ]; then 
				speed=0
				set_fan_speed $speed
				#echo "speed 1 to 0" > /dev/console
				continue
			fi
			if [ $sfp -gt $(($standard_sfp2+$threshold)) ]; then 
				speed=2
				reason=1
				set_fan_speed $speed
				#echo "speed 1 to 2" > /dev/console
				continue
			fi 
			if [ $chip -gt $(($standard_chip2+$threshold)) ]; then
				speed=2
				reason=2
				set_fan_speed $speed
				#echo "speed 1 to 2" > /dev/console
				continue
			fi 
		elif [ $speed -eq 2 ]; then
			if [ $sfp -lt $(($standard_sfp1-$threshold)) ] && [ $chip -lt $standard_chip1 ] && [ $reason -eq 1 ]; then 
				speed=0
				reason=0
				set_fan_speed $speed
				#echo "speed 2 to 0" > /dev/console
				continue
			fi
			if [ $sfp -lt $standard_sfp1 ] && [ $chip -lt $(($standard_chip1-$threshold)) ] && [ $reason -eq 2 ]; then 
				speed=0
				reason=0
				set_fan_speed $speed
				#echo "speed 2 to 0" > /dev/console
				continue
			fi 
			if [ $sfp -lt $(($standard_sfp2-$threshold)) ] && [ $chip -ge $standard_chip1 ] && [ $chip -le $standard_chip2 ] && [ $reason -eq 1 ]; then 
				speed=1
				reason=0
				set_fan_speed $speed
				#echo "speed 2 to 1" > /dev/console
				continue
			fi
			if [ $sfp -ge $standard_sfp1 ] && [ $sfp -lt $standard_sfp2 ] && [ $chip -le $(($standard_chip2-$threshold)) ] && [ $reason -eq 2 ]; then 
				speed=1
				reason=0
				set_fan_speed $speed
				#echo "speed 2 to 1" > /dev/console
				continue
			fi
		else
			echo "fan speed error" > /dev/console
		fi
		echo $speed > /tmp/fan_speed
		fan_state_check
		sleep 1
	done
	return 0
}
set_fan_main
