. /lib/functions.sh

pppox_ppppath="/tmp/ppp/"
kill_flag="yes"
command=$1

CONFIG_PTAH=/etc/config/

has_config() {
    vpn_type="$1"
	[ "${vpn_type}" == "l2tp" ] && cat ${CONFIG_PTAH}network | grep proto | grep ${vpn_type} > /dev/null && echo "no" && return
	[ "${vpn_type}" == "l2tp" ] && cat ${CONFIG_PTAH}${vpn_type}-client | grep enable > /dev/null && echo "no" && return
	cat ${CONFIG_PTAH}${vpn_type}-server | grep enable > /dev/null && echo "no" && return
	echo "yes" && return
}

check_vpn_dial(){
    vpn_type=$1
    kill_flag=`has_config ${vpn_type}`
    [ "${kill_flag}" == "no" ] && return

    for file in `ls ${pppox_ppppath}/pid 2>/dev/null`; do
		getconfigpath=`uci -c ${pppox_ppppath}/pid get ${file}.@info[0].configpath 2>/dev/null`
		file_vpn_type=`echo ${getconfigpath} | cut -d "/" -f3 2>/dev/null`
        [ "${file_vpn_type}" == "${vpn_type}" ] && kill_flag="no" && return
	done

    return
}

kill_pptpd(){
    check_vpn_dial "pptp"
    [ ${kill_flag} == "yes" ] && /etc/init.d/pptpd stop
}

kill_xl2tpd(){
    check_vpn_dial "l2tp"
    [ ${kill_flag} == "yes" ] && /etc/init.d/xl2tpd stop
}

case $command in
    (kill_pptpd)
        kill_pptpd
        ;;
    (kill_xl2tpd)
        kill_xl2tpd
        ;;
esac