local dbg = require "luci.tools.debug"
local sys = require "luci.sys"
local uci = require "luci.model.uci"
local uci_r = uci.cursor()

local user_config = "user-secrets"
local pppox_l2tptype = "l2tp"
local pppox_pptptype = "pptp"
local pppox_l2tp_reference_path = "/tmp/l2tp_reference"
local pppox_pptp_reference_path = "/tmp/pptp_reference"

local function _is_exist(ippool, filepath)
    local cmd = "cat \"" .. filepath .. "\""
    local ippool_output = io.popen(cmd)

    for line in ippool_output:lines() do
        if line == ippool then
            --dbg(line)
            --dbg(1111111111)
            return true
        end
    end
    return false
end

local function _load_one_user(section)
    local filepath
    if section.type ~= pppox_l2tptype and section.type ~= pppox_pptptype then
        return false
    end
    if section.type == pppox_l2tptype then
        filepath = pppox_l2tp_reference_path
    else
        filepath = pppox_pptp_reference_path
    end

    if not _is_exist(tostring(section.ippool), filepath) then 
        local ff = io.open(filepath, "a")
        ff:write(section.ippool .. "\n")
        ff:close()
    end
end

local function pppox_load_user()
	uci_r:foreach(user_config, "user", function(section)
			_load_one_user(section)
            return true
        end
        )
	return true
end

pppox_load_user()
