#!/bin/sh
#Copyright (C) 2022 tplink.com

. /lib/qos-tplink/qos_public.sh



dpdk_add_rule()
{
	dpdk_init_file="/etc/init.d/dpdk"
	local rate="$1"
	local type="$2"
	local setting_num="$3"
	local setting_index="$4"
	local rule="$5"
	local maskbit="$6"
	if [ -f "$dpdk_init_file" ]; then
		echo "$rate $type $setting_num $setting_index $rule $maskbit insert" > /proc/net/natfwd_qoslimit
		return 0
	fi
	return
}

dpdk_del_rule()
{
	dpdk_init_file="/etc/init.d/dpdk"
	local rate="$1"
	local type="$2"
	local setting_num="$3"
	local setting_index="$4"
	local rule="$5"
	local maskbit="$6"
	if [ -f "$dpdk_init_file" ]; then
		echo "$rate $type $setting_num $setting_index $rule $maskbit delete" > /proc/net/natfwd_qoslimit
		return 0
	fi
	return
}

dpdk_flush_conntrack()
{
	dpdk_init_file="/etc/init.d/dpdk"
	if [ -f "$dpdk_init_file" ]; then
		echo "flush" > /proc/net/natfwd_flush_conntrack
		return 0
	fi
	return
}

dpdk_on_off()
{
	dpdk_init_file="/etc/init.d/dpdk"
	local qos_enable="$1"
	if [ -f "$dpdk_init_file" ]; then
		[ "$qos_enable" == "off" ] && echo 0 > /sys/qoslimit/g_natfwd_qoslimit_switch && return
		[ "$qos_enable" == "on" ] && echo 1 > /sys/qoslimit/g_natfwd_qoslimit_switch && return
	fi
}