#!/bin/sh
#Copyright (C) 2015 tplink.com

local THIS_MODULE="qos_ctl"
local QOS_CONFIG_DIR="/etc/config"
local QOS_LIB_DIR="/lib/qos_ctl"
local QOS_UCI="${QOS_CONFIG_DIR}/${THIS_MODULE}"
local LIB_SH="$QOS_LIB_DIR/qos_nf.sh"
local QOS_TMP_DIR="/tmp/.qos_ctl"
local QOS_READY="$QOS_TMP_DIR/ready"
source $LIB_SH

[ -f $QOS_UCI ] || {
    touch $QOS_UCI
    export QOS_CONFIG_INVALID="true"
}


#############################################################################

# qos start entry
# complete hard init qos in TC & nf
qos_start()
{

    [ -z $QOS_CONFIG_INVALID ] || {
        echo "  NO UCI config, exit the QOS process ! "
        return
    }
    
    mkdir -p /tmp/.qos_ctl
# 1. global init root
    $LIB_SH init
    [ $? -ne 0 ] && echo "QoS Control init failed!" && return

# 2. extract all user rules from UCI config file
    local rule_list=$(qos_rulelist_get)
    local wan_list=$(qos_wanlist_get)
    echo "rule_list: $rule_list"
    echo "wan_list: $wan_list"
#    if [ ${#wan_list} -eq 0 ];then
#        echo "No wan config find!"
#    else
#        for wan in $wan_list
#        do
#            $LIB_SH update_bandwidth $wan
#        done
#    fi
#    if [ ${#rule_list} -eq 0 ]; then
#        echo "NO user rule find!"
#    else
#        $LIB_SH update_rule
#    fi
    touch $QOS_READY
}


qos_stop()
{
    rm $QOS_READY 2>/dev/null
    $LIB_SH destroy
}


qos_ipv6group_handle()
{
       [ ! -f $QOS_READY ] && QOS_LOG_PRINT " info, qos not config, NO need ipgroup handle ! " && return
        local mode="$1"  # UPDATE or DELETE
        local ipobj="$2"

        [ "$mode" != "update" ] && QOS_LOG_PRINT " info, ipv6group handle mode != update ! " && return

        # compose the rule_list match the ipgroup obj
        local ln=`ip6tables -w -t mangle -L qosctl_rule_mark --line | grep -w "ipv6_$ipobj" | awk '{print $1}' NR==1`
        [ ${#ln} -ne 0 ] && $LIB_SH toggle
}
    #echo "#####$0 $@ " > /dev/console
##################################################################################
    if [ "$1" = "start" ]; then
    	qos_start
    elif [ "$1" = "stop" ]; then
    	qos_stop
    elif [ "$1" = "ipv6group" ];then
        qos_ipv6group_handle $2 $3
    else
    	echo "$0 NO support arg $args " > /dev/console
    fi

