#!/usr/bin/lua
local uci_m = require "luci.model.uci"
local sys = require "luci.sys"
local MODULE_UCI = "qos_ctl"
local STYPE_RULE = "rule"
local uci = uci_m.cursor()

function qos_rule_count()
    local i = 0
    local flag = false
    uci:foreach(MODULE_UCI, STYPE_RULE,
        function(section)
            local rule = uci:get_all(MODULE_UCI, section[".name"])
            if not rule.ipt_idx then
                flag = true
            end
            i = i + 1
        end
    )
    -- since rule are in pairs
    return i, flag
end

function qos_config_sync()
    local count, flag = qos_rule_count()
    if not flag then
        return
    end
    local idx_v4 = 1
    local idx_v6 = 1
    for i=1, count do
        uci:foreach(MODULE_UCI, STYPE_RULE,
            function(section)
                local rule = uci:get_all(MODULE_UCI, section[".name"])
                if tonumber(rule.rule) == i then
                    if rule.ip == "ipv4" then
                        uci:set(MODULE_UCI, section[".name"],"ipt_idx",idx_v4)
                        idx_v4 = idx_v4 + 1
                    elseif rule.ip == "ipv6" then
                        uci:set(MODULE_UCI, section[".name"],"ipt_idx",idx_v6)
                        idx_v6 = idx_v6 + 1
                    end
                end
            end
        )
    end
    uci:commit(MODULE_UCI)
end

qos_config_sync()