#! /bin/sh

logre_volume_name=log_recovery
pnc_oops_volume_name=panic-oops

logre_mtd=`cat /proc/mtd | grep ${logre_volume_name} | head -n 1 | awk -F : '{print $1}'`
logre_mtd_num=${logre_mtd##mtd}

oops_mtd=`cat /proc/mtd | grep ${pnc_oops_volume_name} | head -n 1 | awk -F : '{print $1}'`
oops_mtd_num=${oops_mtd##mtd}

if [ ! -z "$logre_mtd" ] ; then
	if [ ! -e /tmp/log ]; then
		mkdir /tmp/log
	fi


	dd if=/dev/mtdblock${logre_mtd_num} of=/tmp/log/temp_file count=1 bs=8
	read A </tmp/log/temp_file

	# recovery file if volume log_recovery is not 0xff
	if [ -n "$(echo ${A}| sed -n "/^[0-9]\+$/p")" ] ; then
		dd if=/dev/mtdblock${logre_mtd_num} of=/tmp/log/systemlog_recovery count=${A} bs=1 skip=8
		mtd erase ${logre_volume_name}
	fi
	rm -rf /tmp/log/temp_file


	hexdump -v -n 4 /dev/mtdblock${oops_mtd_num} | head -n 1 | awk -F: '{print $1}' > /tmp/log/temp_file
	read A B C </tmp/log/temp_file
	cnt=0
	step=0

	while [ "${B}${C}" != "ffffffff" ]
	do
		dd if=/dev/mtdblock${oops_mtd_num} of=/tmp/log/panic-oops_recovery${cnt} count=4096 bs=1 skip=${step}
		cat /tmp/log/panic-oops_recovery${cnt} >> /tmp/log/panic-oops_recovery
		rm -rf /tmp/log/temp_file
		rm -rf /tmp/log/panic-oops_recovery${cnt}

		cnt=$((${cnt}+1))
		step=$((${cnt}*4096))
		hexdump -v -n 4 -s ${step} /dev/mtdblock${oops_mtd_num} | head -n 1 | awk -F: '{print $1}' > /tmp/log/temp_file
		read A B C </tmp/log/temp_file
	done

	if [ -e tmp/log/temp_file ] ; then
		rm -rf /tmp/log/temp_file
	fi

	if [ ${cnt} -ne 0 ] ; then
		mtd erase ${pnc_oops_volume_name}
	fi
fi
