#!/bin/sh 
#/etc/rc.common
# Copyright(c) 2011-2020 Shenzhen TP-LINK Technologies Co.Ltd.
# file    portal_mgmt_monitor.sh 
# brief   dns 查找云controller ip，给与放行443端口报文
# author   cuibinglin
# version  1.0.0
# date     2020.11.22
# histry   arg 1.0.0, 2020.11.22, cuibinglin, Create the file. 

. /lib/functions.sh
. /lib/functions/network.sh
. /lib/zone/zone_api.sh

portal_cs_dns_s=10
portal_cs_dns_l=300
portal_cs_dns_timeout=$portal_cs_dns_s
portal_cshost_file="/tmp/portal_mgmt_cshost"
portal_cshost_backup=""

portal_waiting_next()
{
	for i in `seq $portal_cs_dns_timeout`;do
		sleep 2
	done
	#echo "portal step  $portal_cs_dns_timeout" > /dev/console
}

portal_cs_domain_dns()
{
	local cs_domain_ips
	#cs_domain use for cloud portal redirect, there is a flag,check mode is cloud controller
	#cs_host is real device cloud url
	#cs_domain is not cs_host
	local cs_domain=$(uci get portal_mgmt.rewrite.cs_domain 2>/dev/null )
	local cs_host

	portal_cs_dns_timeout=$portal_cs_dns_s
	#echo "cs_domain is $cs_domain" > /dev/console
	if [ "$cs_domain" != "" ]; then
		lua /usr/lib/portal_mgmt/portal_mgmt_monitor.lua
		sleep 1
		[ -e $portal_cshost_file ] && {
			cs_host=$(cat $portal_cshost_file 2>/dev/null)
			#echo "cs_host is $cs_host" > /dev/console
			if [ "$cs_host" != "" ]; then
				#dnsq only get one ip, there use dnslookup
				cs_domain_ips=$(dnslookup ${cs_host} )
				echo "cs_domain_ips is $cs_domain_ips" > /dev/console
				if [ "$cs_domain_ips" != "" ]; then
					portal_mgmt clearcsdomainip
					#echo "portal_mgmt clearcsdomainip $cs_domain_ips" > /dev/console
					for cs_domain_ip in $cs_domain_ips;
					do
						[ "$cs_domain_ip" != "0.0.0.0" ] && {
							echo "portal_mgmt addcsdomainip $cs_domain_ip" > /dev/console
							portal_mgmt addcsdomainip $cs_domain_ip
							portal_cs_dns_timeout=$portal_cs_dns_l
						}
					done
				fi
			fi
		}
	fi	
}

while [ 1 ]
do
	portal_waiting_next
	portal_cs_domain_dns
done	
	
