local sys = require "luci.sys"
local uci = require "luci.model.uci"
--local dbg  = require "luci.tools.debug"
local uci_r = uci.cursor()
local utl    = require "luci.util"
local client = {}
local count = 1
local line

local dip = ngx.var.remote_addr
	
client.mac = "00:00:00:00:00:00"
client.vlanid = "1"

local function vlans2vlanid(vlans)
	local index = utl.split(vlans,",")
	local vlanstr_table = (type(index) == "table") and index or {index}
	local vlanstr = vlanstr_table[1]
	index = utl.split(vlanstr,"-")
	local vlanid_table = (type(index) == "table") and index or {index}
	local vlanid = vlanid_table[1]
	return vlanid
end

sys.call("vnete arp -n | grep -v Address | grep -v incomplete | grep -v veth | awk '{{print $1,$3,$5}}' >/tmp/portal_mgmt_arp")
for line in io.lines("/tmp/portal_mgmt_arp") do
	if count > 4096 then 
		break
	end
	count = count + 1
	
	local ip = string.match(line,"%d+.%d+.%d+.%d+")
	--gdb("ip",ip)
	if dip == ip then
		local mac = string.match(line,"%x+:%x+:%x+:%x+:%x+:%x+")	
		--gdb("mac",mac)
		local start=nil
		local end_ind=nil
		if mac then
			start,end_ind = string.find(line,mac)
		end

		--ifname
		local ifname = nil
		if end_ind then
			ifname = string.sub(line,end_ind+2,string.len(line))
		end
		--gdb("ifname",ifname)
	
		client.mac = string.upper(mac)
		--client.mac = string.gsub(client.mac,":","-")
		ifname = string.gsub(ifname,"^%s*(.-)%s*$","%1")
		
		uci_r:foreach("vnetwork", "vinterface",
					function(section)
						local entry = uci_r:get_all("vnetwork", section[".name"])
						if entry.ifname == ifname then
							if entry.vlans ~= nil then
								client.vlanid = vlans2vlanid(entry.vlans)
							elseif entry.vlanid ~= nil then
								client.vlanid = tostring(entry.vlanid)
							else
								client.vlanid = nil
							end
						end
					end
				)
		break
	end	
end
sys.call("rm -f /tmp/portal_mgmt_arp")

local cs_ip = uci_r:get("portal_mgmt", "rewrite", "cs_ip")
local cs_domain = uci_r:get("portal_mgmt", "rewrite", "cs_domain")
local cs_http_port = uci_r:get("portal_mgmt", "rewrite", "cs_http_port")
local portal_name = "entry"
local gateway_mac = uci_r:get("portal_mgmt", "rewrite", "gateway_mac")
local time_start = os.time()
local ori_url = ngx.var.scheme .. "%3A%2F%2F" .. ngx.var.host .. ngx.var.request_uri

if cs_domain then
   --dbg("cs_domain" .. cs_domain)
   cs_ip = cs_domain
end

local redirect_url = string.format("http://%s:%d/portal/%s?cid=%s&gateway=%s&vid=%s&t=%s&u=%s",cs_ip,cs_http_port,portal_name,client.mac,gateway_mac,client.vlanid,time_start,ori_url)

local data = "<html><head></head><body><script type=\"text/javascript\" language=\"javascript\">top.location.href=\""..redirect_url.."\";</script></body></html>" 

ngx.header['Content-Type'] = "text/html"
ngx.header['Content-Length'] = string.len(data)

return ngx.print(data)
--[[
--local sys = require "luci.sys"
--local uci = require "luci.model.uci"
--local uci_r = uci.cursor()
function getMacByIp(dip)
	local ret = {}
	local count = 1
	local line
	
	ret.mac = "00:00:00:00:00:00"
	ret.interface = 1
	
	sys.call("vnete arp -n | grep -v Address | grep -v incomplete | grep -v veth | awk '{{print $1,$3,$5}}' >/tmp/portal_mgmt_arp")
	for line in io.lines("/tmp/portal_mgmt_arp") do
        if count > 4096 then 
            break
        end
		count = count + 1
		
		local ip = string.match(line,"%d+.%d+.%d+.%d+")
		--gdb("ip",ip)
		if dip == ip then
			local mac = string.match(line,"%x+:%x+:%x+:%x+:%x+:%x+")	
			--gdb("mac",mac)
			local start=nil
			local end_ind=nil
			if mac then
				start,end_ind = string.find(line,mac)
			end

			--interface
			local interface = nil
			if end_ind then
				interface = string.sub(line,end_ind+1,string.len(line)-2)
			end
			--gdb("interface",interface)
		
			ret.mac = string.upper(mac)
			--ret.mac = string.gsub(ret.mac,":","-")
			ret.interface = string.gsub(interface,"^%s*(.-)%s*$","%1") 
			break
		end	
	end
	sys.call("rm -f /tmp/portal_mgmt_arp")
	return ret
end

--function rewrite_handle()
	--local cs_ip = uci_r:get("portal_mgmt", "rewrite", "cs_ip")
	--local cs_http_port = uci_r:get("portal_mgmt", "rewrite", "cs_http_port")
	--local portal_name = "entry"
	--local client = getMacByIp(ngx.var.remote_addr)
	--local gateway_mac = uci_r:get("portal_mgmt", "rewrite", "gateway_mac")
	--local time_start = os.time()
	--local ori_url = ngx.var.uri
	--local redirect_url = string.format("http://%s:%d/portal/%s?cid=%s&gw=%s&vid=%d&t=%u&u=%s",cs_ip,cs_http_port,portal_name,client.mac,gateway_mac,client.interface,time_start,ori_url)
	--local redirect_url = string.format("http://portal/%s",portal_name)
	--return ngx.redirect(redirect_url, 302)
	--return ngx.redirect("http://www.tp-link.com/", 302)
--end
--rewrite_handle()
--return ngx.redirect("http://www.tp-link.com/", 302)
]]--
