#!/bin/sh
. /lib/functions.sh
. /lib/firewall/fw.sh
. /lib/firewall/core_tpfirewall.sh
. /lib/zone/zone_api.sh

ACTUALIP=$2
REMTOEIP=$3
LOCALDEVNET=$4
DEVNAME=$5
VPN_RULE_NUM=25
OVPN_RULE_NUM=24
tunnel_num=0

check_ovpn_server_tunnel()
{
    local name=$1
    if [ "$DEVNAME" != "tun_$name" ]; then
        local test1=`openvpn_mgmt $name status 2 |grep -v "HEADER,ROUTING_TABLE," |grep -c "ROUTING_TABLE,"`
        let tunnel_num+=$test1
    fi
}

add_proxy_arp_route()
{
    echo "openvpn connect script" > /dev/console
    echo [LOCAL]$LOCALDEVNET $ACTUALIP [VIRTUAL]$REMTOEIP [TUN]$DEVNAME is connected > /dev/console
    #ip route add $REMTOEIP via $LOCALDEVNET dev $DEVNAME table $VPN_RULE_NUM
    vnete ip route add $REMTOEIP via 169.254.11.21 table $VPN_RULE_NUM
    ip route add $REMTOEIP dev  $DEVNAME table $VPN_RULE_NUM
}
ippool_set="ovpn_${DEVNAME}"
ipset add  $ippool_set $REMTOEIP

config_load openvpn
config_foreach check_ovpn_server_tunnel server
let tunnel_num+=$cur_tunnel_num
local ucipath="/etc/profile.d"
local total_tunnel_max=`uci -c $ucipath get profile.@openvpn[0].server_list_max`
[ -z $total_tunnel_max ] && total_tunnel_max=5
total_tunnel_max=`expr $total_tunnel_max \* 10`
[ $tunnel_num -ge $total_tunnel_max ] && exit -1


add_proxy_arp_route
exit 0
