#!/bin/sh  
###########################################################  
# checkpsw.sh (C) 2004 Mathias Sundman <mathias@openvpn.se> 
#  
# This script will authenticate OpenVPN users against  
# a plain text file. The passfile should simply contain  
# one row per user with the username first followed by  
# one or more space(s) or tab(s) and then the password.  
 
PASSFILE="/etc/openvpn/openvpn-pswserver$SECTIONNAME" 
LOG_FILE="/var/run/openvpn-password.log" 
TIME_STAMP=`date "+%Y-%m-%d %T"`  
echo "$PASSFILE" >> ${LOG_FILE}
. /lib/ldap-tplink/api.sh
###########################################################  

local server_name=$SERVERNAME
local mytype=`uci get openvpn.$server_name.authtype`
if [ "$mytype" = "ldap" ]; then
  local ldap_profile=`uci get openvpn.${server_name}.ldap_profile`
  vpn_ldap_auth "$username" "$password" "$ldap_profile"
  if [ "$?" = 0 ]; then
    echo "openvpn ldap auth success" > /dev/console
    exit 0
  else
    echo "openvpn ldap auth failed" > /dev/console
    exit 1
  fi
fi
 
if [ ! -r "${PASSFILE}" ]; then  
  echo "${TIME_STAMP}: Could not open password file \"${PASSFILE}\" for reading." >> ${LOG_FILE}  
  exit 1  
fi  
 
CORRECT_PASSWORD=`awk '!/^;/&&!/^#/&&$1=="'${username}'"{print $2;exit}' ${PASSFILE}`  
 
if [ "${CORRECT_PASSWORD}" = "" ]; then   
  echo "${TIME_STAMP}: User does not exist: username=\"${username}\", password=\"${password}\"." >> ${LOG_FILE}  
  exit 1  
fi  
 
if [ "${password}" = "${CORRECT_PASSWORD}" ]; then   
  echo "${TIME_STAMP}: Successful authentication: username=\"${username}\"." >> ${LOG_FILE}  
  exit 0  
fi  
 
echo "${TIME_STAMP}: Incorrect password: username=\"${username}\", password=\"${password}\"." >> ${LOG_FILE}  
exit 1 
