;(function ($) {
    $.su = $.su || {}
    $.su.CHAR = $.su.CHAR || {}
    $.su.CHAR.HELP = {
        IFSTAT_INTRODUCT: {
            TITLE: 'Interface Statistics',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Interface Statistics displays detailed information relating to the traffic statistics on each interface. You can monitor the traffic and locate faults according to this information.'
                }
            ]
        },

        IFSTAT_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'View the data on the desired interface. Click %<{"type":"refreshSpan","text":"Refresh"}>% to view the latest traffic statistics of the interfaces, and click the header to sort the column in ascending or descending order.'
                }
            ]
        },

        IFSTAT_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'TX Rate (KB/s)',
                    content: 'Displays the rate for transmitting data in kilobytes per second.'
                },
                {
                    type: 'name',
                    title: 'RX Rate (KB/s)',
                    content: 'Displays the rate for receiving data in kilobytes per second.'
                },
                {
                    type: 'name',
                    title: 'TX Packet Rate (Pkt/s)',
                    content: 'Displays the rate for transmitting data in packets per second.'
                },
                {
                    type: 'name',
                    title: 'RX Packet Rate (Pkt/s)',
                    content: 'Displays the rate for receiving data in packets per second.'
                },
                {
                    type: 'name',
                    title: 'Total TX Bytes',
                    content: 'Displays the bytes of packets transmitted on the interface.'
                },
                {
                    type: 'name',
                    title: 'Total RX Bytes',
                    content: 'Displays the bytes of packets received on the interface.'
                },
                {
                    type: 'name',
                    title: 'Total TX Packets',
                    content: 'Displays the number of packets transmitted on the interface.'
                },
                {
                    type: 'name',
                    title: 'Total RX Packets',
                    content: 'Displays the number of packets received on the interface.'
                }
            ]
        },

        IP_STATS_INTRODUCT: {
            TITLE: 'IP Statistics',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'IP Statistics displays detailed information relating to the traffic of specific IP  addresses. You can monitor the traffic and locate faults according to this information.'
                }
            ]
        },

        IP_STATS_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Enable IP Statistics and specify an IP range for monitor.',
                        'View the detailed information of the IP addresses.'
                    ]
                }
            ]
        },

        IP_STATS_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Enable IP Statistics',
                    content: 'Check the box to enable IP Statistics.'
                },
                {
                    type: 'name',
                    title: 'IP Range',
                    content:
                        'Specify an IP range. The gateway will monitor the packets whose source IP addresses or destination IP addresses are in this range, and display the statistics information in Statistics List.'
                },
                {
                    type: 'name',
                    title: 'IP Address Number',
                    content: 'Displays the number of active users whose IP address is in the  specified IP range.'
                },
                {
                    type: 'name',
                    title: 'TX Rate (KB/s)',
                    content: 'Displays the rate for transmitting data in kilobytes per second.'
                },
                {
                    type: 'name',
                    title: 'RX Rate (KB/s)',
                    content: 'Displays the rate for receiving data in kilobytes per second.'
                },
                {
                    type: 'name',
                    title: 'TX Packet Rate (Pkt/s)',
                    content: 'Displays the rate for transmitting data in packets per second.'
                },
                {
                    type: 'name',
                    title: 'RX Packet Rate (Pkt/s)',
                    content: 'Displays the rate for receiving data in packets per second.'
                },
                {
                    type: 'name',
                    title: 'Total TX Bytes',
                    content: 'Displays the bytes of packets transmitted by the user who owns the IP address.'
                },
                {
                    type: 'name',
                    title: 'Total RX Bytes',
                    content: 'Displays the bytes of packets received by the user who owns the IP address.'
                }
            ]
        },

        INTERFACE_MODE_INTRODUCT: {
            TITLE: 'Introduction',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'WAN ports connect to the internet. You can configure multiple WAN ports for your network. Each WAN port has its own connection type and parameters, which you should configure according to the requirements of your ISP.</br></br>To configure the WAN network, follow the guidelines:'
                },
                {
                    type: 'pearlStep',
                    content: [
                        'In WAN Mode, determine the number of WAN ports according to your needs. Configurable WAN ports then appear in the menu tabs.',
                        'Configure WAN connection for the WAN / SFP WAN port(s). You can configure WAN connection for multiple WANs, and each WAN port has its own Internet Connection Type and parameters.'
                    ]
                },
                {
                    title: 'Note',
                    type: 'note',
                    content: ['WAN/LAN ports cannot all be set to WAN mode at the same time.']
                }
            ]
        },

        INTERFACE_MODE_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'WAN Mode',
                    content:
                        'Determine the number of WAN ports according to your needs. To enable a port as WAN port, check the box of the desired port. To configure multiple WAN ports, enable the ports. Only WAN, WAN/LAN, SFP WAN (for certain devices) and USB Modem can function as WAN port.'
                }
            ]
        },

        INTERFACE_MODE: {
            TITLE: 'WAN Mode',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Configure the number of WAN ports. When a WAN port is added, the port-related entries are automatically added; when a WAN port is deleted, the port-related entries are automatically deleted.'
                },
                {
                    type: 'name',
                    title: '1',
                    content: 'Configure physical interface 1 as WAN1.'
                },
                {
                    type: 'name',
                    title: '2',
                    content: 'Configure physical interface 1 and interface 2 as WAN1 and WAN2 respectively.'
                },
                {
                    type: 'name',
                    title: '3',
                    content: 'Configure physical interface 1, interface 2  and interface3 as WAN1, WAN2  and WAN3 respectively.'
                },
                {
                    type: 'name',
                    title: '4',
                    content:
                        'Configure physical interface 1, interface 2, interface 3 and interface 4 as WAN1, WAN2, WAN3 and WAN4 respectively.'
                },
                {
                    type: 'name',
                    title: 'Save',
                    content: 'Click Save to save the settings.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: 'The router will reboot after switching WAN mode. DO NOT operate the device during this process.'
                }
            ]
        },
        INTERFACE_MODE1: {
            TITLE: 'WAN Mode',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Configure the number of WAN ports. When a WAN port is added, the port-related entries are automatically added; when a WAN port is deleted, the port-related entries are automatically deleted.'
                },
                {
                    type: 'name',
                    title: '1',
                    content: 'Configure physical interface 1 as WAN1.'
                },
                {
                    type: 'name',
                    title: 'Save',
                    content: 'Click Save to save the settings.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: 'The router will reboot after switching WAN mode. DO NOT operate the device during this process.'
                }
            ]
        },
        INTERFACE_MODE2: {
            TITLE: 'WAN Mode',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Configure the number of WAN ports. When a WAN port is added, the port-related entries are automatically added; when a WAN port is deleted, the port-related entries are automatically deleted.'
                },
                {
                    type: 'name',
                    title: '1',
                    content: 'Configure physical interface 1 as WAN1.'
                },
                {
                    type: 'name',
                    title: '2',
                    content: 'Configure physical interface 1 and interface 2 as WAN1 and WAN2 respectively.'
                },
                {
                    type: 'name',
                    title: 'Save',
                    content: 'Click Save to save the settings.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: 'The router will reboot after switching WAN mode. DO NOT operate the device during this process.'
                }
            ]
        },
        INTERFACE_MODE3: {
            TITLE: 'WAN Mode',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Configure the number of WAN ports. When a WAN port is added, the port-related entries are automatically added; when a WAN port is deleted, the port-related entries are automatically deleted.'
                },
                {
                    type: 'name',
                    title: '1',
                    content: 'Configure physical interface 1 as WAN1.'
                },
                {
                    type: 'name',
                    title: '2',
                    content: 'Configure physical interface 1 and interface 2 as WAN1 and WAN2 respectively.'
                },
                {
                    type: 'name',
                    title: '3',
                    content: 'Configure physical interface 1, interface 2  and interface3 as WAN1, WAN2  and WAN3 respectively.'
                },
                {
                    type: 'name',
                    title: 'Save',
                    content: 'Click Save to save the settings.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: 'The router will reboot after switching WAN mode. DO NOT operate the device during this process.'
                }
            ]
        },
        INTERFACE_MODE4: {
            TITLE: 'WAN Mode',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Configure the number of WAN ports. When a WAN port is added, the port-related entries are automatically added; when a WAN port is deleted, the port-related entries are automatically deleted.'
                },
                {
                    type: 'name',
                    title: '1',
                    content: 'Configure physical interface 1 as WAN1.'
                },
                {
                    type: 'name',
                    title: '2',
                    content: 'Configure physical interface 1 and interface 2 as WAN1 and WAN2 respectively.'
                },
                {
                    type: 'name',
                    title: '3',
                    content: 'Configure physical interface 1, interface 2  and interface3 as WAN1, WAN2  and WAN3 respectively.'
                },
                {
                    type: 'name',
                    title: '4',
                    content:
                        'Configure physical interface 1, interface 2, interface 3 and interface 4 as WAN1, WAN2, WAN3 and WAN4 respectively.'
                },
                {
                    type: 'name',
                    title: 'Save',
                    content: 'Click Save to save the settings.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: 'The router will reboot after switching WAN mode. DO NOT operate the device during this process.'
                }
            ]
        },
        INTERFACE_MODE_SFP: {
            TITLE: 'WAN Mode',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Configure the number of WAN ports. When a WAN port is added, the port-related entries are automatically added; when a WAN port is deleted, the port-related entries are automatically deleted.'
                },
                {
                    type: 'name',
                    title: 'SFP WAN',
                    content: 'Configure physical SFP interface as WAN port.'
                },
                {
                    type: 'name',
                    title: 'WAN',
                    content: 'Configure physical WAN interface as WAN port.'
                },
                {
                    type: 'name',
                    title: 'WAN/LAN1',
                    content: 'Configure physical WAN/LAN1 interface as WAN port.'
                },
                {
                    type: 'name',
                    title: 'WAN/LAN2',
                    content: 'Configure physical WAN/LAN2 interface as WAN port.'
                },
                {
                    type: 'name',
                    title: 'Save',
                    content: 'Click Save to save the settings.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: 'The router will reboot after switching WAN mode. DO NOT operate the device during this process.'
                }
            ]
        },
        INTERFACE_MODE_NOSFP: {
            TITLE: 'WAN Mode',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Configure the number of WAN ports. When a WAN port is added, the port-related entries are automatically added; when a WAN port is deleted, the port-related entries are automatically deleted.'
                },
                {
                    type: 'name',
                    title: 'WAN',
                    content: 'Configure physical WAN interface as WAN port.'
                },
                {
                    type: 'name',
                    title: 'WAN/LAN1',
                    content: 'Configure physical WAN/LAN1 interface as WAN port.'
                },
                {
                    type: 'name',
                    title: 'WAN/LAN2',
                    content: 'Configure physical WAN/LAN2 interface as WAN port.'
                },
                {
                    type: 'name',
                    title: 'WAN/LAN3',
                    content: 'Configure physical WAN/LAN3 interface as WAN port.'
                },
                {
                    type: 'name',
                    title: 'Save',
                    content: 'Click Save to save the settings.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: 'The router will reboot after switching WAN mode. DO NOT operate the device during this process.'
                }
            ]
        },
        INTERFACE_WAN: {
            TITLE: 'Connection Configuration',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can configure the WAN port on this page.'
                },
                {
                    type: 'name',
                    title: 'Connection Type',
                    content:
                        'If your ISP (Intrenet Service Provider) has provided you with a static IP address, select "Static IP";</br>If your ISP assigns the IP address automatically, select "Dynamic IP";</br>If your ISP has provided the account information for the PPPoE connection, select "PPPoE";</br>If your ISP has provided the account information for the L2TP connection, please choose"L2TP";</br>If your ISP has provided the account information for the PPTP connection, please choose "PPTP";</br>If your ISP has provided the account information for the BigPond connection, please choose "BigPond".'
                },
                {
                    type: 'name',
                    title: 'Username',
                    content: 'Enter your username. If you are unsure, please contact your ISP.'
                },
                {
                    type: 'name',
                    title: 'Password',
                    content: 'Enter your password. If you are unsure, please contact your ISP.'
                },
                {
                    type: 'name',
                    title: 'Connection Mode',
                    content:
                        'You can select the Connection Mode according to your need.</br>Connect Automatically: Select this option to activate the connection automatically when the router reboots or the connection is down. </br>Connect Manually: Select this option to manually activate or terminate the connection by clicking the Connect or Disconnect button. </br> Time-based: During the specified period, the router will automatically activate the connection.'
                },
                {
                    type: 'name',
                    title: 'Host Name',
                    content: 'Optional: Enter a name for the router. It is null by default. '
                },
                {
                    type: 'name',
                    title: 'Upstream/Downstream Bandwidth',
                    content: 'Specify the upstream/downstream bandwidth of the interface.'
                },
                {
                    type: 'name',
                    title: 'MTU',
                    content:
                        'MTU (Maximum Transmission Unit) is the maximum data unit transmitted in the physical network. </br>When PPPoE is selected, MTU can be set in the range of 576-1492. The default value is 1492. </br>When Dynamic IP/Static IP/BigPond Cable is selected, MTU can be set in the range of 576-1500. The default value is 1500. </br>When L2TP is selected, MTU can be set in the range of 576-1460. The default value is 1460. </br>When PPTP is selected, MTU can be set in the range of 576-1420. The default value is 1420. '
                },
                {
                    type: 'name',
                    title: 'Auth. Server',
                    content: "Enter the authenticating server's IP address or hostname."
                },
                {
                    type: 'name',
                    title: 'Auth. Domain',
                    content:
                        "Enter the server's domain name suffix (based on your location). For example, nsw.bigpond.net.au for NSW/ACT, vic.bigpond.net.au for VIC/TAS/WA/SA/NT, or qld.bigpond.net.au for QLD."
                },
                {
                    type: 'name',
                    title: 'Service Name',
                    content: 'Optional: Enter the Service Name provided by your ISP. It is null by default. '
                },
                {
                    type: 'name',
                    title: 'Primary/Secondary DNS',
                    content: "Optional: Enter the DNS server's IP address, provided by your ISP. It's null by default."
                },
                {
                    type: 'name',
                    title: 'Vlan',
                    content: 'Specify the VLAN that the WAN port belongs to.'
                },
                {
                    type: 'name',
                    title: 'Get IP using Unicast DHCP',
                    content:
                        "Select this checkbox if your ISP's DHCP server does not support broadcast applications and you cannot get the IP address dynamically."
                },
                {
                    type: 'name',
                    title: 'Secondary Connection',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'None: Select if no secondary connection is provided. This mode is not available for L2TP/PPTP.',
                                'Dynamic IP: Select if the IP address and subnet mask are assigned automatically by the ISP.',
                                'Static IP: Select if the IP address and subnet mask are provided by the ISP, and enter this information into the corresponding fields.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'VPN Server IP/Domain Name',
                    content: "Enter the VPN server's IP address or domain name provided by your ISP."
                },
                {
                    type: 'name',
                    title: 'IP Address',
                    content: 'Enter the IP address of the WAN port provided by your ISP.'
                },
                {
                    type: 'name',
                    title: 'Subnet Mask',
                    content: 'Enter the subnet mask provided by your ISP.'
                },
                {
                    type: 'name',
                    title: 'Default Gateway',
                    content: 'Optional: Enter the IP address of the gateway provided by your ISP. It is null by default.'
                },
                {
                    type: 'name',
                    title: 'Primary/Secondary  DNS',
                    content: "Optional: Enter the DNS server's IP address provided by your ISP. It is null by default."
                },
                {
                    type: 'name',
                    title: 'Save',
                    content: 'Click Save to save the settings.'
                },
                {
                    type: 'name',
                    title: 'Connect',
                    content: 'Click Connect to activate the connection.'
                },
                {
                    type: 'name',
                    title: 'Disconnect',
                    content: 'Click Disconnect to terminate the connection.'
                }
            ]
        },

        INTERFACE_WAN_INTRODUCT: {
            TITLE: 'Introduction',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'WAN ports connect to the internet. You can configure multiple WAN ports for your network. Each WAN port has its own connection type and parameters, which you should configure according to the requirements of your ISP.</br></br>To configure the WAN network, follow the guidelines:'
                },
                {
                    type: 'pearlStep',
                    content: [
                        'In WAN Mode, determine the number of WAN ports according to your needs. Configurable WAN ports then appear in the menu tabs.',
                        'Configure WAN connection for the WAN / SFP WAN port(s). You can configure WAN connection for multiple WANs, and each WAN port has its own Internet Connection Type and parameters.'
                    ]
                }
            ]
        },

        INTERFACE_WAN_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Select a WAN / SFP WAN port from the tabs.',
                        'Select the proper Internet Connection Type and configure the parameters according to the requirements of your ISP.'
                    ]
                }
            ]
        },
        INTERFACE_WAN_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Connection Type',
                    content: 'Choose the proper Connection Type according to the requirements of your ISP.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Static IP: Select this type if your ISP has offered you a fixed IP address.',
                                'Dynamic IP: Select this type if your ISP automatically assigns the IP address.',
                                'PPPoE: Select this type if your ISP provides you with a PPPoE account.',
                                'L2TP: Select this type if your ISP provides you with an L2TP account.',
                                'PPTP: Select this type if your ISP provides you with a PPTP account'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Static IP',
                    children: [
                        {
                            type: 'name',
                            title: 'IP Address',
                            content: 'Enter the IP address provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Subnet Mask',
                            content: 'Enter the subnet mask provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Default Gateway',
                            content: 'Enter the default gateway provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Upstream Bandwidth',
                            content:
                                'Specify the upstream bandwidth of the WAN port. This value is the upper limit of the Maximum Upstream Bandwidth on Transmission > Bandwidth Control page. Also, this value determines the bandwidth ratio of each WAN port after Bandwidth Based Balance Routing is enabled on Transmission > Load Balancing > Basic Settings page.'
                        },
                        {
                            type: 'name',
                            title: 'Downstream Bandwidth',
                            content:
                                'Specify the downstream bandwidth of the WAN port. This value is the upper limit of the Maximum Downstream Bandwidth on Transmission > Bandwidth Control page. Also, this value determines the bandwidth ratio of each WAN port after Bandwidth Based Balance Routing is enabled on Transmission > Load Balancing > Basic Settings page.'
                        },
                        {
                            type: 'name',
                            title: 'MTU',
                            content:
                                'Specify the MTU (Maximum Transmission Unit) of the WAN port. MTU is the maximum data unit transmitted in the physical network. When Static IP is selected, MTU can be set in the range of 576-1500 bytes. The default value is 1500.'
                        },
                        {
                            type: 'name',
                            title: 'Primary/Secondary DNS',
                            content: '(Optional) Enter the IP address of the DNS server provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'VLAN',
                            content:
                                'Add the WAN port to a VLAN. Generally, you don’t need to enable VLAN for the WAN port unless required by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'VLAN ID',
                            content:
                                'If VLAN for the WAN port is enabled, you need to enter a VLAN ID. Then the WAN port is automatically assigned to the VLAN. By default, the egress rule of the VLAN is UNTAG, so the packets are transmitted by the WAN port without VLAN tags. If you want the WAN port to transmit packets with VLAN tag, you need to configure its egress rule as TAG. To configure VLANs, go to Network > VLAN > VLAN.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Dynamic IP',
                    children: [
                        {
                            type: 'name',
                            title: 'Host Name',
                            content: '(Optional) Enter a name for the router. It is null by default.'
                        },
                        {
                            type: 'name',
                            title: 'Upstream Bandwidth',
                            content:
                                'Specify the upstream bandwidth of the WAN port. This value is the upper limit of the Maximum Upstream Bandwidth on Transmission > Bandwidth Control page. Also, this value determines the bandwidth ratio of each WAN port after Bandwidth Based Balance Routing is enabled on Transmission > Load Balancing > Basic Settings page.'
                        },
                        {
                            type: 'name',
                            title: 'Downstream Bandwidth',
                            content:
                                'Specify the downstream bandwidth of the WAN port. This value is the upper limit of the Maximum Downstream Bandwidth on Transmission > Bandwidth Control page. Also, this value determines the bandwidth ratio of each WAN port after Bandwidth Based Balance Routing is enabled on Transmission > Load Balancing > Basic Settings page.'
                        },
                        {
                            type: 'name',
                            title: 'MTU',
                            content:
                                'Specify the MTU (Maximum Transmission Unit) of the WAN port. MTU is the maximum data unit transmitted in the physical network. When Dynamic IP is selected, MTU can be set in the range of 576-1500 bytes. The default value is 1500.'
                        },
                        {
                            type: 'name',
                            title: 'Primary/Secondary DNS',
                            content: '(Optional) Enter the IP address of the DNS server provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'VLAN',
                            content:
                                'Add the WAN port to a VLAN. Generally, you don’t need to enable VLAN for the WAN port unless required by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'VLAN ID',
                            content:
                                'If VLAN for the WAN port is enabled, you need to enter a VLAN ID. Then the WAN port is automatically assigned to the VLAN. By default, the egress rule of the VLAN is UNTAG, so the packets are transmitted by the WAN port without VLAN tags. If you want the WAN port to transmit packets with VLAN tag, you need to configure its egress rule as TAG. To configure VLANs, go to Network > VLAN > VLAN.'
                        },
                        {
                            type: 'name',
                            title: 'Get IP using Unicast DHCP',
                            content:
                                'The broadcasting requirement may not be supported by a few ISPs. Select this option if you can not get the IP address from your ISP in the normal DHCP process. This option is not required generally.'
                        },
                        {
                            type: 'name',
                            title: 'Connect',
                            content: 'Click this button to connect to the internet.'
                        },
                        {
                            type: 'name',
                            title: 'Disconnect',
                            content: 'Click this button to disconnect from the internet.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'PPPoE',
                    children: [
                        {
                            type: 'name',
                            title: 'Username',
                            content: 'Enter the PPPoE username provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Password',
                            content: ': Enter the PPPoE password provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Connection Mode',
                            content:
                                'Choose the connection mode, including Connect Automatically, Connect Manually and Time-Based.</br>&nbsp&nbsp&nbsp&nbspConnect Automatically: The router will activate the connection automatically when the router reboots or the connection is down.</br>&nbsp&nbsp&nbsp&nbspConnect Manually: You can manually activate or terminate the connection.</br>&nbsp&nbsp&nbsp&nbspTime-Based: During the specified period, the router will automatically activate the connection.'
                        },
                        {
                            type: 'name',
                            title: 'Time',
                            content:
                                'Choose the time range for automatic connection. To create the time range, go to Preferences > Time Range > Time Range.'
                        },
                        {
                            type: 'name',
                            title: 'Upstream Bandwidth',
                            content:
                                'Specify the upstream bandwidth of the WAN port. This value is the upper limit of the Maximum Upstream Bandwidth on Transmission > Bandwidth Control page. Also, this value determines the bandwidth ratio of each WAN port after Bandwidth Based Balance Routing is enabled on Transmission > Load Balancing > Basic Settings page.'
                        },
                        {
                            type: 'name',
                            title: 'Downstream Bandwidth',
                            content:
                                'Specify the downstream bandwidth of the WAN port. This value is the upper limit of the Maximum Downstream Bandwidth on Transmission > Bandwidth Control page. Also, this value determines the bandwidth ratio of each WAN port after Bandwidth Based Balance Routing is enabled on Transmission > Load Balancing > Basic Settings page.'
                        },
                        {
                            type: 'name',
                            title: 'MTU',
                            content:
                                'Specify the MTU (Maximum Transmission Unit) of the WAN port. MTU is the maximum data unit transmitted in the physical network. When PPPoE is selected, MTU can be set in the range of 576-1492 bytes. The default value is 1492.'
                        },
                        {
                            type: 'name',
                            title: 'Service Name',
                            content:
                                '(Optional) Enter the service name. This parameter is not required unless provided by your ISP. It is null by default.'
                        },
                        {
                            type: 'name',
                            title: 'Primary/Secondary DNS: ',
                            content: '(Optional) Enter the IP address of the DNS server provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'VLAN',
                            content:
                                'Add the WAN port to a VLAN. Generally, you don’t need to enable VLAN for the WAN port unless required by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'VLAN ID',
                            content:
                                'If VLAN for the WAN port is enabled, you need to enter a VLAN ID. Then the WAN port is automatically assigned to the VLAN. By default, the egress rule of the VLAN is UNTAG, so the packets are transmitted by the WAN port without VLAN tags. If you want the WAN port to transmit packets with VLAN tag, you need to configure its egress rule as TAG. To configure VLANs, go to Network > VLAN > VLAN.'
                        },
                        {
                            type: 'name',
                            title: 'Secondary Connection',
                            content:
                                'Secondary connection is required by some ISPs. Select the connection type required by your ISP.</br>&nbsp&nbsp&nbsp&nbspNone: Select this if the secondary connection is not required by your ISP.</br>&nbsp&nbsp&nbsp&nbspDynamic IP: Select this if your ISP automatically assigns the IP address and subnet mask for the secondary connection.</br>&nbsp&nbsp&nbsp&nbspStatic IP: Select this if your ISP provides you with a fixed IP address and subnet mask for the secondary connection.'
                        },
                        {
                            type: 'name',
                            title: 'Connect',
                            content: 'Click this button to connect to the internet.'
                        },
                        {
                            type: 'name',
                            title: 'Disconnect',
                            content: 'Click this button to disconnect from the internet.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'L2TP',
                    children: [
                        {
                            type: 'name',
                            title: 'Username',
                            content: 'Enter the L2TP username provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Password',
                            content: 'Enter the L2TP password provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Connection Mode',
                            content:
                                'Choose the connection mode, including Connect Automatically, Connect Manually and Time-Based.</br>&nbsp&nbsp&nbsp&nbspConnect Automatically: The router will activate the connection automatically when the router reboots or the connection is down.</br>&nbsp&nbsp&nbsp&nbspConnect Manually: You can manually activate or terminate the connection.</br>&nbsp&nbsp&nbsp&nbspTime-Based: During the specified period, the router will automatically activate the connection.'
                        },
                        {
                            type: 'name',
                            title: 'Time',
                            content:
                                'Choose the time range for automatic connection. To create the time range, go to Preferences > Time Range > Time Range.'
                        },
                        {
                            type: 'name',
                            title: 'Upstream Bandwidth',
                            content:
                                'Specify the upstream bandwidth of the WAN port. This value is the upper limit of the Maximum Upstream Bandwidth on Transmission > Bandwidth Control page. Also, this value determines the bandwidth ratio of each WAN port after Bandwidth Based Balance Routing is enabled on Transmission > Load Balancing > Basic Settings page.'
                        },
                        {
                            type: 'name',
                            title: 'Downstream Bandwidth',
                            content:
                                'Specify the downstream bandwidth of the WAN port. This value is the upper limit of the Maximum Downstream Bandwidth on Transmission > Bandwidth Control page. Also, this value determines the bandwidth ratio of each WAN port after Bandwidth Based Balance Routing is enabled on Transmission > Load Balancing > Basic Settings page.'
                        },
                        {
                            type: 'name',
                            title: 'MTU',
                            content:
                                'Specify the MTU (Maximum Transmission Unit) of the WAN port. MTU is the maximum data unit transmitted in the physical network. When L2TP is selected, MTU can be set in the range of 576-1460 bytes. The default value is 1460.'
                        },
                        {
                            type: 'name',
                            title: 'Primary/Secondary DNS',
                            content: '(Optional) Enter the IP address of the DNS server provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'VLAN',
                            content:
                                'Add the WAN port to a VLAN. Generally, you don’t need to enable VLAN for the WAN port unless required by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'VLAN ID',
                            content:
                                'If VLAN for the WAN port is enabled, you need to enter a VLAN ID. Then the WAN port is automatically assigned to the VLAN. By default, the egress rule of the VLAN is UNTAG, so the packets are transmitted by the WAN port without VLAN tags. If you want the WAN port to transmit packets with VLAN tag, you need to configure its egress rule as TAG. To configure VLANs, go to Network > VLAN > VLAN.'
                        },
                        {
                            type: 'name',
                            title: 'Secondary Connection',
                            content:
                                'Select the secondary connection type according to the requirements of your ISP. The secondary connection is required for L2TP connection. The router will get some necessary information after the secondary connection succeeded. The information will be used in the L2TP connection process.</br>&nbsp&nbsp&nbsp&nbspDynamic IP: If you select the secondary connection type as Dynamic IP, the router set up the secondary connection dynamically.</br>&nbsp&nbsp&nbsp&nbspStatic IP: If you select the secondary connection type as Static IP, you need to configure IP Address, Subnet Mask, Default Gateway, Primary/Second DNS for the secondary connection.'
                        },
                        {
                            type: 'name',
                            title: 'VPN Server IP/Domain Name',
                            content: 'Enter the VPN Server/Domain Name provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'IP Address',
                            content: 'Enter the IP address provided by your ISP for the secondary connection.'
                        },
                        {
                            type: 'name',
                            title: 'Subnet  Mask',
                            content: 'Enter the subnet mask provided by your ISP for the secondary connection.'
                        },
                        {
                            type: 'name',
                            title: 'Default Gateway',
                            content: 'Enter the default gateway provided by your ISP for the secondary connection.'
                        },
                        {
                            type: 'name',
                            title: 'Primary/Secondary DNS',
                            content: 'Enter the primary/secondary DNS provided by your ISP for the secondary connection.'
                        },
                        {
                            type: 'name',
                            title: 'Connect',
                            content: 'Click this button to connect to the internet.'
                        },
                        {
                            type: 'name',
                            title: 'Disconnect',
                            content: 'Click this button to disconnect from the internet.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'PPTP',
                    children: [
                        {
                            type: 'name',
                            title: 'Username',
                            content: 'Enter the PPTP  username provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Password',
                            content: 'Enter the PPTP  password provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Connection Mode',
                            content:
                                'Choose the connection mode, including Connect Automatically, Connect Manually and Time-Based.</br>&nbsp&nbsp&nbsp&nbspConnect Automatically: The router will activate the connection automatically when the router reboots or the connection is down.</br>&nbsp&nbsp&nbsp&nbspConnect Manually: You can manually activate or terminate the connection.</br>&nbsp&nbsp&nbsp&nbspTime-Based: During the specified period, the router will automatically activate the connection.'
                        },
                        {
                            type: 'name',
                            title: 'Time',
                            content:
                                'Choose the time range for automatic connection. To create the time range, go to Preferences > Time Range > Time Range.'
                        },
                        {
                            type: 'name',
                            title: 'Upstream Bandwidth',
                            content:
                                'Specify the upstream bandwidth of the WAN port. This value is the upper limit of the Maximum Upstream Bandwidth on Transmission > Bandwidth Control page. Also, this value determines the bandwidth ratio of each WAN port after Bandwidth Based Balance Routing is enabled on Transmission > Load Balancing > Basic Settings page.'
                        },
                        {
                            type: 'name',
                            title: 'Downstream Bandwidth',
                            content:
                                'Specify the downstream bandwidth of the WAN port. This value is the upper limit of the Maximum Downstream Bandwidth on Transmission > Bandwidth Control page. Also, this value determines the bandwidth ratio of each WAN port after Bandwidth Based Balance Routing is enabled on Transmission > Load Balancing > Basic Settings page.'
                        },
                        {
                            type: 'name',
                            title: 'MTU',
                            content:
                                'Specify the MTU (Maximum Transmission Unit) of the WAN port. MTU is the maximum data unit transmitted in the physical network. When PPTP is selected, MTU can be set in the range of 576-1420 bytes. The default value is 1420.'
                        },
                        {
                            type: 'name',
                            title: 'Primary/Secondary DNS',
                            content: '(Optional) Enter the IP address of the DNS server provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'VLAN',
                            content:
                                'Add the WAN port to a VLAN. Generally, you don’t need to enable VLAN for the WAN port unless required by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'VLAN ID',
                            content:
                                'If VLAN for the WAN port is enabled, you need to enter a VLAN ID. Then the WAN port is automatically assigned to the VLAN. By default, the egress rule of the VLAN is UNTAG, so the packets are transmitted by the WAN port without VLAN tags. If you want the WAN port to transmit packets with VLAN tag, you need to configure its egress rule as TAG. To configure VLANs, go to Network > VLAN > VLAN.'
                        },
                        {
                            type: 'name',
                            title: 'Secondary Connection',
                            content:
                                'Select the secondary connection type according to the requirements of your ISP. The secondary connection is required for PPTP connection. The router will get some necessary information after the secondary connection succeeded. The information will be used in the PPTP connection process.</br>&nbsp&nbsp&nbsp&nbspDynamic IP: If you select the secondary connection type as Dynamic IP, the router set up the secondary connection dynamically.</br>&nbsp&nbsp&nbsp&nbspStatic IP: If you select the secondary connection type as Static IP, you need to configure IP Address, Subnet Mask, Default Gateway, Primary/Second DNS for the secondary connection.'
                        },
                        {
                            type: 'name',
                            title: 'VPN Server IP/Domain Name',
                            content: 'Enter the VPN Server/Domain Name provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'IP Address',
                            content: 'Enter the IP address provided by your ISP for the secondary connection.'
                        },
                        {
                            type: 'name',
                            title: 'Subnet  Mask',
                            content: 'Enter the subnet mask provided by your ISP for the secondary connection.'
                        },
                        {
                            type: 'name',
                            title: 'Default Gateway',
                            content: 'Enter the default gateway provided by your ISP for the secondary connection.'
                        },
                        {
                            type: 'name',
                            title: 'Primary/Secondary DNS',
                            content: 'Enter the primary/secondary DNS provided by your ISP for the secondary connection.'
                        },
                        {
                            type: 'name',
                            title: 'Connect',
                            content: 'Click this button to connect to the internet.'
                        },
                        {
                            type: 'name',
                            title: 'Disconnect',
                            content: 'Click this button to disconnect from the internet.'
                        }
                    ]
                }
            ]
        },

        WAN_STATUS: {
            TITLE: 'Connection Status',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the connection status of the current WAN port.'
                }
            ]
        },
        INTERFACE_LAN: {
            TITLE: 'LAN',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can configure the parameters of the LAN port on this page.'
                },
                {
                    type: 'name',
                    title: 'IP Address',
                    content:
                        'Enter the LAN IP address of the router. In the LAN, the default gateway address for all hosts must be the same as this one.'
                },
                {
                    type: 'name',
                    title: 'Subnet Mask',
                    content:
                        'Enter the subnet mask (255.255.255.0 by default). In the LAN, the subnet mask for all hosts must be the same as this one.'
                },
                {
                    type: 'name',
                    title: 'Management Vlan',
                    content:
                        'Only the hosts in this VLAN can manage this router. If not selected, it means all the computers in the LAN can manage this router.'
                }
            ]
        },

        INTERFACE_LAN_INTRODUCT: {
            TITLE: 'Introduction',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'When the LAN ports of the router connect to your local network devices, the router functions as the gateway, which allows those devices to connect to the internet.</br></br>To configure the LAN network, follow the guidelines:'
                },
                {
                    type: 'pearlStep',
                    content: [
                        'If you want the LAN clients to connect to the internet via the router, you need first to add and set up the LAN network with the desired VLAN and IP address. Choose to enable DHCP server or DHCP Relay so that the LAN clients get IP addresses automatically. After the DHCP server assigns IP address to the clients, you can view them in the DHCP Client List.',
                        '(Optional) If you want to reserve IP addresses for certain LAN clients, configure Address Reservation.',
                        '(Optional) With LAN Settings, you can set up IGMP Proxy.'
                    ]
                }
            ]
        },

        INTERFACE_LAN_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'In Network List, set up the LAN network or click %<{"type":"addSpan","text":"Add"}>% to add new networks, and configure the related parameters.',
                        '(Optional) In Settings, set up IGMP Proxy.'
                    ]
                }
            ]
        },

        INTERFACE_LAN_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'IGMP Proxy',
                    content:
                        'If you want the local network devices to receive multicast data from the Internet, check the box to enable IGMP Proxy. This feature is used to detect whether there is any multicast member connected to the LAN ports.'
                },
                {
                    type: 'name',
                    title: 'IGMP Version',
                    content: 'Configure the IGMP version as V2 or V3 according to your ISP.'
                },
                {
                    type: 'name',
                    title: 'IGMP Interface',
                    content: 'Select the interface on which the IGMP Proxy takes effect.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Enter the name of the LAN network. This is the unique identifier for the LAN network.'
                },
                {
                    type: 'name',
                    title: 'IP Address',
                    content:
                        'Enter the IP address of the LAN port. To make your local network devices connect to the internet, you need to set the IP address of the LAN port as the default gateway of those devices.'
                },
                {
                    type: 'name',
                    title: 'Subnet Mask',
                    content:
                        'Enter the subnet mask of the LAN port (255.255.255.0 by default). The IP addresses of all devices which connect to the LAN ports should be in the same subnet as the IP address of the LAN port.'
                },
                {
                    type: 'name',
                    title: 'VLAN',
                    content: 'Specify the VLAN of the LAN port, only the devices in the specified VLAN can access and manage the gateway.'
                },
                {
                    type: 'name',
                    title: 'DHCP Mode -- DHCP Server',
                    content:
                        'If you select DPCP Server as DHCP Mode, the DHCP server of the gateway will assign IP addresses to the LAN clients. Configure the following parameters.',
                    children: [
                        {
                            type: 'name',
                            title: 'Status',
                            content: 'Check the box to enable DHCP Server.'
                        },
                        {
                            type: 'name',
                            title: 'Starting IP Address / Ending IP Address',
                            content:
                                'Enter the starting IP address and ending IP address of the DHCP server’s IP pool. The IP pool defines the range of IP addresses that can be assigned to the LAN clients. Note that the starting IP address and ending IP address should be in the same subnet as the IP address of the LAN port.'
                        },
                        {
                            type: 'name',
                            title: 'Lease Time',
                            content:
                                'Specify the lease time for DHCP clients. Lease time defines how long the clients can use the IP address assigned by the DHCP server. Generally, the client will automatically request the DHCP server for extending the lease time before the lease expired. If the request fails, the client will have to stop using that IP address when the lease finally expired, and try to get a new IP address from another DHCP server.'
                        },
                        {
                            type: 'name',
                            title: 'Default Gateway',
                            content:
                                '(Optional) Enter the default gateway which is assigned by the DHCP server. It is recommended to enter the IP address of the LAN port.'
                        },
                        {
                            type: 'name',
                            title: 'Default Domain',
                            content: '(Optional) Enter the domain name of your network.'
                        },
                        {
                            type: 'name',
                            title: 'Primary DNS / Secondary DNS',
                            content:
                                '(Optional) Enter the DNS server address provided by your ISP. If you are not clear, please consult your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Option60',
                            content:
                                '(Optional) Enter the value for DHCP Option 60. DHCP clients use this field to optionally identify the vendor type and configuration of a DHCP client. Mostly, it is used in the scenario where the APs apply for different IP addresses from different servers according to the needs. For detailed information, please consult the vendor. For TP-Link, this entry should be TP-Link.'
                        },
                        {
                            type: 'name',
                            title: 'Option66',
                            content:
                                '(Optional) Enter the value for DHCP Option 66. It specifies the TFTP server information and supports a single TFTP server IP address.'
                        },
                        {
                            type: 'name',
                            title: 'Option67',
                            content: '(Optional) Enter the value for DHCP Option 67. It specifies the boot file name.'
                        },
                        {
                            type: 'name',
                            title: 'Option138',
                            content:
                                '(Optional) Enter the value for DHCP Option 138. It is used in discovering the devices by the Omada controller.'
                        },
                        {
                            type: 'name',
                            title: 'Option150',
                            content:
                                '(Optional) Enter the value for DHCP Option 150. It specifies the TFTP server information and supports multiple TFTP server IP addresses.'
                        },
                        {
                            type: 'name',
                            title: 'Option159',
                            content:
                                '(Optional) Enter the value for DHCP Option 159. This option is used to configure a set of ports bound to a shared IPv4 address.'
                        },
                        {
                            type: 'name',
                            title: 'Option160',
                            content: '(Optional) Enter the value for DHCP Option 160. This option is used to configure DHCP captive portal.'
                        },
                        {
                            type: 'name',
                            title: 'Option176',
                            content:
                                '(Optional) Enter the value for DHCP Option 176. This option is used to configure parameters for IP phones.'
                        },
                        {
                            type: 'name',
                            title: 'Option242',
                            content:
                                '(Optional) Enter the value for DHCP Option 242. This option is used to provide the TMS address automatically.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'DHCP Mode -- DHCP Relay',
                    content:
                        'If you select DHCP Relay as DHCP Mode, the gateway will relay DHCP requests from LAN clients to the DHCP server in another network. Then the DHCP server will assign IP addresses to the LAN clients. Configure the following parameters.',
                    children: [
                        {
                            type: 'name',
                            title: 'Status',
                            content: 'Check the box to enable DHCP Relay.'
                        },
                        {
                            type: 'name',
                            title: 'Server Address',
                            content: 'Enter the IP address of the DHCP server.'
                        }
                    ]
                }
            ]
        },

        DHCP_CLIENT_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view all the devices which has got IP addresses from the DHCP server in the DHCP Client List.'
                }
            ]
        },

        DHCP_CLIENT_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Client Name',
                    content:
                        'Displays the host name of the DHCP client. It should be composed of digits, English letters, dashes and underscores only.'
                },
                {
                    type: 'name',
                    title: 'MAC Address',
                    content: 'Displays the MAC address of the DHCP client.'
                },
                {
                    type: 'name',
                    title: 'Assigned IP Address',
                    content: 'Displays the IP address assigned to the DHCP client.'
                },
                {
                    type: 'name',
                    title: 'Lease Time',
                    content:
                        'Displays the remaining lease time of the assigned IP address. After the lease expires, the IP address will be re-assigned.'
                }
            ]
        },

        DHCP_STATIC_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>%.',
                        'Configure the parameters for the address reservation entry, including MAC address, IP Address, and so on.'
                    ]
                }
            ]
        },

        DHCP_STATIC_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'MAC Address',
                    content: 'Enter the MAC address of the client.'
                },
                {
                    type: 'name',
                    title: 'IP Address',
                    content: 'Enter the IP address to be reserved.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: '(Optional) Enter a brief description for the entry. Up to 32 characters can be entered.'
                },
                {
                    type: 'name',
                    title: 'Export to IP-MAC Binding',
                    content:
                        '(Optional) Check the box to export this binding entry to IP-MAC Binding List on Firewall > Anti ARP Spoofing > IP-MAC Binding page.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable this entry.'
                }
            ]
        },

        INTERFACE_MAC_INTRODUCT: {
            TITLE: 'Introduction',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Generally, the MAC address does not need to be changed. However, in the following situations, you may need to change the MAC address of the WAN port or LAN port.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Configure the MAC Address of the WAN port: </br>In the condition that your ISP has bound your account to the MAC address of the dial- up device, if you want to replace the dial-up device with this router, you can just set the MAC address of this router’s WAN port the same as that of the previous dial-up device for a normal internet connection.',
                                'Configure the MAC Address of the LAN port: </br>In a complex network where all the devices are ARP bound, if you want to replace the current router with this router, you can just set the MAC address of this router’s LAN port the same as that of the previous router, which avoids updating ARP binding tables of all devices in your local network.'
                            ]
                        }
                    ]
                }
            ]
        },

        IPTV_INTRODUCT: {
            TITLE: 'IPTV',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Configure IPTV settings to enable Internet/IPTV/Phone service provided by your ISP (internet service provider).'
                }
            ]
        },

        IPTV_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Enable IPTV globally.',
                        'Chose the Wan Port according to your ISP.',
                        'Select the appropriate Mode according to your ISP.',
                        'Select the Port Mode to determine which port is used to support IPTV service, IP-Phone service, or internet service.',
                        'Click %<{"type":"button","text":"Save"}>%.'
                    ]
                }
            ]
        },

        IPTV_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'IPTV',
                    content: 'Enable IPTV globally.'
                },
                {
                    type: 'name',
                    title: 'Wan Port',
                    content: 'Select the Wan Port according to your ISP.'
                },
                {
                    type: 'name',
                    title: 'Mode',
                    content: 'Select the appropriate Mode according to your ISP.',
                    children: [
                        {
                            type: 'name',
                            title: 'Bridge',
                            content: 'Select this mode if your ISP requires no other parameters.'
                        },
                        {
                            type: 'name',
                            title: 'Custom',
                            content:
                                'Select this mode if your ISP provides necessary parameters, and configure the parameters according to the requirements of your ISP.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Port Mode',
                    content:
                        'Select the appropriate Port Mode of the LAN ports to determine which port is used to support Internet service, IPTV service, or IP-Phone service.'
                }
            ]
        },

        INTERFACE_MAC_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Interface Name',
                    content: 'Displays the WAN port and LAN port.'
                },
                {
                    type: 'name',
                    title: 'Current MAC Address',
                    content: 'Configure the MAC address of the WAN port or LAN port.'
                },
                {
                    type: 'name',
                    title: 'MAC Clone',
                    content:
                        'MAC Clone provides a shortcut to changing the MAC Address.</br>&nbsp&nbsp&nbsp&nbspRestore Factory MAC: Click  this  button to restore the MAC address to the factory default value.</br>&nbsp&nbsp&nbsp&nbspClone Current PC’s MAC: Click this button to clone the MAC address of the PC you are currently using to configure the router. It’s only available for the WAN ports.'
                },
                {
                    type: 'note',
                    title: 'Note ',
                    content: [
                        'When cloning curent management host’s MAC on the WAN port, the management PC should be connected to the LAN port.',
                        'If the connection type on the WAN port is PPPoE, L2TP or PPTP, changing the MAC address of the WAN port may cause the connection to be terminated or re-established.'
                    ]
                }
            ]
        },

        SWITCH_MONITOR_INTRODUCT: {
            TITLE: 'Introduction',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'The router provides the following switching features.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Statistics (Only for Certain Devices)</br>You can view the detailed traffic information of each port, which facilitates you to monitor the traffic and manage the network effectively.',
                                'Mirror</br>Port Mirror function allows the router to forward packet copies of the monitored ports to a specific monitoring port. Then you can analyze the copied packets to monitor network traffic and troubleshoot network problems.',
                                'Rate Control (Only for Certain Devices)</br>You can set limit to the traffic rate for the specific packets on each port to manage the traffic flow of your network.',
                                'Port Config</br>You can configure the flow control feature and negotiation mode for the port.',
                                'Port Status</br>You can view the status and parameters of each port.'
                            ]
                        }
                    ]
                }
            ]
        },

        SWITCH_MONITOR_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'In the Settings section, enable Port Mirror function, and choose the mirror mode.',
                        'In the Monitor List section, set the mirroring port and the mirrored port(s), then click %<{"type":"button","text":"Save"}>%.'
                    ]
                }
            ]
        },

        SWITCH_MONITOR_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Enable Port Mirror',
                    content: 'Check the box to enable Port Mirror function.'
                },
                {
                    type: 'name',
                    title: 'Mirror Mode',
                    content: 'Check the box to enable Port Mirror function.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Ingress: The packets received by the mirrored port will be copied to the mirroring port.',
                                'Egress: The packets sent by the mirrored port will be copied to the mirroring port.',
                                'Ingress and Egress: Both the incoming and outgoing packets through the mirrored port will be copied to the mirroring port'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Mirroring Port',
                    content:
                        'The packets through the mirrored port will be copied to this port. Usually, the mirroring port is connected to a data diagnose device, which is used to analyze the mirrored packets for monitoring and troubleshooting the network.'
                },
                {
                    type: 'name',
                    title: 'Mirrored Port',
                    content:
                        'The packets through this port will be copied to the mirroring port. Usually, the mirrored ports are the ports to be monitored.'
                },
                {
                    type: 'note',
                    title: 'Note ',
                    content: [
                        'A port cannot be configured as the mirrored port and the mirroring port simultaneously.',
                        'Only one port can be configured as the mirroring port.'
                    ]
                }
            ]
        },

        SWITCH_PORT_STATISTICS: {
            TITLE: 'Statistics List',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'You can view the detailed traffic information of each port, which facilitates you to monitor the traffic and manage the network effectively.'
                },
                {
                    type: 'name',
                    title: 'Unicast',
                    content: 'Displays the number of normal unicast packets received or transmitted on the port.'
                },
                {
                    type: 'name',
                    title: 'Broadcast',
                    content: 'Displays the number of normal broadcast packets received or transmitted on the port.'
                },
                {
                    type: 'name',
                    title: 'Pause',
                    content: 'Displays the number of flow control frames received or transmitted on the port.'
                },
                {
                    type: 'name',
                    title: 'Mulitcast',
                    content: 'Displays the number of normal multicast packets received or transmitted on the port.'
                },
                {
                    type: 'name',
                    title: 'Total',
                    content: 'Displays the total bytes of the received or transmitted packets (including error frames).'
                },
                {
                    type: 'name',
                    title: 'Undersize',
                    content: 'Displays the number of received packets which have a length less than 64 bytes (including error frames).'
                },
                {
                    type: 'name',
                    title: 'Normal',
                    content:
                        'Displays the number of received packets which have length between 64 bytes and the maximum frame length (including error frames).'
                },
                {
                    type: 'name',
                    title: 'Oversize',
                    content:
                        'Displays the number of received packets that have a length greater than the maximum frame length (including error frames).'
                },
                {
                    type: 'name',
                    title: 'Refresh',
                    content: 'Click Refresh to view the latest traffic statistics of each port.'
                },
                {
                    type: 'name',
                    title: 'Clear',
                    content: 'Click Clear to clear all the traffic statistcs.'
                },
                {
                    type: 'note',
                    title: 'Note ',
                    content: [
                        'Error frame: The frames that have a false checksum.',
                        "Maximum frame length: The maximum frame length supported by the router. For untagged frames, it's 1518 bytes long; for tagged packets, it's 1522 bytes long."
                    ]
                }
            ]
        },
        SWITCH_MONITOR_ENABLE: {
            TITLE: 'Enable Port Mirror',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'Check the box to enable Port Mirror function. There are three Mirror Modes:',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Ingress and Egress: Both the incoming and outgoing packets through the mirrored port will be copied to the mirroring port.',
                                'Ingress: The packets received by the mirrored port will be copied to the mirroring port.',
                                'Egress: The packets sent by the mirrored port will be copied to the mirroring port.'
                            ]
                        }
                    ]
                }
            ]
        },
        SWITCH_MONITOR_SETTING: {
            TITLE: 'Monitor List',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Mirroring Port',
                    content: 'The packets through the mirrored port will be copied to this port.'
                },
                {
                    type: 'name',
                    title: 'Mirrored Port',
                    content: 'The packets through this port will be copied to the mirroring port.'
                },
                {
                    type: 'note',
                    title: 'Note ',
                    content: [
                        'A port cannot be configured as the mirrored port and the mirroring port simultaneously.',
                        'Only one port can be configured as the mirroring port.'
                    ]
                }
            ]
        },
        SWITCH_PORTLIMIT: {
            TITLE: 'Rate Control',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can limit the traffic rate for the specific packets on each port to manage the network flow on this page.'
                },
                {
                    type: 'name',
                    title: 'Ingress Limit',
                    content: 'Check the box to enable the Ingress Limit feature.'
                },
                {
                    type: 'name',
                    title: 'Ingress Frame Type',
                    content: 'Specify the ingress frame type to be limited. It is All Frames by default.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'All Frames: The ingress rate of all frames is limited.',
                                'Broadcast: The ingress rate of broadcast frames is limited.',
                                'Broadcast and Multicast: The ingress rate of broadcast and multicast frames is limited.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Ingress Rate(Mbps)',
                    content: 'Specify the limit rate for the ingress packets.'
                },
                {
                    type: 'name',
                    title: 'Egress Limit',
                    content: 'Check the box to enable Egress Limit feature.'
                },
                {
                    type: 'name',
                    title: 'Egress Rate(Mbps)',
                    content: 'Specify the limit rate for the egress packets.'
                }
            ]
        },
        SWICH_PARAMETER: {
            TITLE: 'Port Config',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can configure the basic parameters of the port.'
                },
                {
                    type: 'name',
                    title: 'Flow Control',
                    content: 'Check the box to enable Flow Control function for the port.'
                },
                {
                    type: 'name',
                    title: 'Negotiation Mode',
                    content:
                        'Select the Negotiation Mode for the port. You can select Auto (Auto-negoation), or manually select the speed and duplex mode.'
                }
            ]
        },
        SWITCH_STATUS: {
            TITLE: 'Port Status',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the status of each port on this page.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'There are two types of port status:',
                    children: [
                        {
                            type: 'step',
                            content: ['Link Down: The port is not connected.', 'Link Up: The port is working normally.']
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Speed(Mbps)',
                    content: 'Displays the speed of the port.'
                },
                {
                    type: 'name',
                    title: 'Duplex Mode',
                    content: 'Displays the duplex mode, including Full-duplex and Half-duplex.'
                },
                {
                    type: 'name',
                    title: 'Flow Control',
                    content: 'Displays if the Flow Control is enabled.'
                }
            ]
        },
        VLAN_VLAN_SETTING: {
            TITLE: 'VLAN Settings',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'By creating VLANs, you can divide the LAN into multiple logical LANs, which lets you flexibly control the communication among the ports.'
                },
                {
                    type: 'name',
                    title: 'VLAN ID',
                    content:
                        'VLAN ID is used to specify the ID of VLAN TAG in IEEE 802.1Q, which identifies the number of VLANs the packets belong to. Ports in the same VLAN can communicate with each other. Ports in different VLANs cannot communicate directly.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the name of the VLAN for easy identification.'
                },
                {
                    type: 'name',
                    title: 'Ports',
                    content: 'Specify the port type in the specified VLAN. The ports can be divided into two types: TAG or UNTAG.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for easy management and searching.'
                }
            ]
        },
        VLAN_VLAN_INTRODUCT: {
            TITLE: 'Introduction',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'VLAN enables you to divide the LAN into multiple logical networks and control the traffic among them in a convenient and flexible way. The LAN can be logically segmented by departments, application, or types of users, without regard to geographic locations.</br></br>To configure VLANs, follow the guidelines:',
                    children: [
                        {
                            type: 'pearlStep',
                            content: ['Create VLANs and add the desired ports to the VLANs.', 'Configure the PVID of the ports.']
                        }
                    ]
                },
                {
                    type: 'note',
                    title: 'Note ',
                    content: [
                        'Typically, the WAN is separated from the LAN. VLAN configuration of the WAN is determined by the requirements of your ISP and should be set accordingly.',
                        'If your PC is not in the same VLAN as the LAN port of the router, you cannot manage the router using the web interface. To configure the VLAN of the LAN port, go to Network > LAN > LAN.'
                    ]
                }
            ]
        },
        VLAN_VLAN_EXAMPLE: {
            TITLE: 'Configuration Example',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Network Requirements',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'The network topology of a home office is shown below. PC A and PC B belong to workgroup 1, whereas PC C and PC D belong to workgroup 2. The four PCs are connected to different LAN ports of the router, namely Port 2 - Port 5.',
                                'To improve network efficiency and enhance security, the network administrator needs to divide different workgroups into different networks so that PCs in different groups cannot communicate with each other directly.'
                            ]
                        },
                        {
                            type: 'img',
                            title: '',
                            imgName: 'VLAN-1.png',
                            alt: 'img!!!'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Configuration Scheme',
                    content:
                        'To meet the above requirements, configure segmented networks based on 802.1Q VLAN. Configure networks according to the following table.',
                    children: [
                        {
                            type: 'img',
                            title: '',
                            imgName: 'VLAN-2.png',
                            alt: 'img!!!'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Configuration Procedure',
                    content: 'The following part outlines the configuration procedure, including fundamental parameters and steps.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Create VLANs and add the desired ports to the VLANs On the VLAN tab, click	to create two new VLANs respectively. The following chart shows the basic information of VLANs.'
                            ]
                        },
                        {
                            type: 'img',
                            title: '',
                            imgName: 'VLAN-3.png',
                            alt: 'img!!!'
                        },
                        {
                            type: 'step',
                            content:
                                'Configure the PVID of the ports.</br>On the Ports tab, configure the PVID of the ports according to the following chart.'
                        },
                        {
                            type: 'img',
                            title: '',
                            imgName: 'VLAN-4.png',
                            alt: 'img!!!'
                        }
                    ]
                }
            ]
        },

        VLAN_VLAN_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>%.',
                        'Create the VLAN and add the desired ports to the VLAN. Devices connnected to the ports in the same VLAN can communicate with each other, whereas devices connected to the ports in different VLANs cannot communicate with each other.'
                    ]
                }
            ]
        },

        VLAN_VLAN_PARA: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'name',
                    title: 'VLAN ID',
                    content: 'Enter a VLAN ID. The value ranges from 1 to 4094'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the name of the VLAN for easy identification'
                },
                {
                    type: 'name',
                    title: 'Ports',
                    content:
                        'Check the box to add the desired port to the VLAN and specify the port type in the specified VLAN. The port can be divided into two types: TAG or UNTAG.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'TAG: The egress rule of the packets transmitted by the port is tagged.',
                                'UNTAG: The egress rule of the packets transmitted by the port is untagged. If the device connected to the port is an end device, like a PC or a server, the port type should be UNTAG, because end devices don’t recognize tagged packets.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: '(Optional) Enter a brief description for easy management and searching.'
                }
            ]
        },

        VLAN_PORT_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Configure the PVID of the port. PVID indicates the default VLAN for the corresponding port. Untagged packets which are received by the port are tagged with the PVID and then transmitted within the corresponding VLAN.</br></br>For example, if Port 2 is in both VLAN 10 and VLAN 20, and the PVID of the port is 10, when Port 2 receives an untagged packet from a PC, the packet is transmitted within VLAN 10, but cannot reach VLAN 20 directly.'
                }
            ]
        },

        VLAN_PORT_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Port',
                    content: 'Displays the Port.'
                },
                {
                    type: 'name',
                    title: 'PVID',
                    content: 'Specify the PVID for the port. PVID indicates the default VLAN for the corresponding port.'
                },
                {
                    type: 'name',
                    title: 'VLAN',
                    content: 'Displays the VLAN(s) the port belongs to.'
                }
            ]
        },

        VLAN_VLAN_SETTING_NO_GENERAL: {
            TITLE: 'VLAN Settings',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'By creating VLANs, you can divide the LAN into multiple logical LANs, which lets you flexibly control the communication among the ports.'
                },
                {
                    type: 'name',
                    title: 'VLAN ID',
                    content:
                        'VLAN ID is used to specify the ID of VLAN TAG in IEEE 802.1Q, which identifies the number of VLANs the packets belong to. Ports in the same VLAN can communicate with each other. Ports in different VLANs cannot communicate directly.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the name of the VLAN for easy identification.'
                },
                {
                    type: 'name',
                    title: 'Ports',
                    content: 'Specify the port type in the specified VLAN. The ports can be divided into two types: TAG or UNTAG.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for easy management and searching.'
                }
            ]
        },
        VLAN_VLANLIST: {
            TITLE: 'VLAN List',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'View the VLAN information in the list and customize the VLAN settings by pressing the buttons.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: [
                        '1. Some VLANs are automatically and randomly referenced by the system, and cannot be edited or deleted. When the WAN mode or IPTV settings are changed, the referenced VLANs may be different.',
                        '2. For more VLAN settings, please go to the Ports page.'
                    ]
                }
            ]
        },
        VLAN_PORT_SETTING: {
            TITLE: 'Ports',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can change the PVID on this page according to your network deployment.'
                },
                {
                    type: 'name',
                    title: 'PVID',
                    content: 'Specify the PVID for the ports.'
                },
                {
                    type: 'name',
                    title: 'VLAN',
                    content: 'Displays the VLAN(s) the port belongs to.'
                }
            ]
        },
        VLAN_PORT_SETTING_NO_GENERAL: {
            TITLE: 'Ports',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can change the PVID on this page according to your network deployment.'
                },
                {
                    type: 'name',
                    title: 'PVID',
                    content: 'Specify the PVID for the ports.'
                },
                {
                    type: 'name',
                    title: 'VLAN',
                    content: 'Displays the VLAN(s) the port belongs to.'
                }
            ]
        },
        VLAN_RELATION_TABLE: {
            TITLE: 'Relations',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the port and its VLAN information on this page.'
                },
                {
                    type: 'name',
                    title: 'VLAN',
                    content: 'Displays the VLAN(s) the port belongs to.'
                }
            ]
        },

        IPV6_LAN_INTRODUCT: {
            TITLE: 'Introduction',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'IPv6 is the next-generation network protocol following IPv4. You can configure IPv6 network for the router if your ISP supports IPv6. IPv6 network won’t cause conflict with your current IPv4 network.</br></br>To configure the IPv6 network, follow the guidelines:'
                },
                {
                    type: 'pearlStep',
                    content: [
                        'Configure IPv6 for the LANs.',
                        'Configure IPv6 for the WAN/SFP WAN port(s). You can configure IPv6 for multiple WANs, and each WAN port has its own Internet Connection Type and parameters.'
                    ]
                }
            ]
        },

        IPV6_LAN_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Select the desired VLAN to configure IPv6 for the VLAN, and click %<{"type":"editSpan","text":""}>%.',
                        'Select the proper Assigned Type, which is determined by the compatibility of clients in your local network, and configure the parameters according to the requirements of your ISP. Then click %<{"type":"button","text":"OK"}>%.'
                    ]
                }
            ]
        },

        IPV6_LAN_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Assigned Type',
                    content:
                        'Determines the method whereby the gateway assigns IPv6 addresses to the clients in your local network. Some clients may support only a few of these assigned types, so you should choose it according to the compatibility of clients in your local network.'
                },
                {
                    type: 'name',
                    title: 'None',
                    content: 'Disable IPv6 of the LAN port.'
                },
                {
                    type: 'name',
                    title: 'DHCPv6',
                    content:
                        'The gateway assigns an IPv6 address and other parameters including the DNS server address to each client using DHCPv6.',
                    children: [
                        {
                            type: 'name',
                            title: 'IPv6 Address',
                            content: 'Enter the IPv6 address and prefix length (subnet mask).'
                        },
                        {
                            type: 'name',
                            title: 'File Suffix',
                            content:
                                'Enter file suffixes to specify the file types. Use Enter key, Space key, "," or ";" to divide different file suffixes. The hosts of the selected IP group cannot download these types of files from the internet.'
                        },
                        {
                            type: 'name',
                            title: 'DHCP Range',
                            content:
                                'Enter the starting and ending IPv6 address to define a range for the DHCPv6 server to assign dynamic IPv6 addresses.'
                        },
                        {
                            type: 'name',
                            title: 'Lease Time',
                            content:
                                'The duration time in minutes when the assigned IPv6 address remains valid. Either keep the defualt 1440 minutes or change it if required.'
                        },
                        {
                            type: 'name',
                            title: 'DNS Address',
                            content:
                                'Select a method to configure the DNS server for the LAN, with Auto selected, the DNS server addresses are automatically obtained. With Manual DNS selected, manually enter the primary and secondary DNS server addresses provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Address',
                            content: 'Displays the IPv6 address of the LAN port.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'SLAAC+Stateless DHCP',
                    content:
                        'The gateway assigns the IPv6 address prefix to each client and the client automatically generates its own IPv6 address. Also, the gateway assigns other parameters including the DNS server address to each client using DHCPv6.',
                    children: [
                        {
                            type: 'name',
                            title: 'Prefix',
                            content:
                                'Configure the IPv6 address prefix for each client in the local network. WIth Manual Prifix selected, enter the prefix in the Address Prefix field. With Get from Prefix Delegation selected, select hte IPv6 Prefix Delegation WAN port, and enter the IPv6 Prefix ID to get a prefix delegation from the ISP.'
                        },
                        {
                            type: 'name',
                            title: 'IPv6 Prefix Delegation WAN',
                            content:
                                'Enter the IPv6 Prefix Delegation WAN port and the IPv6 Prefix ID to get a prefix delegation from the ISP.'
                        },
                        {
                            type: 'name',
                            title: 'IPv6 Prefix ID',
                            content:
                                'With Get from Prefix Delegation selected, enter the Prefix ID, which will be addred to the prefix to obtain a /64 subnet. The range of IPv6 Prefix ID is determined by Prefix Delegation Size and Prefix Length.'
                        },
                        {
                            type: 'name',
                            title: 'DNS Address',
                            content:
                                'Select a method to configure the DNS server for the LAN. With Auto selected, the DNS server addresses are automatically obtained. With Manual DNS selected, manually enter the primary and secondary DNS server addresses provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Address',
                            content: 'Displays the IPv6 address automatically generated by Prefix.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'SLAAC+RDNSS',
                    content:
                        'The gateway assigns the IPv6 address prefix to each client and the client automatically generates its own IPv6 address. Also, the gateway assigns other parameters including the DNS server address to each client using the RDNSS option in RA (Router Advertisement).',
                    children: [
                        {
                            type: 'name',
                            title: 'Prefix',
                            content:
                                'Configure the IPv6 address prefix for each client in the local network. WIth Manual Prifix selected, enter the prefix in the Address Prefix field. With Get from Prefix Delegation selected, select hte IPv6 Prefix Delegation WAN port, and enter the IPv6 Prefix ID to get a prefix delegation from the ISP.'
                        },
                        {
                            type: 'name',
                            title: 'IPv6 Prefix Delegation WAN',
                            content:
                                'Enter the IPv6 Prefix Delegation WAN port and the IPv6 Prefix ID to get a prefix delegation from the ISP.'
                        },
                        {
                            type: 'name',
                            title: 'IPv6 Prefix ID',
                            content:
                                'With Get from Prefix Delegation selected, enter the Prefix ID, which will be addred to the prefix to obtain a /64 subnet. The range of IPv6 Prefix ID is determined by Prefix Delegation Size and Prefix Length.'
                        },
                        {
                            type: 'name',
                            title: 'DNS Address',
                            content:
                                'Select a method to configure the DNS server for the LAN. With Auto selected, the DNS server addresses are automatically obtained. With Manual DNS selected, manually enter the primary and secondary DNS server addresses provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Address',
                            content: 'Displays the IPv6 address automatically generated by Prefix.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Pass-Through (Bridge)',
                    content: 'Select this type if the WAN ports of the gateway use the Pass-Through for IPv6 connections.',
                    children: [
                        {
                            type: 'name',
                            title: 'IPv6 Passthrough WAN',
                            content: 'Select the WAN port using Pass-Through (Bridge) for the IPv6 connection.'
                        }
                    ]
                }
            ]
        },

        IPV6_WAN_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Choose a WAN/SFP WAN port, and click the corresponding tab.',
                        'In the General section, enable IPv6 and click %<{"type":"button","text":"Save"}>%.',
                        'In the Internet section, select the proper Internet Connection Type and configure the parameters according to the requirements of your ISP. Then click %<{"type":"button","text":"Save"}>%.'
                    ]
                }
            ]
        },

        IPV6_WAN_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Internet Connection Type',
                    content: 'Choose the proper Internet Connection Type according to the requirements of your ISP.'
                },
                {
                    type: 'name',
                    title: 'Static IP',
                    content: 'Select this type if your ISP provides you with a static IPv6 address.',
                    children: [
                        {
                            type: 'name',
                            title: 'IPv6 Address/Prefix Length/Default Gateway/Primary DNS/Secondary DNS',
                            content: 'Enter these parameters as provided by the ISP.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Dynamic IP (SLAAC/DHCPv6)',
                    content: 'Select this type if your ISP uses Dynamic IPv6 address assignment, either DHCPv6 or SLAAC+Stateless DHCP.',
                    children: [
                        {
                            type: 'name',
                            title: 'IPv6 Address/Primary DNS/Secondary DNS',
                            content: 'These parameters are automatically assigned by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Renew',
                            content: 'Click this button to get new IPv6 parameters assigned by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Release',
                            content: 'Click this button to release all IPv6 address assigned by your ISP.'
                        },
                        {
                            type: 'paragraph',
                            content: '<b>Advanced</b>'
                        },
                        {
                            type: 'name',
                            title: 'Get IPv6 Address',
                            content:
                                'Select the proper method whereby your ISP assigns IPv6 address to your gateway.</br>&nbsp&nbsp&nbsp&nbspAuto: Select Auto to get an IPv6 address automatically.</br>&nbsp&nbsp&nbsp&nbspDHCPv6: Your ISP assigns an IPv6 address and other parameters including the DNS server address to your gateway using DHCPv6.</br>&nbsp&nbsp&nbsp&nbspSLAAC+Stateless DHCP: Your ISP assigns the IPv6 address prefix to your gateway and your gateway automatically generates its own IPv6 address. Also, your ISP assigns other parameters including the DNS server address to your gateway using DHCPv6.'
                        },
                        {
                            type: 'name',
                            title: 'Prefix Delegation',
                            content:
                                'Select Enable to get an address prefix for your LAN port from your ISP, or Disable to designate an address prefix for your LAN port manually. Clients in LAN will get an IPv6 address with this prefix.'
                        },
                        {
                            type: 'name',
                            title: 'Prefix Delegation Size',
                            content:
                                'With Prefix Delegation enabled, enter the Prefix Delegation Size to determine the length of the address prefix. You can get this value from your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'DNS Address',
                            content:
                                'Select whether to get the DNS address dynamically from your ISP or designate the DNS address manually.'
                        },
                        {
                            type: 'name',
                            title: 'Get dynamically from ISP',
                            content: 'Your ISP assigns an DNS address to your gateway dynamically.'
                        },
                        {
                            type: 'name',
                            title: 'Use the following DNS Addresses',
                            content: 'You should manually enter the DNS address provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Primary DNS/Secondary DNS',
                            content: 'Enter the DNS address manually or display the DNS address which is assigned by your ISP.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'PPPoE',
                    content: 'Select this type if your ISP uses PPPoEv6, and provides a username and password.',
                    children: [
                        {
                            type: 'name',
                            title: 'PPPoE same session with IPv4 connection',
                            content: 'If this option is enabled, IPv6 uses the same PPPoE session as IPv4.'
                        },
                        {
                            type: 'name',
                            title: 'Username/Password',
                            content: 'Enter these parameters as provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'IPv6 Address',
                            content:
                                'This address will be automatically assigned by your ISP after you enter the username and password and click Connect.'
                        },
                        {
                            type: 'paragraph',
                            content: '<b>Advanced</b>'
                        },
                        {
                            type: 'name',
                            title: 'Get IPv6 Address',
                            content:
                                'Select the proper method whereby your ISP assigns IPv6 address to your gateway.</br>&nbsp&nbsp&nbsp&nbspAuto: Select Auto to get an IPv6 address automatically.</br>&nbsp&nbsp&nbsp&nbspDHCPv6: Your ISP assigns an IPv6 address and other parameters including the DNS server address to your gateway using DHCPv6.</br>&nbsp&nbsp&nbsp&nbspSLAAC+Stateless DHCP: Your ISP assigns the IPv6 address prefix to your gateway and your gateway automatically generates its own IPv6 address. Also, your ISP assigns other parameters including the DNS server address to your gateway using DHCPv6.</br>&nbsp&nbsp&nbsp&nbspSpecified by ISP: You should manually enter the IPv6 address provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Prefix Delegation',
                            content:
                                'Select Enable to get an address prefix for your LAN port from your ISP, or Disable to designate an address prefix for your LAN port manually. Clients in LAN will get an IPv6 address with this prefix.'
                        },
                        {
                            type: 'name',
                            title: 'Prefix Delegation Size',
                            content:
                                'With Prefix Delegation enabled, enter the Prefix Delegation Size to determine the length of the address prefix. You can get this value from your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'DNS Address',
                            content:
                                'Select whether to get the DNS address dynamically from your ISP or designate the DNS address manually.</br>&nbsp&nbsp&nbsp&nbspGet dynamically from ISP: Your ISP assigns an DNS address to your gateway dynamically.</br>&nbsp&nbsp&nbsp&nbspUse the following DNS Addresses: You should manually enter the DNS address provided by your ISP'
                        },
                        {
                            type: 'name',
                            title: 'Primary DNS/Secondary DNS',
                            content: 'Enter the DNS address manually or display the DNS address which is assigned by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Connect',
                            content: 'Click this button to connect to the internet.'
                        },
                        {
                            type: 'name',
                            title: 'Disconnect',
                            content: 'Click this button to disconnect from the internet.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: '6to4 Tunnel',
                    content: 'Select this type if your ISP uses 6to4 deployment for assigning address.',
                    children: [
                        {
                            type: 'name',
                            title: 'IPv4 Address/IPv4 Subnet Mask/IPv4 Default Gateway/Tunnel Address',
                            content:
                                'IPv4 Address/IPv4 Subnet Mask/IPv4 Default Gateway/Tunnel Address: These parameters will be dynamically generated by the IPv4 information of WAN port after you click Connect.'
                        },
                        {
                            type: 'paragraph',
                            content: '<b>Advanced</b>'
                        },
                        {
                            type: 'name',
                            title: 'Use the following DNS Server',
                            content: 'Click the box to manually enter the primary DNS and/or secondary DNS as provided by your ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Connect',
                            content: 'Click this button to connect to the internet.'
                        },
                        {
                            type: 'name',
                            title: 'Disconnect',
                            content: 'Click this button to disconnect from the internet.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Pass-Through (Bridge)',
                    content:
                        'Select this type if your ISP uses Pass-Through (Bridge) network deployment. No extra parameter is required. Click Save to save the settings.'
                }
            ]
        },

        IPGROUP_GROUP_INTRODUCT: {
            TITLE: 'IP Group',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'In IP Group, you can preset IP groups that will appear as options for you to choose when configuring related parameters for some features, such as Bandwidth Control, Session Limit, and Policy Routing. After creating the entries, you can apply them to multiple configurations, which saves you from repeatedly setting up the same information.'
                }
            ]
        },

        IPGROUP_GROUP_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to add a new IP group.',
                        'Enter a name, select the preset IP address entries, and then configure the corresponding parameters for the new entry.',
                        'Select the created IP group entry in related configurations, such as Bandwidth Control, Session Limit, and Policy Routing.'
                    ]
                }
            ]
        },
        IPGROUP_GROUP_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Group Name',
                    content: 'Enter the name of the IP group.'
                },
                {
                    type: 'name',
                    title: 'IP Group',
                    content:
                        'Select the IP address entry, and you can select more than one entry for one IP group. A rule that references the IP group will be applied to all the IP addresses in the group.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content:
                        'Enter a brief description for the address group to facilitate your management. It can be 50 characters at most.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: [
                        'The IP group that has been referenced by a rule cannot be deleted unless the rule no longer references the IP group.',
                        'The IP group can be null, which means the IP group contains no IP address. A rule that references the address group will not take effect on any IP address.'
                    ]
                }
            ]
        },

        IPGROUP_ADDRESS_INTRODUCT: {
            TITLE: 'IP Address',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'In IP Address, you can preset entries with multiple IP addresses that will appear as options for you to choose when configuring IP groups. After creating the entries, you can apply them to different IP groups, which saves you from repeatedly setting up the same information.'
                }
            ]
        },

        IPGROUP_ADDRESS_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to add a new IP address entry.',
                        'Enter a name, select the type and then configure the corresponding parameters for the new entry.',
                        'Select the created IP address entry when configuring IP groups.'
                    ]
                }
            ]
        },
        IPGROUP_ADDRESS_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Enter the name of the IP address entry.'
                },
                {
                    type: 'name',
                    title: 'IP Address Type',
                    content: 'Specify the type of the IP address entry.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'IP Address Range: Specify a starting IP address and an ending IP address. A rule that references the IP address entry will be applied to the IP addresses within the range in the entry.',
                                'IP Address/Mask: Specify a network address and a subnet mask. A rule that references the IP address entry will be applied to the IP addresses within the range in the entry.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Description',
                    content:
                        'Enter a brief description for the IP address entry to facilitate your management. It can be 50 characters at most.'
                }
            ]
        },

        TIME_MNGT_INTRODUCT: {
            TITLE: 'Time Range',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Time Range configuration allows you to define time ranges by specifying the period in a day and days in a week. The time range configured here can be used for multiple features like Bandwidth Control, Link Backup, and Policy Routing, saving you from repeatedly setting up the same information.'
                }
            ]
        },

        TIME_MNGT_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to add a new entry of time range.',
                        'Enter a name and configure the corresponding parameters for the new entry.',
                        'Select the created entry of time range in related configurations, such as Bandwidth Control, Link Backup, and Policy Routing.'
                    ]
                }
            ]
        },
        TIME_MNGT_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Time Range Name',
                    content: 'Enter a name for the time range entry. Only letters, digits or underscores are allowed.'
                },
                {
                    type: 'name',
                    title: 'Time Settings',
                    content: 'Specify the time range for the new entry.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Working Calendar: It allows you to set the time range on a calendar. In this mode, the preset time can be accurate to the hour. Click %<{"type":"calendarSpan","text":""}>% to load the calendar.',
                                'Manual: It allows you to manually enter the time range and select the days in a week. In this mode, the preset time can be accurate to the minute.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Description',
                    content:
                        'Enter a brief description for the time range entry to facilitate your management. It can be 32 characters at most.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content:
                        'The time range that has been referenced by a rule cannot be deleted unless the rule no longer references the time range.'
                }
            ]
        },

        IP_POOL_INTRODUCT: {
            TITLE: 'VPN IP Pool',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'In VPN IP Pool, you can preset VPN IP pools that will appear as options for you to choose when configuring L2TP VPN and PPTP VPN. After creating the entries, you can apply them to different rules, which saves you from repeatedly setting up the  same information.'
                }
            ]
        },

        IP_POOL_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to add a new entry of VPN IP pool.',
                        'Enter a name and configure the corresponding parameters for the new entry.',
                        'Select the created entry of VPN IP pool when configuring L2TP VPN and PPTP VPN.'
                    ]
                }
            ]
        },
        IP_POOL_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'IP Pool Name',
                    content: 'Enter a name for the new entry of IP pool. Only letters, digits or underscores are allowed.'
                },
                {
                    type: 'name',
                    title: 'Starting IP Address',
                    content: 'Specify the starting IP address of the IP Pool.'
                },
                {
                    type: 'name',
                    title: 'Ending IP Address',
                    content: 'Specify the ending IP address of the IP Pool. It should be greater than the starting IP address.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: [
                        'The range of the newly created IP pool cannot overlap with the IP range of the DHCP pool and other existing VPN IP pools.',
                        'The VPN IP pool entry that has been referenced by a rule cannot be deleted unless the rule no longer references the entry.'
                    ]
                }
            ]
        },

        SERVICE_TYPE_INTRODUCT: {
            TITLE: 'Service Type',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'In Service Type, you can define service type entries that will appear as matching  conditions for you to choose when configuring the rules of Access Control in Firewall. The entries in gray are system predefined service types, and they cannot be edited or deleted. You can add other entries if your service type is not in the list.'
                }
            ]
        },

        SERVICE_TYPE_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to add a new entry of service type.',
                        'Enter a name, select the protocol for the service type, and configure the corresponding parameters for the new entry.',
                        'Select the predefined entry of service type when configuring rules of access control in firewall.'
                    ]
                }
            ]
        },
        SERVICE_TYPE_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Service Type Name',
                    content: 'Enter a name for the service type. Only letters, digits or underscores are allowed.'
                },
                {
                    type: 'name',
                    title: 'Protocol',
                    content:
                        'Specify the protocol for the service. The system predefined protocols include TCP, UDP, TCP/UDP and ICMP. For other protocols, select the option Other.'
                },
                {
                    type: 'name',
                    title: 'Source Port Range',
                    content:
                        'Specify the source port range for the service. Packets whose source port and destination port are both in the range are considered as the target packets.'
                },
                {
                    type: 'name',
                    title: 'Destination Port Range',
                    content:
                        'Specify the destination port range for the service. Packets whose source port and destination port are both in the range are considered as the target packets.'
                },
                {
                    type: 'name',
                    title: 'Type',
                    content:
                        'Specify the type of the ICMP packets. 255 means all types are included. ICMP packets with both the type and code fields matched are considered as the target packets.'
                },
                {
                    type: 'name',
                    title: 'Code',
                    content:
                        'Specify the code of the ICMP packets. 255 means all codes are included. ICMP packets with both the type and code fields matched are considered as the target packets.'
                },
                {
                    type: 'name',
                    title: 'Protocol Number',
                    content:
                        'Specify the protocol number of the packets. Packets matched with the protocol number are considered as the target packets.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for the service type to facilitate your management.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content:
                        'A service type entry that is being referenced by a rule cannot be deleted unless the rule no longer references the entry.'
                }
            ]
        },

        NAPT: {
            TITLE: 'Multi-Nets NAT',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the information of the rules and edit them by clicking the buttons in the table.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the name of the rule.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Specify the effective interface for the rule only when the connection type is Static IP.'
                },
                {
                    type: 'name',
                    title: 'Source IP Range',
                    content: 'Specify the source IP range for the rule.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Enable or disable the rule.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for the rule entry to facilitate your management.'
                }
            ]
        },

        ONE_NAT_INTRO: {
            TITLE: 'One-to-One NAT',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'One-to-One NAT creates a relationship between a private IP address and a public IP address. A device with a private IP address can be accessed through the corresponding valid public IP address.'
                },
                {
                    type: 'note',
                    title: 'Notes',
                    content: [
                        'One-to-One NAT takes effect only when the connection type of WAN is Static IP.',
                        'When setting open ports for NAT, do not select the reserved ports (1723/1701 is reserved for PPTP/L2TP, 1194 is reserved for OpenVPN, and the specific ports you reserved).'
                    ]
                }
            ]
        },

        NAT_NOTE: {
            CONTENT: [
                {
                    type: 'note',
                    title: 'Notes',
                    content: [
                        'When setting open ports for NAT, do not select the reserved ports (1723/1701 is reserved for PPTP/L2TP, 1194 is reserved for OpenVPN, and the specific ports you reserved).'
                    ]
                }
            ]
        },

        ONE_NAT_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to create the new rule of One-to-One NAT and specify the related parameters.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },

        ONE_NAT_PARAM: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Enter a name to identify the One-to-One NAT rule.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content:
                        'Specify the effective interface for the rule only when the connection type is Static IP. If you choose multiple ports, the entry will be applied to all selected ports simultaneously.'
                },
                {
                    type: 'name',
                    title: 'Original IP',
                    content:
                        'Specify the private IP address for the rule. The original IP address cannot be the broadcast address and the IP address of the LAN interface.'
                },
                {
                    type: 'name',
                    title: 'Translated IP',
                    content:
                        'Specify the public IP address for the rule. The translated IP address cannot be the broadcast address and the IP address of the WAN interface.'
                },
                {
                    type: 'name',
                    title: 'DMZ Forwarding',
                    content:
                        'Check the box to enable DMZ Forwarding. The packets transmitted to the translated IP address will be forwarded to the host of original IP address if DMZ Forwarding is enabled.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: '(Optional) Enter a brief description for the rule to facilitate your management.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        ONE_NAT: {
            TITLE: 'One-to-One NAT',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the information of the rules and edit them by clicking the buttons in the table.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the name of the rule.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Specify the effective interface for the rule only when the connection type is Static IP.'
                },
                {
                    type: 'name',
                    title: 'Original IP',
                    content:
                        "Specify the original IP address for the rule, which means the device's private IP. The original IP address cannot be the broadcast address, network segment or interface IP. With One-to-One NAT enabled, the original IP will map to the translated IP."
                },
                {
                    type: 'name',
                    title: 'Translated IP ',
                    content:
                        'Specify the translated IP address for the rule, which means the public IP of device. The translated IP address cannot be the broadcast address, network segment or interface IP. With One-to-One NAT enabled, the original IP will map to the translated IP.'
                },
                {
                    type: 'name',
                    title: 'DMZ Forwarding',
                    content:
                        'Choose to enable DMZ Forwarding. The packets transmitted to the  translated IP address will be forwarded to the host with the original IP address if DMZ Forwarding is enabled. '
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for the rule entry to facilitate your management.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        VIRTUAL_SERVER_INTRO: {
            TITLE: 'Virtual Server',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'When you build up a server in the local network and want to share it on the internet, Virtual Servers can realize the service and provide it to the internet users. At the same time, Virtual Servers can keep the local network safe as other services are still invisible from the internet.'
                }
            ]
        },

        VIRTUAL_SERVER_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to create the new rule of Virtual Servers and specify the related parameters.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },

        VIRTUAL_SERVER_PARAM: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Enter a name to identify the created virtual server.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content:
                        'Specify the effective interface for the rule. If you choose multiple ports, the entry will be applied to all selected ports simultaneously.'
                },
                {
                    type: 'name',
                    title: 'External Port',
                    content:
                        'Enter the service port or port range of the router for external network access. The ports or port ranges cannot overlap with those of other virtual server rules.'
                },
                {
                    type: 'name',
                    title: 'Internal Port',
                    content: 'Specify the service port or port range of the LAN host as virtual server.'
                },
                {
                    type: 'name',
                    title: 'Internal Server IP',
                    content:
                        'Enter the IP address of the specified internal server for the entry. All the requests from the internet to the specified LAN port will be redirected to this host.'
                },
                {
                    type: 'name',
                    title: 'Protocol',
                    content: 'Specify the protocol used for the rule.',
                    children: [
                        {
                            type: 'name',
                            title: 'ALL',
                            content: 'Data packets are transmitted based on TCP or UDP protocols.'
                        },
                        {
                            type: 'name',
                            title: 'TCP',
                            content: 'Data packets are transmitted based on TCP protocol.'
                        },
                        {
                            type: 'name',
                            title: 'UDP',
                            content: 'Data packets are transmitted based on UDP protocol.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },
        VIRTUAL_SERVER: {
            TITLE: 'Virtual Server',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the information of the rules and edit them by clicking the buttons in the table.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the name of the rule.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Specify the effective interface for the rule.'
                },
                {
                    type: 'name',
                    title: 'External Port',
                    content:
                        "Enter the service port or port range of the router for external network's access. The ports or port ranges cannot overlap with those of other virtual server rules. "
                },
                {
                    type: 'name',
                    title: 'Internal Port',
                    content: 'Specify the service port of the LAN host which acts as the server.'
                },
                {
                    type: 'name',
                    title: 'Internal Server IP',
                    content:
                        'Enter the IP address of the LAN host which acts as the server. All the requests from the internet to the specified LAN port will be redirected to this host.  '
                },
                {
                    type: 'name',
                    title: 'Protocol',
                    content: 'Specify the protocol used for the entry.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        PORT_TRIGGERING_INTRO: {
            TITLE: 'Port Triggering',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Port Triggering is a feature used to dynamically forward traffic on a certain port to a specific server on the local network. When a host in the local network initiates a connection to the triggering port, all the external ports will be opened for subsequent connections. The router can record the IP address of the host, and forward the data packets to the corresponding host when they return from the internet to the external ports. Port Triggering is mainly applied to online games, VoIPs, video players, and so on.'
                }
            ]
        },

        PORT_TRIGGERING_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to create the new rule of Port Triggering and specify the related parameters.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },

        PORT_TRIGGERING_PARAM: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Enter a name to identify the rule.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content:
                        'Specify the effective interface for the rule. If you choose multiple ports, the entry will be applied to all selected ports simultaneously.'
                },
                {
                    type: 'name',
                    title: 'Trigger Port',
                    content:
                        'Enter the trigger port or port range from which the data flows out. Each entry supports at most 5 groups of trigger ports. For example, you can enter 1 or 1-2. Note that the ports or port ranges cannot overlap with those of other port triggering rules.'
                },
                {
                    type: 'name',
                    title: 'Trigger Protocol',
                    content: 'Specify the protocol for the trigger port.',
                    children: [
                        {
                            type: 'name',
                            title: 'ALL',
                            content: 'Data packets are transmitted based on TCP or UDP protocols.'
                        },
                        {
                            type: 'name',
                            title: 'TCP',
                            content: 'Data packets are transmitted based on TCP protocol.'
                        },
                        {
                            type: 'name',
                            title: 'UDP',
                            content: 'Data packets are transmitted based on UDP protocol.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Incoming Port',
                    content:
                        'Enter the incoming port or port range from which the data is received. Each entry supports at most 5 groups of incoming ports. For example, you can enter 1-2 or 11-12. Note that the ports or port ranges cannot overlap with those of other port triggering rules.'
                },
                {
                    type: 'name',
                    title: 'Incoming Protocol',
                    content: 'Specify the protocol for the incoming port.',
                    children: [
                        {
                            type: 'name',
                            title: 'ALL',
                            content: 'Data packets are transmitted based on TCP or UDP protocols.'
                        },
                        {
                            type: 'name',
                            title: 'TCP',
                            content: 'Data packets are transmitted based on TCP protocol.'
                        },
                        {
                            type: 'name',
                            title: 'UDP',
                            content: 'Data packets are transmitted based on UDP protocol.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        PORT_TRIGGERING: {
            TITLE: 'Port Triggering',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the information of the rules and edit them by clicking the buttons in the table.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Specify the effective interface for the rule.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the name of the rule.'
                },
                {
                    type: 'name',
                    title: 'Trigger Port',
                    content:
                        'Enter the trigger port or port range. Each entry supports at most 5 groups of trigger ports. The ports or port ranges cannot overlap with those of other port triggering rules. '
                },
                {
                    type: 'name',
                    title: 'Trigger Protocol',
                    content: 'Specify the trigger protocol for the trigger port.'
                },
                {
                    type: 'name',
                    title: 'Incoming Port',
                    content:
                        'Enter the incoming port or port range. Each entry supports at most 5 groups of incoming ports. The ports or port ranges cannot overlap with those of other port triggering rules. '
                },
                {
                    type: 'name',
                    title: 'Incoming Protocol',
                    content: 'Specify the incoming protocol for the incoming port.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        ALG_INTRO: {
            TITLE: 'ALG',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'ALG (Application Layer Gateway Service) manages specific application protocols and serves as an intermediary between the internet and an application server. ALG ensures that certain application-level protocols function appropriately through your gateway.'
                }
            ]
        },

        ALG_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'step',
                    content: ['Enable or disable certain types of ALG based on needs, then click %<{"type":"button","text":"Save"}>%.']
                }
            ]
        },

        ALG_PARAM: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'FTP ALG',
                    content:
                        'FTP (File Transfer Protocol) ALG allows the FTP server and client to transfer data using the FTP protocol in the following scenarios:',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'The FTP server is in the LAN, while the FTP client is on the internet.',
                                'The FTP server is on the internet, while the FTP client is in the LAN.',
                                'The FTP server and FTP client are in different LANs.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'H.323 ALG',
                    content:
                        'H.323  ALG  allows  the  IP  phones  and  multimedia  devices  to  set  up connections using the H.323 protocol in the following scenarios:',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'One of the endpoints is in the LAN, while the other is on the internet.',
                                'The endpoints are in different LANs.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'PPTP ALG',
                    content:
                        'PPTP (Point-to-point Tunneling Protocol) ALG allows the PPTP server and client to set up a PPTP VPN in the following scenarios:',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'The PPTP server is in the LAN, while the PPTP client is on the internet.',
                                'The PPTP server is on the internet, while the PPTP client is in the LAN.',
                                'The PPTP server and PPTP client are in different LANs.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'SIP ALG',
                    content:
                        'SIP (Session Inititation Protocol) ALG allows the IP phones and multimedia devices to set up connections using the SIP protocol in the following scenarios:',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'One of the endpoints is in the LAN, while the other is on the internet.',
                                'The endpoints are in different LANs.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'IPsec ALG',
                    content:
                        'IPsec (IP Security Protocol) ALG allows the IPsec endpoints to set up an IPsec VPN in the following scenarios:',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'One of the endpoints is in the LAN, while the other is on the internet.',
                                'The endpoints are in different LANs.'
                            ]
                        }
                    ]
                }
            ]
        },

        ALG: {
            TITLE: 'ALG',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'You can determine whether to provide ALG(Application Level Gateway) service for FTP, H.323, PPTP, SIP and IPsec to keep these special applications from the effect of NAT service on this page.'
                },
                {
                    type: 'name',
                    title: 'FTP ALG',
                    content: 'Check the box to enable FTP ALG.'
                },
                {
                    type: 'name',
                    title: 'H.323 ALG',
                    content: 'Check the box to enable H.323 ALG.'
                },
                {
                    type: 'name',
                    title: 'PPTP ALG',
                    content: ' Check the box to enable PPTP ALG.'
                },
                {
                    type: 'name',
                    title: 'SIP ALG',
                    content: 'Check the box to enable SIP ALG.'
                },
                {
                    type: 'name',
                    title: 'IPsec ALG',
                    content: 'Check the box to enable IPsec ALG.'
                }
            ]
        },

        NAT_DMZ_INTRO: {
            TITLE: 'NAT-DMZ',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'A demilitarized zone (DMZ) is either a small network or computer host (DMZ host) that is inserted between a private network and the Internet. It is a network security neutral zone with less restricted connection to the internet. When you are not clear about which ports to open in some special applications, such as IP camera and database software, you can set the PC to be a DMZ host.'
                }
            ]
        },

        NAT_DMZ_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to create the new rule of NAT-DMZ and specify the related parameters.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },

        NAT_DMZ_PARAM: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Enter the name of the rule.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Specify the effective interface for the rule.'
                },
                {
                    type: 'name',
                    title: 'Host IP Address',
                    content: 'Specify the host IP address for NAT-DMZ.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        NAT_DMZ: {
            TITLE: 'NAT-DMZ',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the information of the rules and edit them by clicking the buttons in the table.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the name of the rule.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Specify the effective interface for the rule.'
                },
                {
                    type: 'name',
                    title: 'Host IP Address',
                    content: 'Specify the host IP address for NAT-DMZ.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        QOS_INTRO: {
            TITLE: 'Introduction',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Bandwidth Control function allows you to configure rules to limit various data flows. In this way, you can optimize the network performance by reasonably utilizing the bandwidth.'
                }
            ]
        },

        QOS_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Check the box to enable bandwidth control. You can also set a threshold to trigger the control. Click %<{"type":"button","text":"Save"}>%.',
                        'Click %<{"type":"addSpan","text":"Add"}>% to add a new rule for bandwidth control, and specify the parameters for the new rule.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },

        QOS_SETTINGS: {
            TITLE: 'Bandwidth Control Config',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Enable Bandwidth Control',
                    content: 'Check the box to enable Bandwidth Control globally.'
                },
                {
                    type: 'name',
                    title: 'Bandwidth Control Threshold',
                    content:
                        'With Enable Bandwidth Control selected, you can specify a percentage, and	the Bandwidth Control will take effect only when the bandwidth usage reaches the percentage you specified.'
                }
            ]
        },

        QOS_LIST: {
            TITLE: 'Bandwidth Control Rule List',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Enter a name to identify the bandwidth control rule.'
                },
                {
                    type: 'name',
                    title: 'Direction',
                    content: 'Specify the data stream direction for the rule.'
                },
                {
                    type: 'name',
                    title: 'Group',
                    content:
                        'Select the IP groups  you have created from the drop-down list. With IPGROUP_ANY selected, the rule will apply to all clients. If no desired IP groups have been created, go to Preferences > IP Group page to create one.'
                },
                {
                    type: 'name',
                    title: 'Maximum Upstream Bandwidth',
                    content:
                        'Specify  the  limit  of  upstream  bandwidth  for  the specific user to transmit traffic to the internet through the router.'
                },
                {
                    type: 'name',
                    title: 'Maximum Downstream Bandwidth',
                    content:
                        'Specify the limit of downstream bandwidth for the specific user to receive traffic from the internet through the router.'
                },
                {
                    type: 'name',
                    title: 'Mode',
                    content: 'Select the bandwidth control mode for the controller users.',
                    children: [
                        {
                            type: 'name',
                            title: 'Shared',
                            content:
                                'The total bandwidth for all users is equal to the specified values in upstream and downstream bandwidth.'
                        },
                        {
                            type: 'name',
                            title: 'Individual',
                            content: 'The bandwidth for each user is equal to the specified value in upstream and downstream bandwidth.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Effective Time',
                    content:
                        'Specify the time for the rule to take effect. Any means it always takes effect. If no desired time ranges have been configured, go to Preferences > Time Range page to create one.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description of the rule.'
                },
                {
                    type: 'name',
                    title: 'ID',
                    content: 'Assign a number to the rule to reorder the list.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        SESSION_LIMIT_INTRO: {
            TITLE: 'Session Limit',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Session limit feature limits the number of sessions that specific sources can use. This feature can prevent the network resources and bandwidth from being exhausted by some hosts which use too many sessions at one time, and therefore optimizes network performance.'
                }
            ]
        },

        SESSION_LIMIT_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Check the box to enable session limit, then click %<{"type":"button","text":"Save"}>%.',
                        'Click %<{"type":"addSpan","text":"Add"}>%, and specify the parameters for the new rule of session limit',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },

        SESSION_LIMIT_PARAM: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Enter a name to identify the session limit rule.'
                },
                {
                    type: 'name',
                    title: 'Group',
                    content:
                        'Specify the address group to which the rule will be applied. The IP Group referenced here can be created on the Preferences > IP Group page.'
                },
                {
                    type: 'name',
                    title: 'Max Sessions',
                    content:
                        'Enter the maximum number of sessions that a LAN host can use. The router will limit the sessions of the source when its number exceeds the maximum value.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the session limit rule.'
                }
            ]
        },

        SESSION_MONITOR_INTRO: {
            TITLE: 'Session Monitor',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the Session Limit information of hosts configured with Session Limit on this page.'
                }
            ]
        },

        SESSION_MONITOR_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'step',
                    content: ['Check %<{"type":"refreshSpan","text":"Refresh"}>% button to get the latest information.']
                }
            ]
        },

        SESSION_MONITOR_PARAM: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'ID',
                    content: 'The number for identifying the session limit rule.'
                },
                {
                    type: 'name',
                    title: 'IP',
                    content: 'The IP address of the local host.'
                },
                {
                    type: 'name',
                    title: 'Max Sessions',
                    content: 'The maximum number of sessions that a LAN host can use.'
                },
                {
                    type: 'name',
                    title: 'Current Sessions',
                    content: 'The number of sessions that a LAN host current uses.'
                }
            ]
        },

        SESSIONLIMIT_ENABLE: {
            TITLE: 'General',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Enable Session Limit',
                    content: 'Check the box to enable Session Limit.'
                }
            ]
        },
        SESSIONLIMIT_LIST: {
            TITLE: 'Session Limit Rule List',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the name of the rule.'
                },
                {
                    type: 'name',
                    title: 'Group',
                    content: 'Specify the address group to which the rule will be applied.'
                },
                {
                    type: 'name',
                    title: 'Max Sessions',
                    content: 'Specify the max sessions for the controlled users.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },
        SESSION_LIMITS: {
            TITLE: 'Session Monitor List',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'You can view the Session Limit information of hosts configured with Session Limit on this page. Click the Refresh button to get the latest information. '
                },
                {
                    type: 'name',
                    title: 'IP',
                    content: 'Displays the IP address of controlled users.'
                },
                {
                    type: 'name',
                    title: 'Max Sessions',
                    content: 'Displays the maximum sessions of controlled users.'
                },
                {
                    type: 'name',
                    title: 'Current Sessions',
                    content: 'Displays the current sessions of controlled users.'
                }
            ]
        },

        BALANCE_INTRO: {
            TITLE: 'Load Balancing',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'You can configure the traffic sharing mode of the WAN ports to optimize the resource utilization and processing capability of servers. The router will switch all the new sessions from dropped lines automatically to the others to keep an always on-line network.'
                }
            ]
        },

        BALANCE_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Check the box of Enable Load Balancing and click %<{"type":"button","text":"Save"}>%.',
                        'Select the appropriate method for load balancing after configuring WAN bandwidth on the Network > WAN page. Then click %<{"type":"button","text":"Save"}>%.'
                    ]
                }
            ]
        },

        BALANCE_PARAM: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Enable Application Optimized Routing',
                    content:
                        'With Application Optimized Routing enabled, the router will consider the source IP address and destination IP address (or destination port) of the packets as a whole and record the WAN port they pass through. Then packets with the same source IP address and destination IP address (or destination port) will be forwarded to the recorded WAN port. This feature ensures that multi-connected applications work properly.'
                },
                {
                    type: 'name',
                    title: 'Enable Bandwidth Based Balance Routing on port(s)',
                    content: 'Select the WAN port from the drop-down list on which bandwidth-based balance routing is enabled.'
                }
            ]
        },

        BALANCE_GLOBAL_SETTING: {
            TITLE: 'General',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can configure Load Balancing on this page.'
                },
                {
                    type: 'name',
                    title: 'Enable Load Balancing',
                    content: 'Check the box to enable Load Balancing globally.'
                }
            ]
        },
        BALANCE_BASIC_SETTING: {
            TITLE: 'Basic Settings',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Enable Application Optimized Routing',
                    content:
                        'With Application Optimized Routing enabled, the router will consider the source IP address and destination IP address (or destination port) of the packets as a whole and record the WAN port they pass through. Then the packets with the same source IP address and destination IP address (or destination port) will be forwarded to the recorded WAN port. This feature ensures that multi-connected applications work properly.   '
                },
                {
                    type: 'name',
                    title: 'Enable Bandwidth Based Balance Routing on port(s)',
                    content: 'Select the WAN port from the drop-down list to enable Bandwidth Based Balance Routing.'
                }
            ]
        },

        LINK_BACKUP_INTRO: {
            TITLE: 'Link Backup',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'With Link Backup enabled, you will define two roles of lines, namely primary lines and backup lines. Normally, only the primary lines are used for data forwarding. Under certain circumstances, the router will automatically switch all the new sessions from the primary lines to the backup lines to keep an always on-line network.'
                }
            ]
        },

        LINK_BACKUP_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to create the new rule of Link Backup and specify the related paramters.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },

        LINK_BACKUP_PARAM: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Primary WAN',
                    content: 'Specify the primary WAN port.'
                },
                {
                    type: 'name',
                    title: 'Backup WAN',
                    content:
                        'Specify the backup WAN port to back up the traffic for the primary WAN port under the specified condition. For example, you may define LTE as the backup WAN to save money.'
                },
                {
                    type: 'name',
                    title: 'Mode',
                    content: 'Specify the mode as Timing or Failover.',
                    children: [
                        {
                            type: 'name',
                            title: 'Timing',
                            content:
                                'Link Backup will be enabled if the specified effective time is reached. All the traffic on the primary WAN will switch to the backup WAN at the beginning of the effective time; the traffic on the backup WAN will switch to the primary WAN at the ending of the effective time.'
                        },
                        {
                            type: 'name',
                            title: 'Failover(Enable backup link when any primary WANs fails)',
                            content:
                                'Link Backup will be enabled when any primary WANs fails. Load balancing will be enabled on the backup WAN. The traffic on the backup WAN will switch to the primary WAN when the failed primary WANs works properly.'
                        },
                        {
                            type: 'name',
                            title: 'Failover(Enable backup link when all primary WANs fails)',
                            content:
                                'Link Backup will be enabled only when all primary WANs fail. All the traffic on the primary WAN will switch to the backup WAN. The traffic on the backup WAN will switch to the primary WAN when all the primary WANs works properly.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Effective Time',
                    content:
                        'Specify the time for the rule to take effect. Any means it takes effect at any time. If no desired time ranges have been configured, go to Preferences > Time Range page to create one.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        ONLINE_INTRO: {
            TITLE: 'Online Detection',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'With Online Detection function, you can detect the online status of the WAN port.'
                }
            ]
        },

        ONLINE_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"editSpan","text":""}>% and specify the parameters for the new rule of online detection.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },

        ONLINE_PARAM: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Port',
                    content: 'Displays the name of WAN Port.'
                },
                {
                    type: 'name',
                    title: 'Mode',
                    content: 'Select the online detection mode.',
                    children: [
                        {
                            type: 'name',
                            title: 'Auto',
                            content:
                                'In Auto Mode, the DNS server of the WAN port will be selected as the destination for DNS Lookup to detect whether the WAN is online.'
                        },
                        {
                            type: 'name',
                            title: 'Manual',
                            content:
                                'In Manual Mode, you can configure the destination IP address for PING and DNS Lookup manually to detect whether the WAN is online.'
                        },
                        {
                            type: 'name',
                            title: 'Always Online',
                            content: 'In Always Online Mode, the status of the port will always be online.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Ping',
                    content:
                        'With Manual Mode selected, specify the destination IP for Ping. The corresponding port will ping the IP address to detect whether the WAN port is online. 0.0.0.0 means Ping detection is disabled.'
                },
                {
                    type: 'name',
                    title: 'DNS Lookup',
                    content:
                        'With Manual Mode selected, specify the IP address of DNS server. The corresponding port will perform the DNS lookup using default domain name to detect whether the WAN port is online. 0.0.0.0 means DNS Lookup is disabled.'
                }
            ]
        },

        ONLINE_SETTING: {
            TITLE: 'Online Detection',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can configure the detecting mode to detect whether the WAN is online on this page.'
                },
                {
                    type: 'name',
                    title: 'Port',
                    content: 'Displays the name of WAN Port.'
                },
                {
                    type: 'name',
                    title: 'Auto',
                    content:
                        'In Auto Mode, the DNS server of the WAN port will be selected as the destination for DNS Lookup to detect whether the WAN is online.'
                },
                {
                    type: 'name',
                    title: 'Manual',
                    content:
                        'In Manual Mode, you can configure the destination IP address for PING and DNS Lookup manually to detect whether the WAN is online.'
                },
                {
                    type: 'name',
                    title: 'Always Online',
                    content: 'In Always Online Mode, the status of the port will always be online.'
                },
                {
                    type: 'name',
                    title: 'Ping',
                    content:
                        'With "Manual Mode" selected, specify the destination IP for Ping.  The correspoding port will ping the IP address to detect whether the WAN port is online. 0.0.0.0 means Ping detection is disabled.  '
                },
                {
                    type: 'name',
                    title: 'DNS Lookup',
                    content:
                        'With "Manual Mode" selected, specify the IP address of DNS server. The correspoding port will perform the DNS lookup using default domain name to detect whether the WAN port is online. 0.0.0.0 means DNS Lookup is disabled. '
                }
            ]
        },

        POLICY_ROUTING_INTRO: {
            TITLE: 'Policy Routing',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Policy routing allows users to customize rules for the router to forward the packets. Once policy routing is configured and enabled, the router will check the source, destination, and the protocol of the network traffic first. When the traffic matches the user-defined policies, it will be forwarded according to the specific polices. In this way, policy routing provides great flexibility for networking.'
                }
            ]
        },

        POLICY_ROUTING_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to create the new rule of static route and specify the related paramters.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },

        POLICY_ROUTING_PARAM: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Enter a name to identify the policy routing rule.'
                },
                {
                    type: 'name',
                    title: 'Service Type',
                    content: 'Specify the service type for the rule.'
                },
                {
                    type: 'name',
                    title: 'Source IP',
                    content:
                        'Specify the source IP range for the rule. Select IP groups you have created from the drop-down list. With Any selected, the rule will apply to all clients. If no desired IP groups have been created, go to Preferences > IP Group page to create one.'
                },
                {
                    type: 'name',
                    title: 'Destination IP',
                    content:
                        'Specify the destination IP range for the rule. Select IP groups you have created from the drop-down list. With Any selected, the rule will apply to all clients. If no desired IP groups have been created, go to Preferences > IP Group page to create one.'
                },
                {
                    type: 'name',
                    title: 'WAN',
                    content: 'Select the WAN port, and the traffic will be forwarded through the selected port.'
                },
                {
                    type: 'name',
                    title: 'Effective Time',
                    content:
                        'Specify the effective time for the rule. If no desired time ranges have been configured, go to Preferences > Time Range page to create one.'
                },
                {
                    type: 'name',
                    title: 'Mode',
                    content: 'Specify the policy routing mode for the rule.',
                    children: [
                        {
                            type: 'name',
                            title: 'Priority',
                            content:
                                'In Priority Mode, the rule depends on the online detection result. If any WAN port that you specify is online, the rule will take effect. If all the WAN ports that you specify are offline, the rule will not take effect.'
                        },
                        {
                            type: 'name',
                            title: 'Only',
                            content:
                                'In Only Mode, the rule always takes effect regardless of the WAN port status or online detection result.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for the rule.'
                },
                {
                    type: 'name',
                    title: 'ID',
                    content:
                        'Assign a number to the rule to reorder the list. A smaller number means a higher priority for the rule to take effect.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the policy routing entry.'
                }
            ]
        },

        POLICY_ROUTING_SETTING: {
            TITLE: 'Policy Routing',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can configure the policy routing rule for forwarding packets on this page.'
                }
            ]
        },
        POLICY_ROUTING_LIST: {
            TITLE: 'Policy Routing Rule List',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the information of the policy routing rules and edit them using the buttons in the table.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the name of the rule.'
                },
                {
                    type: 'name',
                    title: 'Service Type',
                    content:
                        'Specify the service type for the rule. The service type referenced here can be created on the Preferences > Service Type page. '
                },
                {
                    type: 'name',
                    title: 'Source IP',
                    content:
                        'Specify the IP Group you want to reference.  The IP Group referenced here can be created on the Preferences > IP Group page. '
                },
                {
                    type: 'name',
                    title: 'Destination IP',
                    content:
                        'Specify the IP Group you want to reference. The IP Group referenced here can be created on the Preferences > IP Group page. '
                },
                {
                    type: 'name',
                    title: 'WAN',
                    content: 'Specify the outcoming port for the rule.'
                },
                {
                    type: 'name',
                    title: 'Effective Time',
                    content: 'Specify the effective time for the rule.'
                },
                {
                    type: 'name',
                    title: 'Mode',
                    content: 'Specify the policy routing mode for the rule.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Priority: Priority means that the rule depends on the online detection result. If any WAN port that you specify is online, the rule will take effect. If all the WAN ports that you specify is offline, the rule will not take effect.',
                                'Only: Only means that the rule always takes effect regardless of the WAN port status or online detection result.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for the rule.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        STATIC_ROUTING_INTRO: {
            TITLE: 'Static Route',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Static Route designates the next hop or interface to which the network traffic is forwarded. In most cases, static route is applied when there is no dynamic route, or you do not hope that the network traffic is forwarded in the dynamically learned route.'
                },
                {
                    type: 'note',
                    title: 'Notes',
                    content: 'Static route take effects with a higher priority over policy routing.'
                }
            ]
        },

        STATIC_ROUTING_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to create the new rule of static route and specify the related paramters.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },

        STATIC_ROUTING_PARAM: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Enter a name to identify the static route entry.'
                },
                {
                    type: 'name',
                    title: 'Destination IP',
                    content:
                        'Specify the destination IP of the network traffic. The traffic will be forwarded to the specified destination.'
                },
                {
                    type: 'name',
                    title: 'Subnet Mask',
                    content: 'Specify the subnet mask of the destination network.'
                },
                {
                    type: 'name',
                    title: 'Next Hop',
                    content:
                        'Specify the IP address as the next hop. Your devices will forward the corresponding network traffic to this IP address.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content:
                        'Specify the physical network interface through which this route is accessible. Your devices will forward the corresponding network traffic through this network interface.'
                },
                {
                    type: 'name',
                    title: 'Metric',
                    content:
                        'Define the priority of the static route entry. A smaller value means a higher priority. The default value is 0. It is recommended to keep the default value.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for the entry.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the static route entry.'
                }
            ]
        },

        ADVANCED_ROUTING_STATIC_ROUTING: {
            TITLE: 'Static Route',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can configure the static route entries on this page.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the name of the route entry. The name cannot be same as existing ones.'
                },
                {
                    type: 'name',
                    title: 'Destination IP',
                    content: 'Specify the destination IP address the route leads to.'
                },
                {
                    type: 'name',
                    title: 'Subnet Mask',
                    content: 'Specify the subnet mask of the destination network.'
                },
                {
                    type: 'name',
                    title: 'Next Hop',
                    content: 'Specify the IP address to which the packet should be sent next.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Specify the physical network interface through which this route is accessible.'
                },
                {
                    type: 'name',
                    title: 'Metric',
                    content:
                        'Define the priority of the route. Smaller values represent higher priority. The default value is 0. It is recommended to keep the default value. '
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for the rule. It can be 50 characters at most.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        ROUTING_TABLE_INTRO: {
            TITLE: 'Routing Table',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'Routing Table shows the information of the current route entries.'
                }
            ]
        },

        ROUTING_TABLE_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'step',
                    content: ['Click %<{"type":"refreshSpan","text":"Refresh"}>% button to get the latest information.']
                }
            ]
        },

        ROUTING_TABLE_PARAM: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Destination IP',
                    content:
                        'Specify the destination IP of the network traffic. The traffic will be forwarded to the specified destination.'
                },
                {
                    type: 'name',
                    title: 'Subnet Mask',
                    content: 'Specify the subnet mask of the destination network.'
                },
                {
                    type: 'name',
                    title: 'Next Hop',
                    content:
                        'Specify the IP address as the next hop. Your devices will forward the corresponding network traffic to this IP address.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content:
                        'Specify the physical network interface through which this route is accessible. Your devices will forward the corresponding network traffic through this network interface.'
                },
                {
                    type: 'name',
                    title: 'Metric',
                    content:
                        'Define the priority of the static route entry. A smaller value means a higher priority. The default value is 0. It is recommended to keep the default value.'
                }
            ]
        },

        ADVANCED_ROUTING_SYSTEM_ROUTING_TABLE: {
            TITLE: 'Route Table',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the route table on this page.'
                },
                {
                    type: 'name',
                    title: 'Destination IP',
                    content: 'Displays the destination IP address the route leads to.'
                },
                {
                    type: 'name',
                    title: 'Subnet Mask',
                    content: 'Displays the subnet mask of the destination network.'
                },
                {
                    type: 'name',
                    title: 'Next Hop',
                    content: 'Displays the gateway IP address to which the packet should be sent next.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Displays the physical network interface through which this route is accessible.'
                },
                {
                    type: 'name',
                    title: 'Metric',
                    content: 'Displays the metric to reach the destination IP address.'
                }
            ]
        },

        IMB_INTRODUCT: {
            TITLE: 'IP-MAC Binding',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'ARP (Address Resolution Protocol) is used to map IP addresses to the corresponding MAC addresses so that packets can be delivered to their destinations. However, if attackers send ARP spoofing packets with false IP address-to-MAC address mapping entries, the device will update the ARP table based on the false ARP  packets and record wrong mapping entries, which results in a breakdown of normal communication.</br></br>Anti ARP Spoofing can protect the network from ARP spoofing attacks. It works based on the IP-MAC Binding. These entries record the correct one-to-one  relationships between IP addresses and MAC addresses. When receiving an ARP packet, the router checks whether it matches any of the IP-MAC Binding entries. If not, the router will ignore the ARP packets. In this way, the router maintains the  correct ARP table.'
                }
            ]
        },

        IMB_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Enable ARP Spoofing Defense.',
                        'Add IP-MAC binding entries to the IP-MAC Binding List mannually or via ARP Scanning.'
                    ]
                }
            ]
        },

        IMB_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'General',
                    children: [
                        {
                            type: 'name',
                            title: 'Enable ARP Spoofing Defense',
                            content: 'Check the box to globally enable ARP Spoofing Defense.'
                        },
                        {
                            type: 'name',
                            title: 'Interface',
                            content: 'Select the interface on which the entries will take effect.'
                        },
                        {
                            type: 'name',
                            title: 'Permit the packets matching the IP-MAC Binding entries only',
                            content:
                                'With this option enabled, when receiving a packet, the router will check whether the IP address, MAC address and receiving interface match any of the IP-MAC Binding entries. Only the  matched packets will be forwarded. This feature can be enabled only when ARP Spoofing Defense is enabled.'
                        },
                        {
                            type: 'name',
                            title: 'Send GARP packets when ARP attack is detected',
                            content:
                                'With this option enabled, the router will send GARP packets to the hosts if it detects ARP spoofing packets on the network. The GARP packets will inform the hosts of the correct ARP information, which is used to replace the wrong ARP information in the hosts. This feature can be  enabled only when ARP Spoofing Defense is enabled.'
                        },
                        {
                            type: 'name',
                            title: 'Interval',
                            content: 'Specify the time interval for sending GARP packets. The valid values are from 1 to 10000.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'IP-MAC Binding List',
                    children: [
                        {
                            type: 'name',
                            title: 'IP Address',
                            content: 'Specify the IP address to be bound.'
                        },
                        {
                            type: 'name',
                            title: 'MAC Address',
                            content: 'Specify the MAC address to be bound.'
                        },
                        {
                            type: 'name',
                            title: 'Interface',
                            content: 'Select the interface on which the entries will take effect.'
                        },
                        {
                            type: 'name',
                            title: 'Description',
                            content: 'Enter a description for identification.'
                        },
                        {
                            type: 'name',
                            title: 'Status',
                            content: 'Enable the entry. Only when the status is enabled will the entry take effect.'
                        }
                    ]
                }
            ]
        },

        ARPSCAN_INTRODUCT: {
            TITLE: 'ARP Scanning',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'With ARP Scanning, the router sends ARP request packets with the specified IP field to the hosts. Upon receiving the ARP reply packet, the router can get the IP address, MAC address and connected interface of the host. Then, you can bind these entries conveniently.</br></br>Before using this feature, make sure that your network is safe and the hosts are not suffering from ARP attacks at present; otherwise, you may obtain incorrect IP-MAC Binding entries. If your network is being attacked, it’s recommended to bind the  entries manually.'
                }
            ]
        },

        ARPSCAN_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Specify the IP range and click %<{"type":"button","text":"Scan"}>% to scan the IP addresses and MAC addresses.',
                        'View the scanning results and click %<{"type":"bindSpan","text":"Bind"}>% to add the desired entries to the IP-MAC Binding List.'
                    ]
                }
            ]
        },

        ARPSCAN_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Scanning IP Range',
                    content: 'Specify the scanning IP range, and the router will scan and record the entries in the IP address range.'
                },
                {
                    type: 'name',
                    title: 'Scanning Result',
                    content:
                        'The scanning result will be displayed in the table, and you can select the desired entries to add to the IP-MAC Binding List.'
                }
            ]
        },

        ARPLIST_SCAN: {
            TITLE: 'ARP List',
            CONTENT: [
                {
                    type: 'name',
                    title: 'ARP List',
                    content:
                        'The historical scanned ARP entries are displayed in ARP List. You can click %<{"type":"bindSpan","text":"Bind"}>% in Operation column to add the entries to the IP-MAC Binding List.'
                }
            ]
        },

        ATTCACK_DEFENSE_INTRODUCT: {
            TITLE: 'Attack Defense',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Attacks on a network device can cause device or network paralysis. With the Attack Defense feature, the router can identify and discard various attack packets, and limit the packet receiving rate. In this way, the router can protect itself and the connected network against malicious attacks.</br></br>The router provides two types of Attack Defense: Flood Defense and Packet Anomaly Defense. Flood Defense limits the receiving rate of the specific types of packets, and Packet Anomaly Defense discards the illegal packets directly.'
                }
            ]
        },

        ATTCACK_DEFENSE_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'Check the box of the desired kinds of defense and configure the parameters.'
                }
            ]
        },

        ATTCACK_DEFENSE_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Flood Defense',
                    children: [
                        {
                            type: 'name',
                            title: 'Multi-connections TCP SYN Flood',
                            content:
                                'With this feature enabled, the router will filter the subsequent TCP SYN packets if the number of this kind of packet reaches the specified threshold. The valid threshold ranges from 100 to 99999.'
                        },
                        {
                            type: 'name',
                            title: 'Multi-connections UDP Flood',
                            content:
                                'With this feature enabled, the router will filter the subsequent UDP packets if the number of this kind of packet reaches the specified threshold. The valid threshold ranges from 100 to 99999.'
                        },
                        {
                            type: 'name',
                            title: 'Multi-connections ICMP Floody',
                            content:
                                'With this feature enabled, the router will filter the subsequent ICMP packets if the number of this kind of packet reaches the specified threshold. The valid threshold ranges from 100 to 99999.'
                        },
                        {
                            type: 'name',
                            title: 'Stationary source TCP SYN Flood',
                            content:
                                'With this feature enabled, the router will filter the subsequent stationary source TCP SYN packets if the number of this kind of packet reaches the specified threshold. The valid threshold ranges from 100 to 99999.'
                        },
                        {
                            type: 'name',
                            title: 'Stationary source UDP Flood',
                            content:
                                'With this feature enabled, the router will filter the subsequent stationary source UDP packets if the number of this kind of packet reaches the specified threshold. The valid threshold ranges from 100 to 99999.'
                        },
                        {
                            type: 'name',
                            title: 'Stationary source ICMP Flood',
                            content:
                                'With this feature enabled, the router will filter the subsequent stationary source ICMP packets if the number of this kind of packet reaches the specified threshold. The valid threshold ranges from 100 to 99999.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Packet Anomaly Defense',
                    children: [
                        {
                            type: 'name',
                            title: 'Block TCP Scan (Stealth FIN/Xmas/Null)',
                            content: 'With this option enabled, the router will filter the TCP scan packets of Stealth FIN, Xmas and Null.'
                        },
                        {
                            type: 'name',
                            title: 'Block TCP Scan with RST',
                            content:
                                'With the option enabled, the router will automatically reply a RST packet when it receives TCP SYN packets; with the option disabled, the router will automatically drop the packets and not respond.'
                        },
                        {
                            type: 'name',
                            title: 'Block Ping of Death',
                            content:
                                'With this option enabled, the router will block Ping of Death attack. Ping of Death attack means that the attacker sends abnormal ping packets larger than 65535 bytes to cause system crash on the target computer.'
                        },
                        {
                            type: 'name',
                            title: 'Block Large Ping',
                            content:
                                'With this option enabled, the router will block Large Ping attacks. Large Ping attack means that the attacker sends multiple ping packets larger than 4000 bytes to cause system crash on the target computer.'
                        },
                        {
                            type: 'name',
                            title: 'Block Ping from WAN',
                            content: 'With this option enabled, the router will block the ICMP request from WAN.'
                        },
                        {
                            type: 'name',
                            title: 'Block WinNuke attack',
                            content:
                                'With this option enabled, the router will block WinNuke attacks. WinNuke attack refers to a remote denial-of-service attack (DoS) that affects some Windows operating system, such as the Windows 95 and Windows NT. The attacker sends a string of OOB (Out of Band) data to the target computer on TCP port 137, 138 or 139, causing system crash or Blue Screen of Death.'
                        },
                        {
                            type: 'name',
                            title: 'Block TCP packets with both SYN and FIN set',
                            content: 'With this option enabled, the router will filter the TCP packets with both SYN Bit and FIN Bit set.'
                        },
                        {
                            type: 'name',
                            title: 'Block TCP packets with FIN set but without ACK set',
                            content:
                                'With this option enabled, the router will filter the TCP packets with FIN Bit set but without ACK Bit set.'
                        },
                        {
                            type: 'name',
                            title: 'Block packets with specified IP options',
                            content:
                                'With this option enabled, the router will filter the packets with the IP options you have selected. You can select the options according to your needs.'
                        }
                    ]
                }
            ]
        },

        MAC_FILTERING_INTRODUCT: {
            TITLE: 'MAC Filtering',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'MAC Filtering can drop or allow packets from certain devices passing through the router based on the MAC address of the devices. After the MAC filtering policy and MAC filtering list are configured, the router will apply the filter policy to the packets matching the MAC address, and thus limit network traffic and manage network access behaviors.'
                }
            ]
        },
        MAC_FILTERING_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: ['Enable MAC Filtering and configure the general parameters.', 'Add MAC addresses to the MAC Filtering List.']
                }
            ]
        },

        MAC_FILTERING_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'General',
                    children: [
                        {
                            type: 'name',
                            title: 'Enable MAC Filtering',
                            content: 'Enable the MAC Filtering feature.'
                        },
                        {
                            type: 'name',
                            title: 'Allow packets with the MAC addresses listed below and deny the rest',
                            content:
                                'Select to allow packets with the listed MAC address to pass through the router, and packets with other MAC addresses will be dropped.'
                        },
                        {
                            type: 'name',
                            title: 'Deny packets with the MAC addresses listed below and allow the rest',
                            content:
                                'Select to drop packets with the listed MAC address, and the packets with other MAC addresses will be allowed to pass through the router.'
                        },
                        {
                            type: 'name',
                            title: 'Direction',
                            content:
                                'Select All when you want to apply the policy to traffic both from LAN to LAN and from LAN to WAN. Select LAN -> WAN when you want to apply the policy only to traffic from LAN to WAN.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'MAC Filtering List',
                    children: [
                        {
                            type: 'name',
                            title: 'Name',
                            content: 'Specify the name for the entry.'
                        },
                        {
                            type: 'name',
                            title: 'MAC Address',
                            content:
                                'Specify the MAC address of the device, and the MAC filtering policy will be applied to traffic with the MAC address.'
                        }
                    ]
                }
            ]
        },

        ACL_INTRODUCT: {
            TITLE: 'Access Control',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Access Control can filter the packets passing through the router based on the Access Control rules. An Access Control rule includes a filter policy and conditions including service type, receiving interface, source, destination, and effective time. The router will apply the filter policy to the packets matching these conditions, and thus limit network traffic and manage network access behaviors.</br></br>Access Control can prevent various network attacks, such as attacks on TCP (Transmission Control Protocol) and ICMP (Internet Control Message Protocol) packets, and it can also manage network access behaviors, such as controlling access to the internet.'
                }
            ]
        },

        ACL_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'Click %<{"type":"bindSpan","text":"Bind"}>% to add a new access control rule and configure the parameters.'
                }
            ]
        },

        ACL_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify a name for the rule. It can be 50 characters at most. The name of each entry cannot be the same.'
                },
                {
                    type: 'name',
                    title: 'Policy',
                    content: 'Select whether to block or allow the packets matching the rule to access the network.'
                },
                {
                    type: 'name',
                    title: 'Service Type',
                    content:
                        'Select the effective service for the rule. The service referenced here can be created on the Preferences > Service Type page.'
                },
                {
                    type: 'name',
                    title: 'Direction',
                    content: 'Select the effective traffic direction for the rule.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'ALL: Match the traffic in any direction.',
                                'LAN->WAN: Match the traffic from LAN to WAN.',
                                'LAN->LAN: Match the traffic from LAN to LAN.',
                                '[WAN] IN: Match the traffic coming in via [WAN].',
                                '[VPN] IN: Match the traffic coming in via [VPN].'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Source',
                    content:
                        'Select an IP group to specify the source address range for the rule. The IP group referenced here can be created on the Preferences > IP Group page.'
                },
                {
                    type: 'name',
                    title: 'Destination',
                    content:
                        'Select an IP group to specify the destination address range for the rule. The IP group referenced here can be created on the Preferences > IP Group page.',
                    children: [
                        {
                            type: 'note',
                            title: 'Note',
                            content: 'If you want to allow/block LAN management traffic, select Me as the Destination.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Source Network',
                    content:
                        'Select a LAN Network to specify the source network for the rule. The LAN Network referenced here can be created on the Network>LAN page.'
                },
                {
                    type: 'name',
                    title: 'Destination Network',
                    content:
                        'Select a LAN Network to specify the destination network for the rule. The LAN Network referenced here can be created on the Network>LAN page.'
                },
                {
                    type: 'name',
                    title: 'Effective Time',
                    content:
                        'Select the effective time for the rule. The effective time referenced here can be created on the Preferences > Time Range page.'
                },
                {
                    type: 'name',
                    title: 'ID',
                    content:
                        'Specify a rule ID. A smaller ID means a higher priority. This value is optional, and the newly added rule without this value configured will get the largest ID among all rules, which means the newly added rule has the lowest priority.'
                }
            ]
        },

        APPDIST_SETTING: {
            TITLE: 'General',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'With Application Control, you can block the specified users from using the specified applications.'
                },
                {
                    type: 'name',
                    title: 'Enable Application Control',
                    content: 'Check the box to enable Application Control.'
                }
            ]
        },
        APPDIST_LIST: {
            TITLE: 'Application Control List',
            CONTENT: [
                {
                    type: 'name',
                    title: 'IP Group',
                    content:
                        'Select an IP group for the rule. The IP group referenced here can be created on the Preferences>IP Group page.'
                },
                {
                    type: 'name',
                    title: 'Blacklist',
                    content: 'Select one or more applications to be blocked.'
                },
                {
                    type: 'name',
                    title: 'Effective Time',
                    content:
                        'Select the effective time for the rule. The effective time referenced here can be created on the Preferences>Time Range page.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for the rule.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },
        WEB_FILTER_INTRODUCT: {
            TITLE: 'Web Filtering',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'With the Web Filtering feature, the router blocks specific local users’ access to the specific websites. The router supports two methods of web filtering, which you can choose according to your needs:'
                },
                {
                    type: 'name',
                    title: 'Web Group Filtering',
                    content:
                        'The router allows or denies access to specific websites according to filtering rules. The filtering rules are based on web groups, and a web group can contain one or multiple websites. To configure Web Group Filtering, follow the guidelines:',
                    children: [
                        {
                            type: 'pearlStep',
                            content: [
                                'In Web Group, create web groups which will be applied to the filtering rules.',
                                'In Web Group Filtering, create filtering rules and enable web filtering globally.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'URL Filtering',
                    content:
                        'The router allows or denies access to specific URLs according to filtering rules. The filtering  rules  are  based  on  a  group  of  keywords  or  URL  paths.  To  configure  URL Filtering, follow the guidelines:</br>In URL Filtering, create filtering rules and enable web filtering globally.'
                }
            ]
        },

        WEB_GROUP_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>%.',
                        'Configure the web group members among other parameters and click %<{"type":"button","text":"OK"}>%.'
                    ]
                }
            ]
        },

        WEB_GROUP_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify a name for the web group. The name is the unique identifier for the web group.'
                },
                {
                    type: 'name',
                    title: 'Member',
                    content:
                        'Add one or more website members to the group. The format of the website members is "www.tp-link.com" or "*.tp-link.com", in which "*" is a wildcard. Use Enter key, Space key, "," or ";" to divide different websites.'
                },
                {
                    type: 'name',
                    title: 'File Path',
                    content:
                        'Import the member list from a TXT file on your host. The format of the website members is "www.tp-link.com" or "*.tp-link.com", in which "*" is a wildcard. Use Enter key, Space key, "," or ";" to divide different websites.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for the group.'
                }
            ]
        },

        WEB_GROUP_FILTER_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'In Web Filtering List, click %<{"type":"addSpan","text":"Add"}>% to add a filtering rule. Configure parameters for the filtering rule and click %<{"type":"button","text":"OK"}>%. You can add multiple filtering rules.',
                        'In General, enable Web Filtering gloabally and click %<{"type":"button","text":"Save"}>%.'
                    ]
                }
            ]
        },

        WEB_GROUP_FILTER_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'General',
                    children: [
                        {
                            type: 'name',
                            title: 'Enable Web Filtering',
                            content: 'Check the box to enable Web Filtering globally.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Web Filtering List',
                    children: [
                        {
                            type: 'name',
                            title: 'IP Group',
                            content:
                                'Select an IP group for the filtering rule. The filtering rule only affects the hosts in the IP group. To configure IP group, go to Preferences > IP Group.'
                        },
                        {
                            type: 'name',
                            title: 'Policy',
                            content: 'Choose whether to allow or block access to the websites in the selected web groups.'
                        },
                        {
                            type: 'name',
                            title: 'Web Group',
                            content:
                                'Select one or more web groups for the filtering rule. The filtering rule allows or block access to the websites in the selected web groups.'
                        },
                        {
                            type: 'name',
                            title: 'Effective Time',
                            content:
                                'Select the time range when the filtering rule takes effect. To configure the time range, go to Preferences > Time Range.'
                        },
                        {
                            type: 'name',
                            title: 'Description',
                            content: 'Enter a brief description for the filtering rule.'
                        },
                        {
                            type: 'name',
                            title: 'ID',
                            content:
                                'Specify an ID for the filtering rule. A smaller ID means a higher priority. This value is optional. A newly added rule with this field left blank will get the largest ID among all rules, which means that the newly added rule has the lowest priority.'
                        },
                        {
                            type: 'name',
                            title: 'Status',
                            content: 'Check the box to enable the filtering rule.'
                        }
                    ]
                }
            ]
        },

        URL_FILTER_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'In URL Filtering List, click %<{"type":"addSpan","text":"Add"}>% to add a filtering rule. Configure parameters for the filtering rule and click %<{"type":"button","text":"OK"}>%. You can add multiple filtering rules.',
                        'In General, enable URL Filtering gloabally and click %<{"type":"button","text":"Save"}>%.'
                    ]
                }
            ]
        },

        URL_FILTER_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'General',
                    children: [
                        {
                            type: 'name',
                            title: 'Enable URL Filtering',
                            content: 'Check the box to enable URL Filtering globally.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'URL Filtering List',
                    children: [
                        {
                            type: 'name',
                            title: 'IP Group',
                            content:
                                'Select an IP group for the filtering rule. The filtering rule only affects the hosts in the IP group. To configure IP group, go to Preferences > IP Group.'
                        },
                        {
                            type: 'name',
                            title: 'Policy',
                            content: 'Choose whether to allow or block access to the URLs which match the filtering content.'
                        },
                        {
                            type: 'name',
                            title: 'Mode',
                            content:
                                'Choose a mode for the filtering content to match the URL.</br>&nbsp&nbsp&nbsp&nbspKeywords: If a URL contains any of the keywords specified in the filtering content, the filtering rule will be applied to this URL.</br>&nbsp&nbsp&nbsp&nbspURL Path: If a URL is the same as any of the entire URL rules specified in the filtering content, the filtering rule will be applied to this URL.'
                        },
                        {
                            type: 'name',
                            title: 'Filtering Content',
                            content:
                                'Add the filtering content. Use the Enter key, Space key, "," or ";" to divide different entries of the filtering content. "." means that this rule will be applied to any URL. For example, if you want to allow URL A and deny other URLs, you can add an Allow rule with the filtering content "A" and add a Deny rule with the filtering content ".". Note that the "." rule should have the largest ID number, which means that it has the lowest priority.'
                        },
                        {
                            type: 'name',
                            title: 'Effective Time',
                            content:
                                'Select the time range when the filtering rule takes effect. To configure the time range, go to Preferences > Time Range.'
                        },
                        {
                            type: 'name',
                            title: 'Status',
                            content: 'Check the box to enable the filtering rule.'
                        },
                        {
                            type: 'name',
                            title: 'Description',
                            content: 'Enter a brief description for the filtering rule'
                        },
                        {
                            type: 'name',
                            title: 'ID',
                            content:
                                'Specify an ID for the filtering rule. A smaller ID means a higher priority. This value is optional. A newly added rule with this field left blank will get the largest ID among all rules, which means that the newly added rule has the lowest priority.'
                        }
                    ]
                }
            ]
        },

        WEB_SECURITY_INTRODUCT: {
            TITLE: 'Web Security',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Web Security is used to control the specific online behaviors of local users. You can configure this feature to block HTTP post, which means that the local users cannot log in, submit comments or perform any other operation which needs HTTP post. Also, you can prohibit local users from downloading specific types of files from the internet.'
                }
            ]
        },

        WEB_SECURITY_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'In Web Security List, click %<{"type":"addSpan","text":"Add"}>% to add a web security rule. Configure parameters for the rule and click %<{"type":"button","text":"OK"}>%. You can add multiple web security rules.',
                        'In General, enable Web Security gloabally and click %<{"type":"button","text":"Save"}>%.'
                    ]
                }
            ]
        },

        WEB_SECURITY_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'General',
                    children: [
                        {
                            type: 'name',
                            title: 'Enable Web Security',
                            content: 'Check the box to enable Web Security.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Web Security List',
                    children: [
                        {
                            type: 'name',
                            title: 'IP Group',
                            content:
                                'Select an IP group for the web security rule. The rule only affects the hosts in the IP group. To configure IP group, go to Preferences > IP Group.'
                        },
                        {
                            type: 'name',
                            title: 'Block HTTP Post',
                            content:
                                'With this option enabled, HTTP post will be blocked. The hosts of the selected IP group cannot log in, submit comments or do any operation using HTTP post.'
                        },
                        {
                            type: 'name',
                            title: 'File Suffix',
                            content:
                                'Enter file suffixes to specify the file types. Use Enter key, Space key, "," or ";" to divide different file suffixes. The hosts of the selected IP group cannot download these types of files from the internet.'
                        },
                        {
                            type: 'name',
                            title: 'Effective Time',
                            content:
                                'Select the time range when the web security rule takes effect. To configure the time range, go to Preferences > Time Range.'
                        },
                        {
                            type: 'name',
                            title: 'Description',
                            content: 'Enter a brief description for the web security rule.'
                        },
                        {
                            type: 'name',
                            title: 'Status',
                            content: 'Check the box to enable the web security rule.'
                        }
                    ]
                }
            ]
        },

        APPDIST_DB: {
            TITLE: 'Application Database Upgrade',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can import a database file to upgrade the application database of the router.'
                },
                {
                    type: 'name',
                    title: 'Current Version',
                    content: 'Displays the current database version.'
                },
                {
                    type: 'name',
                    title: 'Database File',
                    content: 'Select the database file from your host.'
                }
            ]
        },
        IPSEC_INTRODUCT: {
            TITLE: 'IPsec VPN',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'IPsec (IP Security) can provide security services such as data confidentiality, data integrity and data origin authentication at the IP layer. IPsec uses IKEv1 (Internet Key Exchange version 1) to handle  negotiation of protocols and algorithms based on the user-specified policy, and generate the encryption and authentication keys to be used by IPsec. IKEv1 negotiation includes two phases, that is IKEv1 Phase-1 and IKEv1 Phase-2.'
                }
            ]
        },

        IPSEC_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: ['Configure the IPsec Policy.', 'Check the IPsec SA list to verify the connectivity of the IPsec VPN tunnel.']
                }
            ]
        },
        IPSEC_TUNNEL_PARA: {
            TITLE: 'IPsec Policy',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'You can configure the IPsec policy on this page. The IPsec policy indicates which IPsec proposal to be applied to the specific data flow. IPsec policy settings include basic settings and advanced settings. Advanced settings are optional.',
                    children: [
                        {
                            type: 'name',
                            title: 'Policy Name',
                            content: 'Enter a name to identify the IPsec policy.'
                        },
                        {
                            type: 'name',
                            title: 'Mode',
                            content:
                                'Configure the Network Mode. Select LAN-to-LAN when the network is connected to the other network. Select Client-to-LAN when a host is connected to the network.'
                        },
                        {
                            type: 'paragraph',
                            content: 'When the <b>LAN-to-LAN</b> mode is selected,'
                        },
                        {
                            type: 'name',
                            title: 'Remote Gatway',
                            content:
                                'Enter an IP address or a domain name (1 to 255 characters) as the remote gateway. 0.0.0.0 represents any IP address. Only when the negotiation mode is set to Responder Mode in Phase-1 Settings can you enter 0.0.0.0.'
                        },
                        {
                            type: 'name',
                            title: 'WAN',
                            content: 'Specify the WAN port on which the IPsec tunnel is established.'
                        },
                        {
                            type: 'name',
                            title: 'Local Subnet',
                            content:
                                'Specify the local network. It’s always the IP address range of LAN on the local side of the VPN tunnel. It’s formed from the IP address and subnet mask. After the IPsec tunnel is established, the peer can access the local subnet.'
                        },
                        {
                            type: 'name',
                            title: 'Remote Subnet',
                            content:
                                'Specify the remote network. It’s always the IP address range of LAN on the remote peer of the VPN tunnel. It’s formed from the IP address and subnet mask. Only the traffic to the remote  subnet will be forwarded through the IPsec tunnel.'
                        },
                        {
                            type: 'name',
                            title: 'Pre-shared Key',
                            content: 'Specify the unique pre-shared key for both peers’ authentication.'
                        },
                        {
                            type: 'name',
                            title: 'Status',
                            content: 'Check the box to enable the IPsec policy.'
                        },
                        {
                            type: 'paragraph',
                            content: 'When the <b>Client-to-LAN</b> mode is selected,'
                        },
                        {
                            type: 'name',
                            title: 'Remote Host',
                            content: 'Enter the IP address of the remote host. 0.0.0.0 represents any IP address.'
                        },
                        {
                            type: 'name',
                            title: 'WAN',
                            content: 'Specify the WAN port on which the IPsec tunnel is established.'
                        },
                        {
                            type: 'name',
                            title: 'Local Subnet',
                            content:
                                'Specify the local network. (This is the IP address range of the LAN on the local side of the VPN tunnel.) It’s formed from the IP address and subnet mask. After the IPsec tunnel is  established, the peer can access the local subnet.'
                        },
                        {
                            type: 'name',
                            title: 'Pre-shared Key',
                            content: 'Specify the unique pre-shared key for both peers’ authentication.'
                        },
                        {
                            type: 'name',
                            title: 'Status',
                            content: 'Check the box to enable the IPsec policy.'
                        },
                        {
                            type: 'paragraph',
                            content: '<b>Advanced Settings</b>'
                        },
                        {
                            type: 'paragraph',
                            content: '<b>In the Phase-1 Settings section, configure the IKE phase-1 parameters</b>'
                        },
                        {
                            type: 'name',
                            title: 'Proposal',
                            content:
                                'Select the proposal for IKE negotiation phase 1 to specify the encryption algorithm, authentication algorithm and DH group. Up to four proposals can be selected. The IPsec SA can be established only when the proposals at both ends of IPsec exactly match.'
                        },
                        {
                            type: 'name',
                            title: 'Exchange Mode',
                            content:
                                'Specify the IKE Exchange Mode as Main Mode or Aggressive Mode. By default, it is Main Mode.</br>&nbsp&nbsp&nbsp&nbspMain Mode: Main mode provides identity protection and exchanges more information, which applies to scenarios with higher requirements for identity protection.</br>&nbsp&nbsp&nbsp&nbspAggressive Mode: Aggressive Mode establishes a faster connection but with lower security, which applies to scenarios with lower requirements for identity protection, or scenarios that there is a NAT device (e.g. modem) in front of the devices at both ends of the IPsec.'
                        },
                        {
                            type: 'name',
                            title: 'Negotiation Mode',
                            content:
                                'Specify the IKE Negotiation Mode as Initiator Mode or Responder Mode.</br>&nbsp&nbsp&nbsp&nbspInitiator Mode: The local device initiates a connection to the peer.</br>&nbsp&nbsp&nbsp&nbspInitiator Mode: The local device initiates a connection to the peer.'
                        },
                        {
                            type: 'name',
                            title: 'Local ID Type',
                            content:
                                'Specify the local ID type for IKE negotiation.</br>&nbsp&nbsp&nbsp&nbspIP Address: Use an IP address as the ID in IKE negotiation. It is the default type.</br>&nbsp&nbsp&nbsp&nbspNAME: Use a name as the ID in IKE negotiation. It refers to FQDN (Fully Qualified Domain Name). When there is a NAT device (e.g. modem) in front of the both end routers of IPsec, the Name type can be used.'
                        },
                        {
                            type: 'name',
                            title: 'Local ID',
                            content:
                                'When the Local ID Type is configured as NAME, enter a name for the local device as the ID in IKE negotiation.'
                        },
                        {
                            type: 'name',
                            title: 'Remote ID Type',
                            content:
                                'Specify the remote ID type for IKE negotiation.</br>&nbsp&nbsp&nbsp&nbspIP Address: Use an IP address as the ID in IKE negotiation. It is the default type.</br>&nbsp&nbsp&nbsp&nbspNAME: Use a name as the ID in IKE negotiation. It refers to FQDN (Fully Qualified Domain Name). When there is a NAT device (e.g. modem) in front of the both end routers of IPsec, the Name type can be used.'
                        },
                        {
                            type: 'name',
                            title: 'Remote ID',
                            content:
                                'When the Remote ID Type is configured as NAME, enter a name of the remote peer as the ID in IKE negotiation.'
                        },
                        {
                            type: 'name',
                            title: 'SA Lifetime',
                            content:
                                'Specify ISAKMP SA (Security Association) Lifetime in IKE negotiation. If the SA lifetime expires, the related ISAKMP SA will be deleted, then both peers renegotiate to establish ISAKMP SA to ensure security.'
                        },
                        {
                            type: 'name',
                            title: 'DPD',
                            content:
                                'Check the box to enable or disable DPD (Dead Peer Detect) function. If enabled, the IKE endpoint can send a DPD request to the peer to inspect whether the IKE peer is alive.'
                        },
                        {
                            type: 'name',
                            title: 'DPD Interval',
                            content:
                                'If DPD is triggered, specify the interval between sending DPD requests. If the IKE endpoint receives a response from the peer during this interval, it considers the peer alive. If the IKE endpoint does not receive a response during the interval, it considers the peer dead and deletes the SA.'
                        },
                        {
                            type: 'paragraph',
                            content: '<b>In the Phase-2 Settings section, configure the IKE phase-2 parameters</b>'
                        },
                        {
                            type: 'name',
                            title: 'Encapsulation Mode',
                            content:
                                'Specify the Encapsulation Mode as Tunnel Mode or Transport Mode. When both ends of the tunnel are hosts, either mode can be chosen. When at least one of the endpoints of a tunnel is a  security gateway, tunnel mode is recommended to ensure safety.'
                        },
                        {
                            type: 'name',
                            title: 'Proposal',
                            content:
                                'Select the proposal for IKE negotiation phase 2 to specify the encryption algorithm, authentication algorithm and protocol. Up to four proposals can be selected.'
                        },
                        {
                            type: 'name',
                            title: 'PFS',
                            content:
                                'Select the DH group to enable PFS (Perfect Forward Security) for IKE mode, then the key generated in phase 2 will be irrelevant with the key in phase 1, which enhance the network security. If you select None, it means PFS is disabled and the key in phase 2 will be generated based on the key in phase 1.'
                        },
                        {
                            type: 'name',
                            title: 'SA Lifetime',
                            content:
                                'Specify IPsec SA (Security Association) Lifetime in IKE negotiation. If the SA lifetime expires, the related IPsec SA will be deleted, then both peers renegotiate to establish ISAKMP SA.'
                        }
                    ]
                }
            ]
        },

        IPSEC_SA_PARA: {
            TITLE: 'IPsec SA',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'The IPSec SA List shows the information of the established IPSec VPN tunnel.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Displays the name of the IPSec policy associated with the SA.'
                },
                {
                    type: 'name',
                    title: 'SPI',
                    content:
                        'Displays the SPI (Security Parameter Index) of the SA, including outgoing SPI and incoming SPI. The SPI of each SA is unique.'
                },
                {
                    type: 'name',
                    title: 'Direction',
                    content: 'Displays the direction (in: incoming/out: outgoing) of the SA.'
                },
                {
                    type: 'name',
                    title: 'Tunnel ID',
                    content: 'Displays the IP addresses of the local and remote peers.'
                },
                {
                    type: 'name',
                    title: 'Data Flow',
                    content: 'Displays the Local Subnet and Remote Subnet/host covered by the SA.'
                },
                {
                    type: 'name',
                    title: 'Protocol',
                    content: 'Displays the authentication protocol and encryption protocol used by the SA.'
                },
                {
                    type: 'name',
                    title: 'AH Authentication',
                    content: 'Displays the AH authentication algorithm used by the SA.'
                },
                {
                    type: 'name',
                    title: 'ESP Authentication',
                    content: 'Displays the ESP authentication algorithm used by the SA.'
                },
                {
                    type: 'name',
                    title: 'ESP Encryption',
                    content: 'Displays the ESP encryption algorithm used by the SA.'
                }
            ]
        },

        OPENVPN_INTRODUCT: {
            TITLE: 'OpenVPN',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'OpenVPN uses OpenSSL for encryption of UDP and TCP for traffic transmission. OpenVPN uses a client-server connection to provide secure communications between a server and a remote client over the internet.'
                }
            ]
        },

        OPENVPN_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Configure the OpenVPN server/client.',
                        'Check the tunnel list to verify the connectivity of the OpenVPN tunnel.'
                    ]
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: 'If you only use the router as the OpenVPN server, you don’t need to configure the OpenVPN client.'
                }
            ]
        },

        OPENVPN_SERVER_PARA: {
            TITLE: 'OpenVPN Server',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'Click <b>Add</b> to add an OpenVPN server.'
                },
                {
                    type: 'name',
                    title: 'Server Name',
                    content: 'Enter a name to identify the VPN server.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the OpenVPN server.'
                },
                {
                    type: 'name',
                    title: 'Protocol',
                    content:
                        'Select the communication protocol for the gateway which works as an OpenVPN Server. Two communication protocols are available: TCP and UDP.'
                },
                {
                    type: 'name',
                    title: 'Service Port',
                    content: 'Enter a VPN service port to which a VPN device connects. The default port is 1194.'
                },
                {
                    type: 'name',
                    title: 'Local Network',
                    content:
                        'Select the network on the local side of the VPN tunnel. The VPN policy will be only applied to the selected local network.'
                },
                {
                    type: 'name',
                    title: 'WAN',
                    content:
                        'Select the WAN port on which the VPN tunnel is established. Each WAN port supports only one OpenVPN tunnel when the gateway works as a OpenVPN server.'
                },
                {
                    type: 'name',
                    title: 'IP Pool',
                    content:
                        'Enter the IP address and subnet mask to decide the range of the VPN IP pool. The VPN server will assign IP address to the remote host when the tunnel is established. You can specify any reasonable IP address that will not cause overlap with the IP address of the LAN on the local peer router.'
                },
                {
                    type: 'paragraph',
                    content:
                        'Click %<{"type":"button","text":"OK"}>% to save the settings. Then click %<{"type":"uploadSpan","text":""}>% in the <b>Operation</b> column to export the OpenVPN file that ends in .ovpn which is to be used by the remote client. The exported OpenVPN file contains the certificate and configuration information. It may take about 2 minutes to export the certificate.'
                }
            ]
        },

        OPENVPN_CLIENT_PARA: {
            TITLE: 'OpenVPN Client',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Click <b>Add</b> to add a OpenVPN client. The router will act as an OpenVPN client to establish the VPN tunnel with the remote Server.'
                },
                {
                    type: 'name',
                    title: 'Client Name',
                    content: 'Specify the name of OpenVPN client.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the OpenVPN client.'
                    //    }, {
                    //                type: "name",
                    //                title: "Protocol",
                    // 			   content: "Select the communication protocol for the gateway which works as an OpenVPN Client. Two communication protocols are available: TCP and UDP. It should be the same as the OpenVPN server."
                },
                {
                    type: 'name',
                    title: 'Service Port',
                    content: 'Enter a VPN service port to which a VPN device connects. The default port is 1194.'
                },
                {
                    type: 'name',
                    title: 'Remote Server',
                    content: 'Enter the IP address of the OpenVPN server.'
                },
                {
                    type: 'name',
                    title: 'Local Network',
                    content:
                        'Select the network on the local side of the VPN tunnel. The VPN policy will be only applied to the selected local network.'
                },
                {
                    type: 'name',
                    title: 'WAN',
                    content: 'Select the WAN port on which the VPN tunnel is established.'
                },
                {
                    type: 'name',
                    title: 'File Path',
                    content: 'Browse the file to find the OpenVPN file that ends in .ovpn generated by the OpenVPN server.'
                },
                {
                    type: 'name',
                    title: 'Import',
                    content:
                        'Click this button to import the OpenVPN file that ends in .ovpn generated by the OpenVPN server. Only one file can be imported. If the certificate file and configuration file are generated singly by the OpenVPN server, combine two files and import the whole file.'
                }
            ]
        },

        OPENVPN_TUNNEL_PARA: {
            TITLE: 'Tunnel List',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Displays the account name of OpenVPN server/client.'
                },
                {
                    type: 'name',
                    title: 'WAN',
                    content: 'Displays the WAN port on which the VPN tunnel is established.'
                },
                {
                    type: 'name',
                    title: 'Local IP',
                    content: 'Displays the assigned virtual local IP address of the tunnel.'
                },
                {
                    type: 'name',
                    title: 'Remote IP',
                    content: 'Displays the assigned virtual remote local IP address of the tunnel.'
                },
                {
                    type: 'name',
                    title: 'Up Bytes',
                    content: 'Displays the upstream throughput.'
                },
                {
                    type: 'name',
                    title: 'Down Bytes',
                    content: 'Displays the downstream throughput.'
                },
                {
                    type: 'name',
                    title: 'Up Time',
                    content: 'Displays how long the tunnel has been up.'
                }
            ]
        },

        L2TP_INTRODUCT: {
            TITLE: 'L2TP VPN',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'L2TP (Layer 2 Tunneling Protocol) provides a way for a dial-up user to make a virtual PPP (Point-to-Point Protocol) connection to a VPN server. Because of the lack of confidentiality inherent in the L2TP protocol, it is often implemented along with IPsec.'
                }
            ]
        },

        L2TP_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Configure the VPN IP pool. Go to Preferences > VPN IP Pool for settings.',
                        'Configure L2TP globally.',
                        'Configure the L2TP server/client.',
                        '(Optional) Configure the L2TP users. Go to VPN > Users for settings.',
                        'Check the tunnel list to verify the connectivity of the L2TP VPN tunnel.'
                    ]
                },
                {
                    type: 'note',
                    title: 'Note',
                    content:
                        'If you only use the router as the L2TP server, you don’t need to configure the L2TP client, please directly go to VPN > Users to create accounts for your clients.'
                }
            ]
        },

        L2TP_SERVER_PARA: {
            TITLE: 'L2TP Server',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Click %<{"type":"addSpan","text":"Add"}>% to add a L2TP server. Then go to VPN > Users to configure the L2TP users.'
                },
                {
                    type: 'name',
                    title: 'WAN',
                    content: 'Specify the WAN port used for L2TP tunnel.'
                },
                {
                    type: 'name',
                    title: 'IPsec Encryption',
                    content:
                        'Specify whether to enable the encryption for the tunnel. If enabled, the L2TP tunnel will be encrypted by IPsec (L2TP over IPsec). If you choose Auto, the L2TP server will determine whether to encrypt the tunnel according to the client ‘s encryption settings.'
                },
                {
                    type: 'name',
                    title: 'Pre-shared Key',
                    content:
                        'When the IPsec Encryption is configured as Encrypted or Auto, specify the Pre-shared Key for IKE authentication.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the L2TP tunnel.'
                }
            ]
        },

        L2TP_CLIENT_PARA: {
            TITLE: 'L2TP Client',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Click %<{"type":"addSpan","text":"Add"}>% to add a L2TP client. The router will act as a L2TP client to establish the VPN tunnel with the remote Server.'
                },
                {
                    type: 'name',
                    title: 'Tunnel',
                    content: 'Specify the name of L2TP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Account Name',
                    content: 'Specify the account name of L2TP tunnel. It should be configured identically on server and client.'
                },
                {
                    type: 'name',
                    title: 'Password',
                    content: 'Specify the password of L2TP tunnel. It should be configured identically on server and client.'
                },
                {
                    type: 'name',
                    title: 'WAN',
                    content: 'Specify the WAN port used for L2TP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Server IP',
                    content: 'Specify the IP address or domain name of L2TP server.'
                },
                {
                    type: 'name',
                    title: 'IPSec Encryption',
                    content:
                        'Specify whether to enable the encryption for the tunnel. If enabled, the L2TP tunnel will be encrypted by IPSec (L2TP over IPSec). Please follow the configuration of L2TP Server.'
                },
                {
                    type: 'name',
                    title: 'Pre-shared Key',
                    content: 'When the IPsec Encryption is configured as Encrypted, specify the Pre-shared Key for IKE authentication.'
                },
                {
                    type: 'name',
                    title: 'Remote Subnet',
                    content:
                        'Specify the remote network. It’s always the IP address range of LAN on the remote peer of the VPN tunnel. It’s the combination of IP address and subnet mask. Traffic to the remote network will be forwarded via L2TP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Upstream Bandwidth',
                    content: 'Specify the upstream limited rate in Kbps for L2TP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Downstream  Bandwidth',
                    content: 'Specify the downstream limited rate in Kbps for L2TP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Working Mode',
                    content: 'Specify the Working Mode as NAT or Routing.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'NAT: NAT (Network Address Translation) mode allows the router to translate source IP address of L2TP packets to its WAN IP when forwarding L2TP packets. This working mode is recommended when  the network mode is configured as Client-to-LAN.',
                                'Route: Route mode allows the router to forward L2TP packets via routing protocol.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the L2TP tunnel.'
                }
            ]
        },

        L2TP_GLOBAL_PARA: {
            TITLE: 'Global Config',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'In the General section, configure L2TP parameters globally.'
                },
                {
                    type: 'name',
                    title: 'L2TP Hello Interval',
                    content: 'Specify the time interval of sending L2TP peer detect packets.'
                },
                {
                    type: 'name',
                    title: 'PPP Hello Interval',
                    content: 'Specify the time interval of sending PPP peer detect packets.'
                },
                {
                    type: 'name',
                    title: 'NetBIOS Passthrough',
                    content: 'Enable NetBIOS Passthrough function to allow NetBIOS packets to be broadcasted through VPN tunnel'
                }
            ]
        },

        L2TP_TUNNEL_PARA: {
            TITLE: 'Tunnel List',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Account Name',
                    content: 'Displays the account name of L2TP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Mode',
                    content: 'Displays whether the device is server or client.'
                },
                {
                    type: 'name',
                    title: 'Tunnel',
                    content: 'Displays the name of the tunnel when the router is an L2TP client.'
                },
                {
                    type: 'name',
                    title: 'Local IP',
                    content: 'Displays the local IP address of the tunnel.'
                },
                {
                    type: 'name',
                    title: 'Remote IP',
                    content: 'Displays the remote public IP address of the tunnel.'
                },
                {
                    type: 'name',
                    title: 'Remote Local IP',
                    content: 'Displays the remote local IP address of the tunnel.'
                },
                {
                    type: 'name',
                    title: 'DNS',
                    content: 'Displays the DNS address of the tunnel.'
                }
            ]
        },

        PPTP_INTRODUCT: {
            TITLE: 'PPTP VPN',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'PPTP (Point-to-Point Tunneling Protocol) is a network protocol that enables the secure transfer of data from a remote client to a private enterprise server by creating a VPN across  TCP/IP-based data networks. PPTP supports on-demand, multi- protocol, and virtual private networking over public networks, such as the internet.'
                }
            ]
        },

        PPTP_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Configure the VPN IP pool. Go to Preferences > VPN IP Pool for settings.',
                        'Configure PPTP globally.',
                        'Configure the PPTP server/client.',
                        '(Optional) Configure the PPTP users. Go to VPN > Users for settings.',
                        'Check the tunnel list to verify the connectivity of the PPTP VPN tunnel.'
                    ]
                },
                {
                    type: 'note',
                    title: 'Note',
                    content:
                        'If you only use the router as the PPTP server, you don’t need to configure the PPTP client, please directly go to VPN > Users to create accounts for your clients.'
                }
            ]
        },

        PPTP_SERVER_PARA: {
            TITLE: 'PPTP Server',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Click %<{"type":"addSpan","text":"Add"}>% to add a PPTP server. Then go to VPN > Users to configure the PPTP users.'
                },
                {
                    type: 'name',
                    title: 'WAN',
                    content: 'Specify the WAN port used for PPTP tunnel.'
                },
                {
                    type: 'name',
                    title: 'MPPE Encryption',
                    content: 'Specify whether to enable the MPPE encryption for the PPTP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the PPTP tunnel.'
                }
            ]
        },

        PPTP_CLIENT_PARA: {
            TITLE: 'PPTP Client',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Click %<{"type":"addSpan","text":"Add"}>% to add a PPTP client. The router will act as a PPTP client to establish the VPN tunnel with the remote Server.'
                },
                {
                    type: 'name',
                    title: 'Tunnel',
                    content: 'Specify the name of PPTP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Account Name',
                    content: 'Specify the account name of PPTP tunnel. It should be configured identically on server and client.'
                },
                {
                    type: 'name',
                    title: 'Password',
                    content: 'Specify the password of PPTP tunnel. It should be configured identically on server and client.'
                },
                {
                    type: 'name',
                    title: 'WAN',
                    content: 'Specify the WAN port used for PPTP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Server IP',
                    content: 'Specify the IP address or domain name of PPTP server.'
                },
                {
                    type: 'name',
                    title: 'MPPE  Encryption',
                    content:
                        'Specify whether to enable the encryption for the tunnel. If enabled, the PPTP tunnel will be encrypted by MPPE.'
                },
                {
                    type: 'name',
                    title: 'Remote Subnet',
                    content:
                        'Specify the remote network. It’s always the IP address range of LAN on the remote peer of the VPN tunnel. It’s the combination of IP address and subnet mask. Traffic to the remote network will be forwarded via PPTP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Upstream Bandwidth',
                    content: 'Specify the upstream limited rate in Kbps for PPTP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Downstream  Bandwidth',
                    content: 'Specify the downstream limited rate in Kbps for PPTP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Working Mode',
                    content: 'Specify the Working Mode as NAT or Routing.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'NAT: NAT (Network Address Translation) mode allows the router to translate source IP address of PPTP packets to its WAN IP when forwarding PPTP packets. This working mode is recommended when  the network mode is configured as Client-to-LAN.',
                                'Route: Route mode allows the router to forward PPTP packets via routing protocol.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the PPTP tunnel.'
                }
            ]
        },

        PPTP_GLOBAL_PARA: {
            TITLE: 'Global Config',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'In the General section, configure PPTP parameters globally.'
                },
                {
                    type: 'name',
                    title: 'PPTP Hello Interval',
                    content: 'Specify the time interval of sending PPTP peer detect packets.'
                },
                {
                    type: 'name',
                    title: 'PPP Hello Interval',
                    content: 'Specify the time interval of sending PPP peer detect packets.'
                },
                {
                    type: 'name',
                    title: 'NetBIOS Passthrough',
                    content: 'Enable NetBIOS Passthrough function to allow NetBIOS packets to be broadcasted through VPN tunnel'
                }
            ]
        },

        PPTP_TUNNEL_PARA: {
            TITLE: 'Tunnel List',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Account',
                    content: 'Displays the account name of PPTP tunnel.'
                },
                {
                    type: 'name',
                    title: 'Mode',
                    content: 'Displays whether the device is server or client.'
                },
                {
                    type: 'name',
                    title: 'Tunnel',
                    content: 'Displays the name of the tunnel when the router is an PPTP client.'
                },
                {
                    type: 'name',
                    title: 'Local IP',
                    content: 'Displays the local IP address of the tunnel.'
                },
                {
                    type: 'name',
                    title: 'Remote IP',
                    content: 'Displays the remote public IP address of the tunnel.'
                },
                {
                    type: 'name',
                    title: 'Remote Local IP',
                    content: 'Displays the remote local IP address of the tunnel.'
                },
                {
                    type: 'name',
                    title: 'DNS',
                    content: 'Displays the DNS address of the tunnel.'
                }
            ]
        },

        VPNUSER_INTRODUCT: {
            TITLE: 'Users',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Create VPN connection accounts for remote devices to connect to the VPN server.</br></br>If the router acts as the L2TP/PPTP client, you don’t need to configure the L2TP/ PPTP user accounts on this page.'
                }
            ]
        },
        VPNUSER_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Account Name',
                    content: 'Specify the account name used for the VPN tunnel.'
                },
                {
                    type: 'name',
                    title: 'Password',
                    content:
                        'Specify the account password used for the VPN tunnel. Your VPN clients will use the account name and password for authentication.'
                },
                {
                    type: 'name',
                    title: 'Protocol',
                    content: 'Specify the protocol for the VPN tunnel. There are two types: L2TP and PPTP.'
                },
                {
                    type: 'name',
                    title: 'Local IP Address',
                    content:
                        'Specify the local virtual IP address for the VPN server. Please avoid using the IP address in the DHCP range, which may cause IP confliction, you can enter the LAN IP of the router. To find out the DHCP Range, go to Network > LAN > Network List and view the information of the desired network.'
                },
                {
                    type: 'name',
                    title: 'IP Address Pool',
                    content:
                        'Specify the IP address pool from which the IP address will be assigned to the VPN client. The IP Pool referenced here can be created on the Preferences > VPN IP Pool page.'
                },
                {
                    type: 'name',
                    title: 'DNS Address',
                    content:
                        'Specify the DNS address to be assigned to the VPN client (8.8.8.8 for example), you can enter the LAN IP of the router.'
                },
                {
                    type: 'name',
                    title: 'Network Mode',
                    content: 'Specify the network mode. There are two modes:',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Client-to-LAN: Select this option when the L2TP/PPTP client is a single host. It’s commonly used to access the internal service from outside.',
                                'LAN-to-LAN: Select this option when the L2TP/PPTP client is a VPN gateway. The tunneling request is always initiated by a device. It’s commonly used for access between two offices.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Max Connections',
                    content:
                        'Specify the maximum number of connections that the tunnel can support. Wihen Client-to-LAN network mode is enabled, it can be used to limit the number of devices connected at the same time.'
                },
                {
                    type: 'name',
                    title: 'Remote Subnet',
                    content:
                        'Specify a remote network. (This is the IP address range of the LAN on the remote peer of the L2TP/PPTP tunnel.) It’s the combination of IP address and subnet mask. It takes effect when LAN-to-LAN network mode is enabled.'
                }
            ]
        },
        QUICKSETUP_INFO: {
            TITLE: 'SSL VPN',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'SSL VPN provides remote users the access to the enterprise network from anywhere on the Internet. The remote access is enabled through a Secure Socket Layer (SSL) VPN gateway, and the SSL VPN gateway allows remote users to establish a secure VPN tunnel via web browser.'
                }
            ]
        },
        QUICKSETUP_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Go to Preferences > VPN IP Pool > VPN IP Pool to configure an IP pool.',
                        'Follow the quick setup to configure the SSL VPN.'
                    ]
                }
            ]
        },
        SSLVPN_STATUS_CONNECTION_INFO: {
            TITLE: 'Status -- Connection',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'In Connection, you can view the information of all the clients connected to the SSL VPN. You can also block or disconnect specific clients based on needs.'
                }
            ]
        },
        SSLVPN_STATUS_CONNECTION_PARAMS: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Username',
                    content: ' Displays the username a client used for login.'
                },
                {
                    type: 'name',
                    title: 'Login IP',
                    content: 'Displays the IP address of a client.'
                },
                {
                    type: 'name',
                    title: 'Virtual IP',
                    content: 'Displays the virtual IP address assigned to a client by the SSL VPN server.'
                },
                {
                    type: 'name',
                    title: 'Login Time',
                    content: 'Displays the time when a client logged in.'
                },
                {
                    type: 'name',
                    title: 'Upload',
                    content: 'Displays the total upload traffic of a client.'
                },
                {
                    type: 'name',
                    title: 'Download',
                    content: 'Displays the total download traffic of a client.'
                },
                {
                    type: 'name',
                    title: 'Operation',
                    children: [
                        {
                            type: 'paragraph',
                            content: 'Block or disconnect a client.'
                        },
                        {
                            type: 'name',
                            title: 'Block',
                            content:
                                'Disconnect a client and put the client into the list of Locked Out Users. A locked out user cannot log in again. To enable Username Lockout or IP Lockout, go to SSL VPN > SSL VPN Server > Advanced.'
                        },
                        {
                            type: 'name',
                            title: 'Disconnect',
                            content: ' Disconnect a client for once.'
                        }
                    ]
                }
            ]
        },
        SSLVPN_STATUS_LOCKEDOUT_INFO: {
            TITLE: 'Status -- Locked Out User',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'In <b>Locked Out User</b>, you can view the currently locked out users, and add, delete or edit an entry.'
                }
            ]
        },
        SSLVPN_STATUS_LOCKEDOUT_PARAMS: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Type',
                    content: 'Displays locked out type.'
                },
                {
                    type: 'name',
                    title: 'Username',
                    content: 'Displays the username of a locked out user.'
                },
                {
                    type: 'name',
                    title: 'IP',
                    content: 'Displays the IP address of a locked out user.'
                },
                {
                    type: 'name',
                    title: 'Remaining Time',
                    content: 'Displays the remaining effective time of a locked out entry.'
                }
            ]
        },
        SSLVPN_SERVER_INFO: {
            TITLE: 'SSL VPN Server',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'In <b>SSL VPN Server</b>, you can enable the feature and configure the SSL VPN settings.'
                }
            ]
        },
        SSLVPN_SERVER_PARAMS: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'SSL VPN Server',
                    content: 'Enable the feature.'
                },
                {
                    type: 'name',
                    title: 'Service Port',
                    content: 'Select the port for the SSL VPN server to listen on, and the VPN tunnel will take effect on the port.'
                },
                {
                    type: 'name',
                    title: 'Virtual IP Pool',
                    children: [
                        {
                            type: 'paragraph',
                            content:
                                'Select a virtual IP Pool, and the SSL VPN server will assign an IP address to a connected client within the pool. To create an IP Pool, go to Preferences > VPN IP Pool > VPN IP Pool.'
                        },
                        {
                            type: 'note',
                            title: 'Notes',
                            content: 'The number of IP addresses in the IP pool should not be less than 4.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Primary DNS',
                    children: [
                        {
                            type: 'paragraph',
                            content: 'Specify the IP address of the DNS server.'
                        },
                        {
                            type: 'note',
                            title: 'Notes',
                            content: 'Please assign the LAN IP to the SSLVPN DNS server.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Secondary DNS',
                    children: [
                        {
                            type: 'paragraph',
                            content: 'Specify the IP address of the DNS server.'
                        },
                        {
                            type: 'note',
                            title: 'Notes',
                            content: 'Please assign the LAN IP to the SSLVPN DNS server.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Advanced'
                },
                {
                    type: 'name',
                    title: 'Listen on Port',
                    content: 'Specify the port for the SSL VPN server to listen on. By default, it is 1194.'
                },
                {
                    type: 'name',
                    title: 'Authentication Type',
                    content:
                        'Select the authentication for the clients. For RADIUS Authentication, go to SSL VPN > Authentication to configure.'
                },
                {
                    type: 'name',
                    title: 'User Group',
                    content:
                        'Specify the default user group in radius authentication mode. When the VPN server cannot find the value of the CLASS attribute in the authentication success message, it will assign the default resource permissions according to the user group.'
                },
                {
                    type: 'name',
                    title: 'Username Lockout',
                    children: [
                        {
                            type: 'paragraph',
                            content: 'Block a client with the specific login username.'
                        },
                        {
                            type: 'name',
                            title: 'Max. Login Attempts',
                            content:
                                'Specify the maximum failed login attempts for a username. After the maximum attempt is reached, the username will be locked out.'
                        },
                        {
                            type: 'name',
                            title: 'Lock Duration',
                            content: 'Specify how long the username will be locked out.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'IP Lockout',
                    children: [
                        {
                            type: 'paragraph',
                            content: 'Block a client of the specific login IP.'
                        },
                        {
                            type: 'name',
                            title: 'Max. Login Attempts',
                            content:
                                'Specify the maximum failed login attempts for a login IP. After the maximum attempt is reached, the login IP will be locked out.'
                        },
                        {
                            type: 'name',
                            title: 'Lock Duration',
                            content: 'Specify how long the login IP will be locked out.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Idle Timeout',
                    content:
                        'Enable the feature and the VPN tunnel will close automatically if there is no traffic for the specified amount of time.'
                },
                {
                    type: 'name',
                    title: 'Full Mode',
                    content:
                        'Enable the feature and all traffic will go through the SSL VPN tunnel. When the feature is disabled, only the resource-related traffic will go through the tunnel.'
                }
            ]
        },
        RSRC_MNGT_TUNNEL_INTRO: {
            TITLE: 'Resource Manangement -- Tunnel Resources',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'In <b>Tunnel Resources</b>, you can configure the resources the clients can access through the VPN tunnel, including IP range and domain name.'
                }
            ]
        },
        RSRC_MNGT_TUNNEL_PARAMS: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify a name for the entry.'
                },
                {
                    type: 'name',
                    title: 'Resource Type',
                    children: [
                        {
                            type: 'paragraph',
                            content: 'Select the type for the resources.'
                        },
                        {
                            type: 'name',
                            title: 'IP Address',
                            content: 'Specify IP range the clients can access, and the protocols the clients can use to access.'
                        },
                        {
                            type: 'name',
                            title: 'Domain Name',
                            content: ' Specify domain name the clients can access.'
                        }
                    ]
                }
            ]
        },
        RSRC_MNGT_RSRC_GROUP_INTRO: {
            TITLE: 'Resource Manangement -- Resource Group',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'In <b>Resource Group</b>, you can add the multiple tunnel resources to a group for better management.'
                }
            ]
        },
        RSRC_MNGT_RSRC_GROUP_PARAMS: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Resource Group',
                    content: 'Specify a name for the resource group.'
                },
                {
                    type: 'name',
                    title: 'Resources',
                    content: 'Select the resources for the group.'
                },
                {
                    type: 'note',
                    title: 'Notes',
                    content: [
                        'A resource entry can be added to multiple resource groups, and the entry cannot be deleted after it is added to a resource group. If you want to delete a resource entry, please remove it from the resource group first.',
                        '<b>GROUP_LAN</b>: Refers to the resources of the LAN segment.',
                        '<b>GROUP_ALL</b>: Refers to the resources of all network segments.'
                    ]
                }
            ]
        },
        SSLVPN_USERMNGT_INTRO: {
            TITLE: 'User Management -- User',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'In <b>User</b>, you can view and configure all user settings of the SSL VPN.'
                }
            ]
        },
        SSLVPN_USERMNGT_PARAMS: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Username',
                    content: 'Specify the username a client used for login.'
                },
                {
                    type: 'name',
                    title: 'Password',
                    content: 'Specify the password a client used for login.'
                },
                {
                    type: 'name',
                    title: 'User Group',
                    content: 'Select which group the user belongs to. A user can only be added to one user group.'
                },
                {
                    type: 'name',
                    title: 'Expiration Date',
                    content: 'Specify when the user will expire.'
                },
                {
                    type: 'name',
                    title: 'Max. Concurrent Users',
                    content:
                        'Specify the maximum number of clients using the username for login concurrently. After the maximum number is reached, new login attempts will be rejected.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Displays the status of the user entry.'
                }
            ]
        },
        SSLVPN_USERGROUP_INTRO: {
            TITLE: 'User Management -- User Group',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'In <b>User Group</b>, you can add multiple users to a group for better management.'
                }
            ]
        },
        SSLVPN_USERGROUP_PARAMS: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify a name for the user group.'
                },
                {
                    type: 'name',
                    title: 'Group Member',
                    content: 'Select the users you want to add into the group. All users in the group share the same resources.'
                },
                {
                    type: 'name',
                    title: 'Resource Group',
                    content: 'Select the resource group for the user group.'
                },
                {
                    type: 'name',
                    title: 'Radius Extended Value',
                    content:
                        'Only valid in radius authentication mode. It maps the user group with radius grouping information (which is carried by the CLASS attribute 25).'
                }
            ]
        },
        SSLVPN_AUTH_SERVER_INTRO: {
            TITLE: 'Authentication -- Authentication Server',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'In <b>Authentication Server</b>, you can view and add authentication servers.'
                }
            ]
        },
        SSLVPN_AUTH_SERVER_PARAMS: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify a name for the authentication server.'
                },
                {
                    type: 'name',
                    title: 'Server Type',
                    content: 'Select the type for the authentication server. Currently, only RADIUS server is supported.'
                },
                {
                    type: 'name',
                    title: 'Primary Server',
                    content: 'Specify the primary server for authentication.'
                },
                {
                    type: 'name',
                    title: 'Secondary Server',
                    content:
                        'Specify the secondary server for authentication. When the primary server is down, the secondary server will be used.'
                },
                {
                    type: 'name',
                    title: 'Recover Time',
                    content: 'Specify the interval to connect the primary server again when the primary server is down.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a description for the server.'
                }
            ]
        },
        SSLVPN_AUTH_RADIUS_SERVER_INTRO: {
            TITLE: 'Authentication -- RADIUS Server',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'In <b>RADIUS Server</b>, you view and configure RADIUS server settings.'
                }
            ]
        },
        SSLVPN_AUTH_RADIUS_SERVER_PARAMS: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify a name for the RADIUS server.'
                },
                {
                    type: 'name',
                    title: 'Authentication Server IP',
                    content: 'Specify the IP address of the RADIUS server.'
                },
                {
                    type: 'name',
                    title: 'Authentication Mode',
                    content:
                        'Select the authentication protocol for the RADIUS server. Two authentication protocols are available: PAP and CHAP.'
                },
                {
                    type: 'name',
                    title: 'Authentication Port',
                    content:
                        'Specify the UDP destination port on the authentication server for authentication requests. The recommended port is 1812.'
                },
                {
                    type: 'name',
                    title: 'Accounting Port',
                    content: 'Specify the UDP destination port on the RADIUS server for accounting requests. The recommended port is 1813.'
                },
                {
                    type: 'name',
                    title: 'Pre-Shared Key',
                    content:
                        'Specify the password that will be used to validate the communication between the router and the RADIUS authentication server.'
                },
                {
                    type: 'name',
                    title: 'Max. Request',
                    content: 'Specify the maximum number of requests sent when no response is received.'
                },
                {
                    type: 'name',
                    title: 'Request Timeout',
                    content: 'Specify the maximum interval for request timeout. After timeout, the request will be sent again.'
                },
                {
                    type: 'name',
                    title: 'NAS IP',
                    content: 'Specify the IP address for the router to communicate with the RADIUS server.'
                }
            ]
        },
        WPORTAL_INTRO: {
            TITLE: 'Web Authentication',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Portal Authentication provides authentication service to the clients that only need temporary access to the network, such as the customers in a restaurant or in a supermarket. The router has a built-in web server and also supports external web server. Web Authentication allows you to configure the authentication page either using the built-in server or the external server. In addition, you can customize the authentication login page and specify a URL which the authenticated clients will be redirected to.'
                }
            ]
        },
        WPORTAL_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'step',
                    content: [
                        'Check the box to enable Web Authentication and configure the parameters in Settings.',
                        'Customize the authentication parameters based on your needs.',
                        'Click %<{"type":"button","text":"Save"}>%.'
                    ]
                }
            ]
        },
        WPORTAL_PARAM: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable Web Authentication.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Specify the effective interface.'
                },
                {
                    type: 'name',
                    title: 'Idle Timeout',
                    content:
                        'Specify the idle timeout. The client will be disconnected after the specified period (Idle Timeout) of inactivity, and is required to authenticate again.</br></br>Value 0 means the client will always keep online until the authentication timeout leased, even if the client remains inactive.'
                },
                {
                    type: 'name',
                    title: 'Portal Authentication Port',
                    content: 'Enter the service port for portal authentication. The default setting is 8080.'
                },
                {
                    type: 'name',
                    title: 'Authentication Page',
                    content: 'Select the type of Authentication page.',
                    children: [
                        {
                            type: 'name',
                            title: 'Custom',
                            content:
                                'You can use the built-in web server to customize the authentication page by specifying the background picture, welcome information and copyright information.'
                        },
                        {
                            type: 'name',
                            title: 'External Links',
                            content:
                                'You can specify an external web server to provide the authentication page by entering the URL of the external web server.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Background Picture',
                    content: 'Click the Upload button to choose a local image as the background picture of the custom authentication page.'
                },
                {
                    type: 'name',
                    title: 'Welcome Information',
                    content: 'Specify the welcome information to be displayed on the custom authentication page.'
                },
                {
                    type: 'name',
                    title: 'Copyright',
                    content: 'Specify the copyright information to be displayed on the custom authentication page.'
                },
                {
                    type: 'name',
                    title: 'Page Preview',
                    content: 'Click the Login Page Preview button, and you can preview the custom authentication page.'
                },
                {
                    type: 'name',
                    title: 'Authentication URL',
                    content:
                        'Specify the URL for authentication page if you choose the Authentication Page as External Links. The browser will redirect to this URL when the client starts the authentication.'
                },
                {
                    type: 'name',
                    title: 'Success Redirect URL',
                    content:
                        'Specify the Success Redirect URL if you choose the Authentication Page as External Links. The browser will redirect to this URL after the authentication succeeded.'
                },
                {
                    type: 'name',
                    title: 'Fail Redirect URL',
                    content:
                        'Specify the Fail Redirect URL if you choose the Authentication Page as External Links. The browser will redirect to this URL if the authentication failed.'
                },
                {
                    type: 'name',
                    title: 'Authentication Type',
                    content: 'Choose the authentication type.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Local Authentication: If you  on’t have an additional Radius server, you can choose local authentication. In local authentication, the router uses the built-in authentication server to authenticate.',
                                'Radius Authentication: Use an external Radius server to authenticate. The authentication timeout is 30 minutes by default, if not specified by the Radius server.',
                                'Onekey Online: Users can pass through authentication directly. No username or password are required.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Expiration Reminder',
                    content:
                        'Check the box to enable expiration reminder. A reminder page will appear to remind users when the online time is about to expire.'
                },
                {
                    type: 'name',
                    title: 'Time to Remind',
                    content: 'Specify the number of days before the expiration date to remind users.'
                },
                {
                    type: 'name',
                    title: 'Remind Type',
                    content: 'Specify the remind type.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Remind Once: Remind the user only once after the authentication succeeded.',
                                'Remind Periodically: Remind users at specified intervals during the period.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Remind Interval',
                    content:
                        'Specify the interval at which the router reminds users if the remind type is specified as Remind Periodically.'
                },
                {
                    type: 'name',
                    title: 'Remind Content',
                    content: 'Specify the remind content. The content will be displayed on the reminder page.'
                },
                {
                    type: 'name',
                    title: 'Primary Radius Server',
                    content: 'Enter the IP address of the primary Radius server.'
                },
                {
                    type: 'name',
                    title: 'Secondary Radius Server',
                    content:
                        '(Optional) Enter the IP address of the secondary Radius server. If the primary server is down, the secondary server will take effect.'
                },
                {
                    type: 'name',
                    title: 'Authentication Port',
                    content: 'Enter the service port for Radius authentication. By default, it is 1812.'
                },
                {
                    type: 'name',
                    title: 'Authorized Share Key',
                    content: 'Specify the authorized share key. This key should be the same configured in the Radius server.'
                },
                {
                    type: 'name',
                    title: 'Retry Times',
                    content:
                        'Specify the number of times the router will retry sending authentication requests after the authentication failed.'
                },
                {
                    type: 'name',
                    title: 'Timeout Interval',
                    content: 'Specify the timeout interval that  the  client  can  wait  before the radius server replies.'
                },
                {
                    type: 'name',
                    title: 'Authentication Method',
                    content: 'Specify the authentication protocol as PAP or CHAP.'
                },
                {
                    type: 'name',
                    title: 'Free Authentication Timeout',
                    content: 'Specify the free time for Onekey Online. The value ranges from 1 to 1440, and the default value is 60.'
                }
            ]
        },
        PORTAL_FREE_INTRO: {
            TITLE: 'Guest Resources',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'The Guest Resources feature allows unauthenticated clients to access the free network resources.'
                }
            ]
        },
        PORTAL_FREE_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'step',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% and specify the parameters for the new rule of guest resources.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },
        PORTAL_FREE_PARAM: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Enter the name of the entry of Guest Resources.'
                },
                {
                    type: 'name',
                    title: 'Type',
                    content: 'Choose the type of Guest Resources.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Five Tuple Type: Specify the client and the network resources the client can visit based on the settings of IP address, MAC address, VLAN ID, service port and protocol. It is recommended to select Five Tuple Type when the IP address and service port of the free network resources are already known.',
                                'URL Type: Specify the client and the network resources the client can visit based on the settings of the URL, IP address, MAC address and service port. It is recommended to select URL Type when the URL of the free network resources is already known.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'URL Address',
                    content: 'Enter the URL address or IP address of the network resources that can be visited for free.'
                },
                {
                    type: 'name',
                    title: 'Source IP Range',
                    content:
                        'Specify the IP range of the client(s) by entering the network address and subnet mask bits. Only the specified clients can visit the guest resources.'
                },
                {
                    type: 'name',
                    title: 'Destination IP Range',
                    content:
                        'Specify the IP range of the server(s) that provides the guest resources by entering the network address and subnet mask bits.'
                },
                {
                    type: 'name',
                    title: 'Source MAC Address',
                    content: 'Enter the MAC address of the client.'
                },
                {
                    type: 'name',
                    title: 'Source Port Range',
                    content: 'Enter the source service port range.'
                },
                {
                    type: 'name',
                    title: 'Destination Port Range',
                    content: 'Enter the destination service port range.'
                },
                {
                    type: 'name',
                    title: 'Protocol',
                    content: 'Specify the protocol as TCP or UDP for Guest Resources.'
                },
                {
                    type: 'name',
                    title: 'Interface Type',
                    content: 'Specify the interface supported for the Guest Resources.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for the Guest Resources entry to make it easier to search and manage.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the entry of Guest Resources.'
                }
            ]
        },
        USERMNGR_USER_INTRO: {
            TITLE: 'User Management',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'For local authentication, the router uses the built-in authentication server to authenticate users. You need to configure the authentication accounts for the local users on this page.'
                }
            ]
        },
        USERMNGR_USER_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'step',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% and specify the parameters for the new entry of user management.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },
        USERMNGR_USER_PARAM: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'User Type',
                    content: 'Specify the user type.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'If you want to provide the user with network service for a long period of time (in days), you can create Formal User accounts for them.',
                                'If you want to provide the user with network service for a short period of time (in minutes), you can create Free User accounts for them.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Username',
                    content: 'Specify the username of the account. The username cannot be the same as any existing one.'
                },
                {
                    type: 'name',
                    title: 'Password',
                    content: 'Specify the password of the account.'
                },
                {
                    type: 'name',
                    title: 'Expiration Date',
                    content:
                        'Specify the expiration date of the account. The formal user can use this account to authenticate before this date.'
                },
                {
                    type: 'name',
                    title: 'Authentication Timeout',
                    content: 'Specify the free duration of the account. The default value is 30 minutes.'
                },
                {
                    type: 'name',
                    title: 'Authentication Peroid',
                    content: 'Specify the period during which the client is allowed to be authenticated.'
                },
                {
                    type: 'name',
                    title: 'MAC Binding Type',
                    content:
                        'Specify the MAC Binding type. There are three types of MAC Binding: No binding, Static Binding and Dynamic Binding.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'No Binding: The client’s MAC address will not be bound.',
                                'Static Binding: Manually enter the MAC address of the client to be bound. Only the bound client is able to use the username and password to authenticate.',
                                'Dynamic Binding: The MAC address of the first client that passes the authentication will be bound. Afterwards only the bound client is able to use the username and password to authenticate.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Maximum Users',
                    content: 'Specify the maximum number of users that are allowed to use this account to authenticate.'
                },
                {
                    type: 'name',
                    title: 'MAC Address',
                    content: 'Enter the MAC address of the client to be bound.'
                },
                {
                    type: 'name',
                    title: 'Upstream Bandwidth',
                    content: 'Specify the upstream bandwidth for the user. 0 means no limit.'
                },
                {
                    type: 'name',
                    title: 'Downstream Bandwidth',
                    content: 'Specify the downstream bandwidth for the user. 0 means no limit.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the user’s name.'
                },
                {
                    type: 'name',
                    title: 'Telephone',
                    content: 'Specify the user’s telephone number.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Enter a brief description for the account to make it easier to search and manage.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable this account.'
                }
            ]
        },
        USERMNGR_USER_BK_INTRO: {
            TITLE: 'Configuration Backup',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Configuration Backup allows you to backup all the local user accounts as a CSV file in ANSI format. You can restore the user accounts by importing the saved file to the router.'
                }
            ]
        },
        USERMNGR_USER_BK_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'step',
                    content: [
                        'To backup local user accounts:</br>Click %<{"type":"button","text":"Backup"}>% to backup all the local user accounts as a CSV file in ANSI format.',
                        'To restore local user accounts:</br>Click %<{"type":"button","text":"Browse"}>% to select the file path (the backup must be a CSV file), then click %<{"type":"button","text":"Restore"}>% to restore the accounts.',
                        'To manually restore local user accounts:</br>Create an Excel file and add the local user accounts to it, then save the Excel file as a CSV file with ANSI format. You can click %<{"type":"button","text":"Backup"}>% to obtain a CSV file to view the correct format.</br>Click %<{"type":"button","text":"Browse"}>% to select the file path, then click %<{"type":"button","text":"Restore"}>% to restore the file.'
                    ]
                }
            ]
        },
        SESSMNGR_LIST_INTRO: {
            TITLE: 'Authentication Status',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the clients that pass the portal authentication on this page.'
                }
            ]
        },
        SESSMNGR_LIST_CFG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'step',
                    content: ['Click %<{"type":"refreshSpan","text":"Refresh"}>% button to get the latest information.']
                }
            ]
        },
        SESSMNGR_LIST_PARAM: {
            TITLE: 'Authentication Status',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Type',
                    content: 'Displays the authentication type of the client.'
                },
                {
                    type: 'name',
                    title: 'Starting Time',
                    content: 'Displays the starting time of the authentication.'
                },
                {
                    type: 'name',
                    title: 'IP Address',
                    content: 'Displays the client’s IP address.'
                },
                {
                    type: 'name',
                    title: 'MAC Address',
                    content: 'Displays the client’s MAC address.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content:
                        'If you want to know the packet rate and the total packets sent, please go to Status > Traffic Statistics > IP Statistics page to enable the IP Statistics feature.'
                }
            ]
        },
        WPORTAL_FUNCTION: {
            TITLE: 'Settings',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable Web Authentication.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Specify the effective interface.'
                },
                {
                    type: 'name',
                    title: 'Idle Timeout',
                    content:
                        'Specify the idle timeout. The client will be disconnected after the specified period (Idle Timeout) of inactivity, and is required to authenticate again.'
                },
                {
                    type: 'name',
                    title: 'Portal Authentication Port',
                    content:
                        "Enter the service port for portal authentication. The port number should be different from other servers'. The default setting is 8080."
                }
            ]
        },
        WPORTAL_PARAMETER: {
            TITLE: 'Authentication Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Authentication Page',
                    content: 'Choose whether to use the custom page or the external links for authentication.'
                },
                {
                    type: 'name',
                    title: 'Background Picture',
                    content: 'Upload the background picture for the custom page. The picture size cannot exceed 200KB.'
                },
                {
                    type: 'name',
                    title: 'Welcome Information',
                    content: 'Enter the welcome information displayed on the custom page.'
                },
                {
                    type: 'name',
                    title: 'Copyright',
                    content: 'Enter the copyright information displayed on the custom page.'
                },
                {
                    type: 'name',
                    title: 'Authentication URL',
                    content: 'Enter the authentication URL when you choose the the type of authentication page as External Links.'
                },
                {
                    type: 'name',
                    title: 'Success Redirect URL',
                    content: 'The browser will redirect to this URL after the authentication succeeds if you select External Links.'
                },
                {
                    type: 'name',
                    title: 'Fail Redirect URL',
                    content: 'The browser will redirect to this URL after the authentication fails if you select External Links.'
                },
                {
                    type: 'name',
                    title: 'Authentication Type',
                    content:
                        'Choose the Authentication Type, including Local Authentication, Radius Authentication and Onekey Online. <br>Note: When you choose the Authentication Page as External Links, Onekey Online is not available.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Local Authentication: Authentication for users can be configured in the local User Management page.',
                                'Radius Authentication: Use an external Radius server to authenticate. The authentication timeout is 30 minutes by default, if not specified by the Radius server.',
                                'Onekey Online: Users can pass through authentication directly. No username or password are required.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Expiration Reminder',
                    content: 'Remind users that the online time is about to expire in Local Authentication.'
                },
                {
                    type: 'name',
                    title: 'Time to Remind',
                    content: 'Specify the number of days before the expiration date to remind users.'
                },
                {
                    type: 'name',
                    title: 'Remind Type',
                    content:
                        'Remind Once: Remind the user only once after the authenticaton succeeded;<br>Remind Periodically: Remind users at specified intervals during the remind period'
                },
                {
                    type: 'name',
                    title: 'Remind Interval',
                    content: 'Specify the interval at which the router reminds users.'
                },
                {
                    type: 'name',
                    title: 'Remind Content',
                    content: 'Specify the remind content. The content will be displayed on the Remind page.'
                },
                {
                    type: 'name',
                    title: 'Page Preview',
                    content: 'Preview the Remind Page.'
                },
                {
                    type: 'name',
                    title: 'Primary Radius Server',
                    content: 'Enter the IP address of the primary Radius server, it is required if you choose Radius Authentication.'
                },
                {
                    type: 'name',
                    title: 'Secondary Radius Server',
                    content:
                        'Enter the IP address of the secondary Radius server. If the primary server is down, the secondary server will be effective.'
                },
                {
                    type: 'name',
                    title: 'Authentication Port',
                    content: 'Enter the authentication port number. By default, it is 1812.'
                },
                {
                    type: 'name',
                    title: 'Authorized Share Key',
                    content: 'Specify the authorized share key.'
                },
                {
                    type: 'name',
                    title: 'Retry Times',
                    content:
                        'Specify the number of times the router will retry sending authentication requests after the authentication failed. '
                },
                {
                    type: 'name',
                    title: 'Timeout Interval',
                    content: 'Specify the timeout interval that the client can wait before the radius server replies.'
                },
                {
                    type: 'name',
                    title: 'Authentication Method',
                    content: 'Specify the Authentication Method.'
                },
                {
                    type: 'name',
                    title: 'Free Authentication Timeout',
                    content: 'Specify the free time for Onekey Online. The value ranges from 1 to 1440, and the default value is 60.'
                } /*,{                      
                           type: "note",
                           title: "Note ",
       content: [ 
                "不能同时开启Web认证和微信连WiFi服务。"]
}*/
            ]
        },
        PORTAL_FREE: {
            TITLE: 'Guest Resources',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'You can configure and view Guest Resources on this page. Guest Resources is used to provide free resources for users before they pass the portal authentication.'
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: 'Specify the name of the resources.'
                },
                {
                    type: 'name',
                    title: 'Type',
                    content: 'Specify the Guest Resources type, including Five Tuple Type and URL Type.'
                },
                {
                    type: 'name',
                    title: 'URL Address',
                    content: 'Specify the URL address of the websites that can be visited before users pass the authentication.'
                },
                {
                    type: 'name',
                    title: 'Source IP Range',
                    content:
                        'Specify the source IP address range and subnet mask of clients. These clients can visit the specified network resource without any authentication.'
                },
                {
                    type: 'name',
                    title: 'Destination IP Range',
                    content:
                        'Specify the destination IP range and subnet mask of servers. These servers can provide free resources for users.'
                },
                {
                    type: 'name',
                    title: 'Source MAC Address',
                    content:
                        'Specify the source MAC address of clients. These clients can visit the specified network resource without any authentication.'
                },
                {
                    type: 'name',
                    title: 'Source Port Range',
                    content: 'Specify the source port range.'
                },
                {
                    type: 'name',
                    title: 'Destination Port Range',
                    content: 'Specify the destination port range.'
                },
                {
                    type: 'name',
                    title: 'Protocol',
                    content: 'Specify the protocol supported for the Guest Resources.'
                },
                {
                    type: 'name',
                    title: 'Interface Type',
                    content: 'Specify the interface supported for the Guest Resources.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content:
                        'Enter a brief description for the Guest Resources entry to make it easier to search for and manage. Up to 50 characters can be entered.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable Guest Resources feature.'
                }
            ]
        },
        USERMNGR_USER: {
            TITLE: 'List of Authenticated User Rule ',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the list of authenticated users on this page.'
                },
                {
                    type: 'name',
                    title: 'User Type',
                    content: 'There are two types of authenticated user:',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Formal User: If you want to provide the user with network service for a long time (in days), you can configure them as formal users.',
                                'Free User: If you want to provide the user with network service for a short time (in minutes), you can configure them as free users.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Username',
                    content: 'Specify the username. The username should not be the same as the existing ones.'
                },
                {
                    type: 'name',
                    title: 'Password',
                    content: 'Specify the password.'
                },
                {
                    type: 'name',
                    title: 'Expiration Date',
                    content: 'Specify the expiration date for the formal user.'
                },
                {
                    type: 'name',
                    title: 'Authentication Timeout',
                    content: 'Specify the authentication timeout for the free user.'
                },
                {
                    type: 'name',
                    title: 'Authentication Peroid',
                    content: 'Specify the period during which that the client is allowed to be authenticated. '
                },
                {
                    type: 'name',
                    title: 'MAC Binding Type',
                    content:
                        'Specify the MAC Binding type. There are three types of MAC Binding: No binding, Static Binding and Dynamic Binding.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                "No Binding: User's MAC address will not be bound.",
                                'Static Binding: Manually enter the MAC address of the client to be bound. Only the bound client is able to use the username and password to authenticate.',
                                'Dynamic Binding: The MAC address of the first client that passes the authentication will be bound. Only the bound client is able to use the username and password to authenticate.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Maximum Users',
                    content:
                        'Specify the maximum number of users able to use this username and password to authencitate.<br>Note: If the MAC Binding Type is either Static Binding or Dynamic Binding, only one client can use this username and password to authenticate,i.e., the bound client.'
                },
                {
                    type: 'name',
                    title: 'Upstream Bandwidth',
                    content: 'Specify the upstream bandwidth for the user. 0 means no limit. '
                },
                {
                    type: 'name',
                    title: 'Downstream Bandwidth',
                    content: 'Specify the downstream bandwidth for the user. 0 means no limit. '
                },
                {
                    type: 'name',
                    title: 'Name',
                    content: "Optional: Record the user's name."
                },
                {
                    type: 'name',
                    title: 'Telephone',
                    content: "Optional: Record the user's telephone number."
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Optional: Enter a brief description for the user '
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable this entry.'
                }
            ]
        },
        USERMNGR_USER_BK: {
            TITLE: 'Backup',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can backup the user configuration information on this page.'
                },
                {
                    type: 'name',
                    title: 'Backup',
                    content: 'Click Backup to back up the user configuration information.'
                }
            ]
        },
        USERMNGR_USER_RT: {
            TITLE: 'Restore',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can restore the information of user configuration on this page.'
                },
                {
                    type: 'name',
                    title: 'Restore',
                    content: 'Click Button to restore the user configuration.'
                }
            ]
        },
        SESSMNGR_LIST: {
            TITLE: 'Authentication Status',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the status of the authentication on this page.'
                },
                {
                    type: 'name',
                    title: 'Refresh',
                    content: 'Refresh the list manually.'
                },
                {
                    type: 'name',
                    title: 'Offline',
                    content: 'You can disconnect users in batches.'
                },
                {
                    type: 'name',
                    title: 'Type',
                    content: 'Displays the authentication type.'
                },
                {
                    type: 'name',
                    title: 'Starting Time',
                    content: 'Displays the Starting Time'
                },
                {
                    type: 'name',
                    title: 'IP Address',
                    content: "Displays user's IP address."
                },
                {
                    type: 'name',
                    title: 'Operation',
                    content: 'Disconnect the user.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content:
                        'If you want to know the packet rate and the total packets sent, please go to Status > Traffic Statistics > IP Statistics page to enable IP Statistics feature.'
                }
            ]
        },
        PHDDNS_INTRODUCT: {
            TITLE: 'Peanuthull DDNS',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'DDNS (Dynamic Domain Name System) allows you to access your home network from anywhere with a fixed domain name, even if your ISP is assigning dynamic (non-fixed) IP address to you.'
                },
                {
                    type: 'paragraph',
                    content:
                        'The router supports four DDNS service providers: Peanuthull, Comexe, DynDNS, NO-IP, you can choose one of them according to your needs.'
                }
            ]
        },
        PHDDNS_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Select your preferred DDNS service from the four service providers, and click the corresponding tab.',
                        'Click %<{"type":"addSpan","text":"Add"}>%, and specify the parameters for the DDNS entry.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },
        PHDDNS_PARA: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Select the interface for the DDNS service.'
                },
                {
                    type: 'name',
                    title: 'Account Name',
                    content:
                        'Enter the account name of your DDNS account. You can click Go to register to visit the official website of DDNS to register an account.'
                },
                {
                    type: 'name',
                    title: 'Password',
                    content: 'Enter the password of your DDNS account.'
                },
                {
                    type: 'name',
                    title: 'Domain Name (Only for DynDNS and NO-IP)',
                    content: 'Specify the domain name that you registered in your DDNS service provider.'
                },
                {
                    type: 'name',
                    title: 'Update Interval',
                    content: 'Specify the update interval to update the dynamic WAN IP addresses for DDNS service.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        CMXDDNS_INTRODUCT: {
            TITLE: 'Comexe DDNS',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'DDNS (Dynamic Domain Name System) allows you to access your home network from anywhere with a fixed domain name, even if your ISP is assigning dynamic (non-fixed) IP address to you.'
                },
                {
                    type: 'paragraph',
                    content:
                        'The router supports four DDNS service providers: Peanuthull, Comexe, DynDNS, NO-IP, you can choose one of them according to your needs.'
                }
            ]
        },
        CMXDDNS_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Select your preferred DDNS service from the four service providers, and click the corresponding tab.',
                        'Click %<{"type":"addSpan","text":"Add"}>%, and specify the parameters for the DDNS entry.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },
        CMXDDNS_PARA: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Select the interface for the DDNS service.'
                },
                {
                    type: 'name',
                    title: 'Account Name',
                    content:
                        'Enter the account name of your DDNS account. You can click Go to register to visit the official website of DDNS to register an account.'
                },
                {
                    type: 'name',
                    title: 'Password',
                    content: 'Enter the password of your DDNS account.'
                },
                {
                    type: 'name',
                    title: 'Domain Name (Only for DynDNS and NO-IP)',
                    content: 'Specify the domain name that you registered in your DDNS service provider.'
                },
                {
                    type: 'name',
                    title: 'Update Interval',
                    content: 'Specify the update interval to update the dynamic WAN IP addresses for DDNS service.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        DYNDDNS_INTRODUCT: {
            TITLE: 'DynDNS',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'DDNS (Dynamic Domain Name System) allows you to access your home network from anywhere with a fixed domain name, even if your ISP is assigning dynamic (non-fixed) IP address to you.'
                },
                {
                    type: 'paragraph',
                    content:
                        'The router supports four DDNS service providers: Peanuthull, Comexe, DynDNS, NO-IP, you can choose one of them according to your needs.'
                }
            ]
        },
        DYNDDNS_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Select your preferred DDNS service from the four service providers, and click the corresponding tab.',
                        'Click %<{"type":"addSpan","text":"Add"}>%, and specify the parameters for the DDNS entry.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },
        DYNDDNS_PARA: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Select the interface for the DDNS service.'
                },
                {
                    type: 'name',
                    title: 'Account Name',
                    content:
                        'Enter the account name of your DDNS account. You can click Go to register to visit the official website of DDNS to register an account.'
                },
                {
                    type: 'name',
                    title: 'Password',
                    content: 'Enter the password of your DDNS account.'
                },
                {
                    type: 'name',
                    title: 'Domain Name (Only for DynDNS and NO-IP)',
                    content: 'Specify the domain name that you registered in your DDNS service provider.'
                },
                {
                    type: 'name',
                    title: 'Update Interval',
                    content: 'Specify the update interval to update the dynamic WAN IP addresses for DDNS service.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        NOIPDDNS_INTRODUCT: {
            TITLE: 'No-IP DDNS',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'DDNS (Dynamic Domain Name System) allows you to access your home network from anywhere with a fixed domain name, even if your ISP is assigning dynamic (non-fixed) IP address to you.'
                },
                {
                    type: 'paragraph',
                    content:
                        'The router supports four DDNS service providers: Peanuthull, Comexe, DynDNS, NO-IP, you can choose one of them according to your needs.'
                }
            ]
        },
        NOIPDDNS_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Select your preferred DDNS service from the four service providers, and click the corresponding tab.',
                        'Click %<{"type":"addSpan","text":"Add"}>%, and specify the parameters for the DDNS entry.',
                        'Click %<{"type":"button","text":"OK"}>% to save the settings.'
                    ]
                }
            ]
        },
        NOIPDDNS_PARA: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Select the interface for the DDNS service.'
                },
                {
                    type: 'name',
                    title: 'Account Name',
                    content:
                        'Enter the account name of your DDNS account. You can click Go to register to visit the official website of DDNS to register an account.'
                },
                {
                    type: 'name',
                    title: 'Password',
                    content: 'Enter the password of your DDNS account.'
                },
                {
                    type: 'name',
                    title: 'Domain Name (Only for DynDNS and NO-IP)',
                    content: 'Specify the domain name that you registered in your DDNS service provider.'
                },
                {
                    type: 'name',
                    title: 'Update Interval',
                    content: 'Specify the update interval to update the dynamic WAN IP addresses for DDNS service.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Check the box to enable the rule.'
                }
            ]
        },

        UPNP_INTRODUCT: {
            TITLE: 'UPnP',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'UPnP  (Universal Plug and Play) is the networking protocol that allows devices to discover each other and then establish connections for communication. With the help of UPnP, It is convenient to realize seamless connections between the devices，especially from WAN to LAN.'
                },
                {
                    type: 'name',
                    title: 'Enable UPnP',
                    content: 'Check the box to enable the UPnP function.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Specify the effective interfaces.'
                }
            ]
        },
        UPNP_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: ['Check the box of Enable UPnP, and select the interface.', 'Click %<{"type":"button","text":"Save"}>%.']
                }
            ]
        },
        UPNP_PARA: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Displays the description of the application using UPnP protocol.'
                },
                {
                    type: 'name',
                    title: 'Protocol',
                    content: 'Displays the protocol type used in the process of UPnP.'
                },
                {
                    type: 'name',
                    title: 'Interface',
                    content: 'Displays the interface used in the process of UPnP.'
                },
                {
                    type: 'name',
                    title: 'IP Address',
                    content: 'Displays the IP address of the local host.'
                },
                {
                    type: 'name',
                    title: 'External Port',
                    content: 'Displays the external port that is opened for the application by the router.'
                },
                {
                    type: 'name',
                    title: 'Internal Port',
                    content: 'Displays the internal port that is opened for the application by the local host.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    children: [
                        {
                            type: 'step',
                            content: ['Enabled: The mapping is active.', 'Disabled: The mapping is inactive.']
                        }
                    ]
                }
            ]
        },
        ADMIN_SETUP_INTRODUCT: {
            TITLE: 'Admin Setup',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Admin Setup is used to configure the parameters for users’login. With this function, you can change the username and password of the administrator account based on needs.'
                }
            ]
        },
        ADMIN_SETUP_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Enter the old username and password for confirmation, and specify a new username and password for the account. Click %<{"type":"button","text":"Save"}>%.'
                }
            ]
        },

        ADMIN_SETUP_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Old Username',
                    content: 'Enter the old username.'
                },
                {
                    type: 'name',
                    title: 'Old Password',
                    content: 'Enter the old password.'
                },
                {
                    type: 'name',
                    title: 'New Username',
                    content: 'Enter a new username for the administrator account. You can use letters, digits and special characters.'
                },
                {
                    type: 'name',
                    title: 'New Password',
                    content: 'Enter a new user password  for the account. It is recommended to use a strong password for the security.'
                },
                {
                    type: 'name',
                    title: 'Confirm New Password',
                    content: 'Re-enter the password for confirmation.'
                }
            ]
        },
        REMOTE_MNGT_INTRODUCT: {
            TITLE: 'Remote Management',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Remote Management allows you to configure the IP subnet and mask for remote host to access your device. With this feature, you can manage and configure the router remotely.'
                }
            ]
        },
        REMOTE_MNGT_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"addSpan","text":"Add"}>% to add a new IP subnet and mask for remote management.',
                        'Disable or enable the entry based on needs.'
                    ]
                }
            ]
        },
        REMOTE_MNGT_PARA: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Subnet/Mask',
                    content:
                        'Enter the Subnet/Mask of the remote host. If an entry with subnet 0.0.0.0/0 is added, all the remote hosts are allowed to access the device.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content:
                        'Check the box to enable the remote management function for the remote host. You can change the status after creating the entry.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: [
                        'The Remote Management IP should not include LAN IP (including legal LAN IP).',
                        'All the remote hosts are allowed to access the device if an entry with subnet 0.0.0.0/0 is added, which may result in illegal attack to the device. '
                    ]
                }
            ]
        },
        ADMIN_CONFIG_INTRODUCT: {
            TITLE: 'System Settings',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'In System Settings, you can specify the HTTP or HTTPS port for web management, and choose the type of protocol for accessing the management interface based on needs. Also, you can decide the session timeout time for the device for security purpose.'
                }
            ]
        },
        ADMIN_CONFIG_CONFIG: {
            TITLE: 'Configurations',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Configure the parameters for the ways to access the management interface of the  router and specify the session timeout time for security purpose. Click %<{"type":"button","text":"Save"}>%.'
                }
            ]
        },
        ADMIN_CONFIG_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'HTTP Server Port',
                    content:
                        'Specify the http server port for web management. The port number should be different from other servers. The default setting is 80. For example, if you change the http server port to 1600, you should access the interface by using IP address and the port number in the format of 192.168.0.1:1600.'
                },
                {
                    type: 'name',
                    title: 'Redirect HTTP to HTTPS',
                    content:
                        'Check the box to enable the function, then you will access the web management interface by HTTPS protocol, which is considered as a more secured way.'
                },
                {
                    type: 'name',
                    title: 'HTTPS Server Port',
                    content:
                        'Specify the https server port for web management. The port number should be different from other servers. The default setting is 443. For example, if you change the http server port to 1600, you should access the interface by using IP address and the port number in the format of https://192.168.0.1:1600.'
                },
                {
                    type: 'name',
                    title: 'HTTPS Server Status',
                    content: 'Check the box to enable HTTPS Server, then you can access the management interface via HTTPS server.'
                },
                {
                    type: 'name',
                    title: 'Web Idle Timeout',
                    content:
                        'Specify a session timeout time for the device. The web session will log out for security if there is no operation within the specified time.'
                }
            ]
        },

        FACTORY_INTRODUCT: {
            TITLE: 'Factory Default Restore',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'In Factory Default Restore, you can restore all the configurations of the router to the factory default settings.'
                }
            ]
        },
        FACTORY_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'Click %<{"type":"button","text":"Factory Restore"}>% to reset the device to the factory default settings.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: [
                        'All configurations will be cleared after system reset. Please go to Backup & Restore to back up the configurations in advance if needed.',
                        'The device will reboot automatically after reset.'
                    ]
                }
            ]
        },
        BACKUP_RESTORE_INTRODUCT: {
            TITLE: 'Backup & Restore',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Backup & Restore allows you to back up the current configurations, and restore the settings via backup files when needed. It is recommended to back up the settings before firmware upgrade or configuration modification.'
                }
            ]
        },
        BACKUP_RESTORE_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"button","text":"Backup"}>% to save a copy of your current settings.',
                        'Click %<{"type":"button","text":"Browse"}>% to select a backup file, and then click %<{"type":"button","text":"Restore"}>% to restore the settings from a backup file.'
                    ]
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: [
                        'If you want to export the configuration file from one device and import it to another device, please make sure the firmware versions of the two devices are same. The large defference of the firmware versions between the two devices may cause the loss of configuration information.',
                        'The device will reboot automatically after restoring.'
                    ]
                }
            ]
        },
        REBOOT_INTRODUCT: {
            TITLE: 'Reboot',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'In Reboot, you can reboot the device, and it will shut down and restart. Note that you should not power off the device during the reboot process, otherwise it may cause  unpredictable damage.'
                }
            ]
        },
        REBOOT_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'Click %<{"type":"button","text":"Reboot"}>% to reboot the device.'
                },
                {
                    type: 'note',
                    title: 'Note',
                    content: 'DO NOT power off the device during the reboot process, otherwise it may cause unpredictable damage.'
                }
            ]
        },
        FIRMWARE_INTRODUCT: {
            TITLE: 'Firmware Upgrade',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'In Firmware Upgrade, you can upgrade the firmware version of the device. Generally, the new firmware version has better performance and compatibility. The current configurations may be lost when the upgrade completes, and it is strongly recommended to back up the configurations in advance.'
                }
            ]
        },
        FIRMWARE_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Click %<{"type":"button","text":"Browse"}>% to select the file of the new firmware version.',
                        'Click %<{"type":"button","text":"Upgrade"}>% to start the upgrade process.'
                    ]
                }
            ]
        },
        FIRMWARE_PARA: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Firmware Version',
                    content: 'Displays the current Firmware Version of the device.'
                },
                {
                    type: 'name',
                    title: 'Hardware Version',
                    content: 'Displays the current Hardware Version of the device.'
                },
                {
                    type: 'name',
                    title: 'New Firmware File',
                    content: 'Click Browse to select a new firmware file to upgrade.'
                },
                {
                    type: 'note',
                    title: 'Tips',
                    content: [
                        'Do not power off the device or refresh the page while upgrading. The device will automatically reboot after upgrading completes. ',
                        'You can visit the official website <a href="http://www.tp-link.com" target="_blank">www.tp-link.com</a> to obtain the latest firmware.'
                    ]
                }
            ]
        },
        SNMP_INTRODUCT: {
            TITLE: 'SNMP',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'SNMP (Simple Network Management Protocol) provides a convenient and flexible method for network administrators to configure and monitor network devices centrally. Once you set up SNMP for the devices, the specified host will have the read-only access or the read-and-write access to the SNMP information of the device.'
                }
            ]
        },
        SNMP_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'Choose the SNMP version and specify the corresponding parameter.'
                }
            ]
        },
        SNMP_PARA: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'SNMPv1&v2c',
                    content: 'Check the box to enable the SNMPv1&v2c.',
                    children: [
                        {
                            type: 'name',
                            title: 'Contact',
                            content:
                                'With SNMPv1&v2c selected, enter the textual identification of the contact person for this the device, for example, contact or e-mail address.'
                        },
                        {
                            type: 'name',
                            title: 'Device Name',
                            content: 'With SNMPv1&v2c selected, enter a name for the device for easy identification.'
                        },
                        {
                            type: 'name',
                            title: 'Location',
                            content:
                                'With SNMPv1&v2c selected, enter the location of the device. For example, the name can be composed of the building, floor number, and room location.'
                        },
                        {
                            type: 'name',
                            title: 'Get Communit',
                            content:
                                "With SNMPv1&v2c selected, specify the community string for getting the read-only access to the device's SNMP information. When a manager tries to access the SNMP agent, the community helps authenticate the manage and establish trust between the manager and the agent. The default value of get community is public."
                        },
                        {
                            type: 'name',
                            title: 'Get Trusted Host',
                            content:
                                ' With SNMPv1&v2c selected, enter the IP address that can serve as Get Community to read the SNMP information of this device.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'SNMPv3',
                    content: 'Check the box to enable the SNMPv3.',
                    children: [
                        {
                            type: 'name',
                            title: 'Username',
                            content:
                                'With SNMPv3 selected, specify the username of your NMS (Network Management Station) to access the SNMP agent. You need to configure the username correspondingly on your NMS.'
                        },
                        {
                            type: 'name',
                            title: 'Password',
                            content:
                                'With SNMPv3 selected, specify the password of your NMS (Network Management Station) to access the SNMP agent. You need to configure the password correspondingly on your NMS.'
                        }
                    ]
                }
            ]
        },
        CONTROLLER_SETTINGS_INTRODUCT: {
            TITLE: 'Controller Settings',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'In Controller Settings, you can configure your router to be discovered by Omada SDN Controller, then it can be managed centrally via an Omada Controller.'
                },
                {
                    type: 'paragraph',
                    content:
                        'With this feature, you can configure your router via Omada Cloud-Based Controller. To enjoy centralized management on Omada Cloud-Based Controller, enable Cloud-Based Controller Management and add the router to the controller via its serial number.'
                },
                {
                    type: 'paragraph',
                    content: 'You can disable this feature if you do not need to manage the router with Omada Cloud-Based Controller.'
                },
                {
                    type: 'paragraph',
                    content:
                        'With the inform URL or IP address of the controller, the router can be discovered by the controller via this address. This feature is commonly used for the router to be managed by the controller in Layer 3 deployments.'
                }
            ]
        },

        CONTROLLER_SETTINGS_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'Enable Cloud-Based Controller Management, and then the router can be added to  Omada Cloud-Based Controller via its serial number.'
                },
                {
                    type: 'paragraph',
                    content:
                        'Specify the inform URL or IP address of the controller, the router can be discovered  by the controller via this address.'
                }
            ]
        },

        CONTROLLER_SETTINGS_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'Cloud-Based Controller Management.'
                },
                {
                    type: 'name',
                    title: 'Connection Status',
                    content: 'Displays the status of the connection between the router and Omada Cloud-Based Controller.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Disabled: Cloud-Based Controller Management is disabled.',
                                'Online: The router is connected to Omada Cloud and not managed by the cloud-based controller yet.',
                                'Offline: The router is not connected to Omada Cloud.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Cloud-Based Controller Management',
                    content:
                        'Enable or disable Omada Cloud-Based Controller Management. With this feature enabled, the router can communicate with Omada Cloud Platform. Then you can add the router to the cloud-based controller via its serial number.'
                },
                {
                    type: 'paragraph',
                    content: 'Controller Inform URL'
                },
                {
                    type: 'name',
                    title: 'Inform URL/IP Address',
                    content: 'Enter the inform URL or IP address of your controller to tell the router where to discover the controller.'
                },
                {
                    type: 'paragraph',
                    content:
                        'To get the inform URL of Omada Cloud-Based Controller, click the controller on your Omada Cloud Dashboard to reveal the Properties window, and then go to the Details tab'
                }
            ]
        },

        USB_LTE_INTRODUCT: {
            TITLE: 'Introduction',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'The USB Modem function is used to connect to the 3G/4G network of the ISP (Internet Service Provider) as the WAN connection, after you connect the 3G/4G USB modem to the USB port.<br/>To use this function, you should first set USB Modem as the WAN port on the Network > WAN page.'
                }
            ]
        },

        USB_LTE_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Confirm that the USB modem is connected to the USB port properly.',
                        'Specify the ISP information. You can specify the location and ISP, or you can set the Dial Number, APN, Username and Password manually.',
                        'Select the connection mode and configure the parameters according to the requirements of your ISP.',
                        'Click %<{"type":"button","text":"Save"}>%.'
                    ]
                }
            ]
        },

        USB_LTE_PARA: {
            TITLE: 'Parameters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'USB Modem',
                    content: 'Displays the status of the 3G/4G USB modem.'
                },
                {
                    type: 'name',
                    title: 'Location',
                    content:
                        'Automatically selects and displays the region when the USB modem and SIM card are successfully identified. If not, select the region from the drop-down menu.'
                },
                {
                    type: 'name',
                    title: 'Mobile ISP',
                    content: 'Displays the ISP of the 3G/4G network. If not automatically detected, select the ISP from the drop-down menu.'
                },
                {
                    type: 'name',
                    title: 'Dial Number, APN, Username and Password manually',
                    content:
                        'If the ISP is not listed in the Mobile ISP list, select this checkbox and enter the Dial Number, APN (Access Point Name), Username and Password that are provided by the ISP.'
                },
                {
                    type: 'name',
                    title: 'Connection Mode',
                    content: 'Select the connection mode and configure the parameters according to the requirements of your ISP.',
                    children: [
                        {
                            type: 'name',
                            title: 'Connect Automatically',
                            content: 'In this mode, the Internet connection reconnects automatically anytime it gets disconnected.'
                        },
                        {
                            type: 'name',
                            title: 'Connect Manually',
                            content:
                                'In this mode, you can click the Connect or Disconnect button to control the Internet connection manually.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Upload Bandwidth',
                    content:
                        'Specify the upstream bandwidth of the USB Modem. This value is the upper limit of the Maximum Upstream Bandwidth on Transmission > Bandwidth Control page. Also, this value determines the bandwidth ratio of USB Modem and WAN ports after Bandwidth Based Balance Routing is enabled on Transmission > Load Balancing > Basic Settings page.'
                },
                {
                    type: 'name',
                    title: 'Download Bandwidth',
                    content:
                        'Specify the downstream bandwidth of the USB Modem. This value is the upper limit of the Maximum Downstream Bandwidth on Transmission > Bandwidth Control page. Also, this value determines the bandwidth ratio of USB Modem and WAN ports after Bandwidth Based Balance Routing is enabled on Transmission > Load Balancing > Basic Settings page.'
                },
                {
                    type: 'name',
                    title: 'Authentication Type',
                    content:
                        'Select an authentication type. The default is Auto. Some ISPs require a specific authentication type, please confirm it with the ISP or keep the default settings.',
                    children: [
                        {
                            type: 'name',
                            title: 'Auto',
                            content: 'If Auto (default), the router automatically determines the authentication type used by the ISP.'
                        },
                        {
                            type: 'name',
                            title: 'PAP',
                            content:
                                'If PAP (Password Authentication Protocol), the router authenticates with the peer using two handshakes. Select this option if the ISP requires this authentication type.'
                        },
                        {
                            type: 'name',
                            title: 'CHAP',
                            content:
                                'If CHAP (Challenge Handshake Authentication Protocol), the router authenticates with the peer using three handshakes and validates the peer’s identify periodically. Select this option if the ISP requires this authentication type.'
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'MTU Size',
                    content: 'The default MTU (Maximum Transmission Unit) size is 1480 bytes. Do not change it unless required by the ISP.'
                },
                {
                    type: 'name',
                    title: 'Use the Following DNS Servers',
                    content:
                        'If the ISP provides DNS server IP addresses, select this checkbox and enter the Primary DNS and Secondary DNS (optional) IP addresses below. Otherwise, the DNS servers will be assigned dynamically by the ISP.',
                    children: [
                        {
                            type: 'name',
                            title: 'Primary DNS',
                            content: 'Enter the DNS IP address in dotted-decimal notation provided by the ISP.'
                        },
                        {
                            type: 'name',
                            title: 'Secondary DNS',
                            content: '(Optional) Enter another DNS IP address in dotted-decimal notation provided by the ISP.'
                        }
                    ]
                }
            ]
        },

        DIGNOSTIC_INTRODUCT: {
            TITLE: 'Diagnostics',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'You can detect the current network connection status by using diagnostic tools on  this page. Ping and traceroute are both used to test the connectivity between two devices in the network.'
                },
                {
                    type: 'paragraph',
                    content: 'Ping shows round trip time between the two devices directly.'
                },
                {
                    type: 'paragraph',
                    content:
                        'Traceroute records the time taken for each hop that the packet makes during its  route to the destination, reporting the IP addresses of all the routers it pinged in between.'
                },
                {
                    type: 'paragraph',
                    content:
                        'If you fail to solve your network problem, you can export the diagnostic information and try to contact with technicians. Under the guide of technicians, you can enable the Remote Assistance function to get help.'
                }
            ]
        },

        DIGNOSTIC_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'pearlStep',
                    content: [
                        'Select the command for connectivity diagnostics and specify the corresponding parameters',
                        'Click %<{"type":"button","text":"Start"}>% and the diagnosis results will be displayed in the table.'
                    ]
                }
            ]
        },

        DIGNOSTIC_PARA: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Diagnostic Tool',
                    content: 'Select the diagnostic tool to use. There are two types below.'
                },

                {
                    type: 'name',
                    title: 'Ping',
                    content: 'Select to test the connectivity between the router and the desired device by using the ping command.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                {
                                    type: 'name',
                                    title: 'Destination IP/Domain Name',
                                    content: 'Enter the IP address or the domain name that you want to ping or tracert.'
                                },
                                {
                                    type: 'name',
                                    title: 'Interface',
                                    content: 'Select the interface that the detection packets sent from.'
                                },
                                {
                                    type: 'name',
                                    title: 'Ping Count',
                                    content: 'Specify the count of the test packets to be sent during the ping process.'
                                },
                                {
                                    type: 'name',
                                    title: 'Ping Packet Size',
                                    content: 'Specify the size of the test packets to be sent during the ping process.'
                                }
                            ]
                        }
                    ]
                },

                {
                    type: 'name',
                    title: 'Traceroute',
                    content: 'Select to test the connectivity between the router and the desired  device by using the traceroute command.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                {
                                    type: 'name',
                                    title: 'Destination IP/Domain Name',
                                    content: 'Enter the IP address or the domain name that you want to ping or tracert.'
                                },
                                {
                                    type: 'name',
                                    title: 'Interface',
                                    content: 'Select the interface that the detection packets sent from.'
                                },
                                {
                                    type: 'name',
                                    title: 'Traceroute Max TTL',
                                    content:
                                        'Specify the traceroute max TTL (Time To Live) during the traceroute process. It is the maximum number of the route hops the test packets can pass through before the test packets are dropped and the test results are returned.'
                                }
                            ]
                        }
                    ]
                }
            ]
        },

        DIA_INFO_INTRODUCT: {
            TITLE: 'Remote Assistance',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'You can detect the current network connection status by using diagnostic tools on  this page. Ping and traceroute are both used to test the connectivity between two devices in the network. Ping shows round trip time between the two devices directly. Traceroute records the time taken for each hop that the packet makes during its route to the destination, reporting the IP addresses of all the routers it pinged in between.'
                },
                {
                    type: 'paragraph',
                    content:
                        'If you fail to solve your network problem, you can export the diagnostic information and try to contact with technicians. Under the guide of technicians, you can enable the Remote Assistance function to get help.'
                }
            ]
        },
        DIA_INFO_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'Enable Remote assistance, and follow the guidance of technicians to get help for the network problem.'
                }
            ]
        },
        DIA_INFO_PARA: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Remote Assistance',
                    content: 'Enable the Remote Assistance function to get help under the guidance of technicians.'
                },
                {
                    type: 'name',
                    title: 'Diagnositc Information',
                    content:
                        'Click Export to download a bin-formatted file containing helpful information, and send it to the technicians for help.'
                },

                {
                    type: 'note',
                    title: 'Note',
                    content: [
                        'In general, it is recommended to keep the Remote Assistance function disabled.',
                        'Please enable this function with the help of technicians if it is needed.'
                    ]
                }
            ]
        },

        TIME_SETTING_INTRODUCT: {
            TITLE: 'Time Settings',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'In Time Settings, you can view and configure the time-related settings, including the ways in which the router gets the time configuration and Daylight Saving Time.'
                }
            ]
        },
        TIME_SETTING_CONFIG: {
            TITLE: 'Configuration',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Time Settings',
                    content:
                        'Select the way in which the router gets its system time configurations and specify the corresponding parameters.'
                },
                {
                    type: 'name',
                    title: 'Daylight Saving Time',
                    content: 'Select the mode based on needs and specify the corresponding parameters.'
                }
            ]
        },

        TIME_SETTING_PARA: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'Time Settings'
                },
                {
                    type: 'name',
                    title: 'Current Time',
                    content: 'Displays the current system time of the router.'
                },
                {
                    type: 'name',
                    title: 'Time Config',
                    content:
                        'Select one method to configure the system time. There are two methods here: "Get automatically from the Internet" and "Manually".'
                },
                {
                    type: 'name',
                    title: 'Get automatically from the Internet',
                    content: 'Select to get Coordinated Universal Time (UTC) from the internet.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Time Zone: Select the time zone the device is in.',
                                'Primary/Secondary NTP Server: By default, 0.0.0.0 is displayed, and the router will synchronize the time with the built-in NTP server. Specify the IP address of the NTP server if you need to customize, and then the clock of your router will be synchronized with the clock on the NTP server periodically.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Manually',
                    content: 'Select to specify the system time manually.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Date: Specify the date of the system in the format of MM/DD/YYYY.',
                                'Time: Specify the time of the system in the format of HH/MM/SS.',
                                "Synchronize with PC's Clock: Click Synchronize with PC's Clock to obtain the time from the host."
                            ]
                        }
                    ]
                },
                {
                    type: 'paragraph',
                    content: 'Daylight Saving Time'
                },
                {
                    type: 'name',
                    title: 'DST Status',
                    content: 'Check the box to enable Daylight Saving Time.'
                },
                {
                    type: 'name',
                    title: 'Mode',
                    content: 'Select a mode for the the DST feature to take effect.'
                },
                {
                    type: 'name',
                    title: 'Predefined Mode',
                    content: 'Select a predefined DST configuration.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'USA: Second Sunday of March at 02:00 ~ First Sunday of November at 02:00.',
                                'Europe: Last Sunday of March at 01:00 ~ Last Sunday of October at 01:00.',
                                'Australia: First Sunday of October at 02:00 ~ First Sunday of April at 03:00.',
                                'New Zealand: Last Sunday of September at 02:00 ~ First Sunday of April at 03:00.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Recurring Mode',
                    content: 'Specify the DST configuration in recurring mode. This configuration is recurring in use.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Time Offset: Specify the time added in minutes when Daylight Saving Time takes effect.',
                                'Starting/Ending Time: Specify starting and ending time of Daylight Saving Time. All times are relative to the local time zone. The starting time is relative to standard time. The ending time is relative to daylight saving time.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Date Mode',
                    content: 'Specify the DST configuration in date mode. This configuration is one-off in use.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Time Offset: Specify the time added in minutes when Daylight Saving Time takes effect.',
                                'Starting/Ending Time: Specify the starting and ending time of Daylight Saving Time. All times are relative to the local time zone. The starting time is relative to standard time. The ending time is relative to daylight saving time.'
                            ]
                        }
                    ]
                }
            ]
        },

        SYSTEM_LOG_INTRODUCT: {
            TITLE: 'System Log',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'You can view the system status and log on this page. You can choose different levels based on their importance, and only the log of the chosen level will be displayed. Also, log can be sent to a log server when needed.'
                }
            ]
        },

        SYSTRM_LOG_PARA: {
            TITLE: 'Paramaters',
            CONTENT: [
                {
                    type: 'name',
                    title: 'Log Settings',
                    children: [
                        {
                            type: 'name',
                            title: 'Enable Auto-refresh',
                            content: 'Check Enable Auto-refresh and the page will refresh automatically every 10 seconds.'
                        },
                        {
                            type: 'name',
                            title: 'Severity',
                            content: 'Check Severity and specify the importance of the logs you want to view.'
                        },
                        {
                            type: 'name',
                            title: '&nbspALL Level',
                            content: 'Logs of all levels.'
                        },
                        {
                            type: 'name',
                            title: '&nbspEMERGENCY',
                            content: 'Errors that render the router unusable, such as hardware errors. '
                        },
                        {
                            type: 'name',
                            title: '&nbspALERT',
                            content: 'Errors that must be resolved immediately, such as flash write errors. '
                        },
                        {
                            type: 'name',
                            title: '&nbspCRITICAL',
                            content: 'Errors that put the system at risk, such as a failure to release memory. '
                        },
                        {
                            type: 'name',
                            title: '&nbspERROR',
                            content: 'Generic errors. '
                        },
                        {
                            type: 'name',
                            title: '&nbspWARNING',
                            content: 'Warning messages, such as WinNuke attack warnings. '
                        },
                        {
                            type: 'name',
                            title: '&nbspNOTICE',
                            content: 'Important notifications, such as IKE policy mismatches. '
                        },
                        {
                            type: 'name',
                            title: '&nbspINFO',
                            content: 'Informational messages. '
                        },
                        {
                            type: 'name',
                            title: '&nbspDEBUG',
                            content: 'Debug-level notifications, such as when the router receives a DNS packet. '
                        },
                        {
                            type: 'name',
                            title: 'Send Log',
                            content:
                                'Check the box and then the newly generated logs will be sent to the log server using the Syslog protocol. '
                        },
                        {
                            type: 'name',
                            title: '&nbspServer IP',
                            content: 'Specify the IP address of the log server.'
                        }
                    ]
                },

                {
                    type: 'name',
                    title: 'Log List',
                    children: [
                        {
                            type: 'name',
                            title: 'Refresh',
                            content: 'Click the button to refresh the logs manually.'
                        },
                        {
                            type: 'name',
                            title: 'Delete All',
                            content: 'Click the button to delete all logs saved in the device.'
                        },
                        {
                            type: 'name',
                            title: 'Save Log',
                            content: 'Click the button and the device will save the current logs as a file to the host. '
                        }
                    ]
                }
            ]
        },

        WIRELESS_BASIC: {
            TITLE: 'Wireless Settings',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'On this page you can configure the basic parameters of the wireless network.'
                },
                {
                    type: 'name',
                    title: 'Wireless',
                    content: 'Check the box to enable the wireless function.'
                },
                {
                    type: 'name',
                    title: 'SSID',
                    content: 'Specify the name of the wireless network.'
                },
                {
                    type: 'name',
                    title: 'SSID Encoding',
                    content:
                        'Set the SSID Encoding as UTF8 or GBK. Only when the SSID contains Chinese charaters can you configure this parameter.'
                },
                {
                    type: 'name',
                    title: 'AP Isolation',
                    content:
                        'Enable AP Isolation function to isolate wireless stations in your network from each other. Wireless devices will only be able to communicate with the router.'
                },
                {
                    type: 'name',
                    title: 'Hide SSID',
                    content:
                        'Select if you want to hide the network name (SSID) from the wireless clients. When selected, the wireless router will not broadcast the SSID on the air.'
                },
                {
                    type: 'name',
                    title: 'Security',
                    content: 'Select one of the following security options.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'No Security: Select this option to disable the network security. It is not recommended to choose this option for security.',
                                'WPA-PSK/WPA2-PSK (Recommended): Select WPA-PSK/WPA2-PSK as the security option. This option requires a PSK password for authentication and you do not need to configure the authentication server.',
                                'WPA/WPA2: Select WPA/WPA2 as the security option. This option requires to configure the Radius Server for authentication.',
                                'WEP: Select WPA/WPA2 as the security option. It is based on the IEEE 802.11 standard.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Authentication Type',
                    content: 'Select the authentication type when using WPA-PSK/WPA2-PSK or WPA/WPA2 as the security option. ',
                    children: [
                        {
                            type: 'step',
                            content: [
                                "For WPA-PSK/WPA2-PSK, there are three authentication types including Automatic, WPA-PSK and WPA2-PSK. It is recommended to choose Automatic for automatically selecting  WPA-PSK or WPA2-PSK according to the wireless station's capability and request.",
                                "For WPA/WPA2, there are three authentication types including Automatic, WPA and WPA2. It is recommended to choose Automatic for automatically selecting WPA or WPA2 according to the wireless station's capability and request.",
                                "For WEP, there are three authentication types including Automatic,  Open System and Shared Key. It is recommended to choose Automatic for automatically selecting Open System or Shared Key according to the wireless station's capability and request."
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Encryption',
                    content: 'Select the encryption algorithm when using WPA-PSK/WPA2-PSK or WPA/WPA2 as the security option. ',
                    children: [
                        {
                            type: 'step',
                            content: [
                                "For WPA-PSK/WPA2-PSK, there are three encryption algorithms including Automatic, TKIP (Temporal Key Integrity Protocol) and AES (Advanced Encryption Standard). It is recommended to choose Automatic for automatically selecting TKIP or AES according to the wireless station's capability and request.",
                                "For WPA/WPA2, there are three encryption algorithms including Automatic, TKIP (Temporal Key Integrity Protocol) and AES (Advanced Encryption Standard). It is recommended to choose Automatic for automatically selecting TKIP or AES according to the wireless station's capability and request."
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'PSK Password',
                    content:
                        'Specify a password when you select WPA-PSK/WPA2-PSK as the security option. Please enter 8 to 63 ASCII characters or 8 to 64 hexadecimal characters. '
                },
                {
                    type: 'name',
                    title: 'RADIUS Server IP',
                    content: 'Specify the IP address of the RADIUS Server when you select WPA/WPA2 as the security option.'
                },
                {
                    type: 'name',
                    title: 'RADIUS Port',
                    content: 'Specify the port number of the RADIUS Server when you select WPA/WPA2 as the security option.'
                },
                {
                    type: 'name',
                    title: 'RADIUS Password',
                    content:
                        'Specify the password for the RADIUS Server when you select WPA/WPA2 as the security option. Please enter 8 to 63 ASCII characters or 8 to 64 hexadecimal characters. '
                },
                {
                    type: 'name',
                    title: 'Group Key Update Period',
                    content:
                        'Specify the group key update period in seconds. The period should be 0 or a value more than 30. 0 means no update.'
                },
                {
                    type: 'name',
                    title: 'WEP Key Format',
                    content:
                        'Select Hexadecimal or ASCII as the WEP key format.<br>Hexadecimal format stands for any combination of hexadecimal digits (0-9, a-f, A-F) in the specified length. <br>ASCII format stands for any combination of keyboard characters in the specified length. '
                },
                {
                    type: 'name',
                    title: 'Key Selected',
                    content: 'Select the key to be used according to your actual needs.'
                },
                {
                    type: 'name',
                    title: 'WEP Key',
                    content:
                        'Select which of the four keys will be used and enter the matching WEP key that you create. Make sure these values are identical on all wireless stations in your network.  '
                },
                {
                    type: 'name',
                    title: 'Key Type',
                    content:
                        'Select the WEP key length (64-bit, 128-bit or 152-bit) for encryption. "Disable" means this WEP key entry is invalid.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                '64-bit: You can enter 10 hexadecimal digits (any combination of 0-9, a-f, A-F, zero key is not promoted) or 5 ASCII characters.',
                                '128-bit: You can enter 26 hexadecimal digits (any combination of 0-9, a-f, A-F, zero key is not promoted) or 13 ASCII characters.',
                                '152-bit: You can enter 32 hexadecimal digits (any combination of 0-9, a-f, A-F, zero key is not promoted) or 16 ASCII characters.'
                            ]
                        }
                    ]
                }
            ]
        },
        WIRELESS_MSSID: {
            TITLE: 'General',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can create and configure multi SSIDs on this page.'
                },
                {
                    type: 'name',
                    title: 'SSID Insulation',
                    content:
                        'Enable or disable the SSID Insulation. If enabled, the hosts accessing to different SSIDs cannot communicate with each other. '
                }
            ]
        },
        WIRELESS_MSSID_LIST: {
            TITLE: 'Multi-SSID List',
            CONTENT: [
                {
                    type: 'name',
                    title: 'SSID',
                    content: 'Specify the name of the wireless network.'
                },
                {
                    type: 'name',
                    title: 'SSID Encoding',
                    content:
                        'Set the SSID Encoding as UTF8 or GBK. Only when the SSID contains Chinese charaters can you configure this parameter.'
                },
                {
                    type: 'name',
                    title: 'AP Isolation',
                    content:
                        'Enable AP Isolation function to isolate wireless stations in your network from each other. Wireless devices will only be able to communicate with the router.'
                },
                {
                    type: 'name',
                    title: 'Hide SSID',
                    content:
                        'Select if you want to hide the network name (SSID) from the wireless clients. When selected, the wireless router will not broadcast the SSID on the air.'
                },
                {
                    type: 'name',
                    title: 'Security',
                    content: 'Select one of the following security options.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'No Security: Select this option to disable the network security. It is not recommended to choose this option for security.',
                                'WPA-PSK/WPA2-PSK (Recommended): Select WPA-PSK/WPA2-PSK as the security option. This option requires a PSK password for authentication and you do not need to configure the authentication server.',
                                'WPA/WPA2: Select WPA/WPA2 as the security option. This option requires to configure the Radius Server for authentication.',
                                'WEP: Select WPA/WPA2 as the security option. It is based on the IEEE 802.11 standard.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Authentication Type',
                    content: 'Select the authentication type when using WPA-PSK/WPA2-PSK or WPA/WPA2 as the security option. ',
                    children: [
                        {
                            type: 'step',
                            content: [
                                "For WPA-PSK/WPA2-PSK, there are three authentication types including Automatic, WPA-PSK and WPA2-PSK. It is recommended to choose Automatic for automatically selecting  WPA-PSK or WPA2-PSK according to the wireless station's capability and request.",
                                "For WPA/WPA2, there are three authentication types including Automatic, WPA and WPA2. It is recommended to choose Automatic for automatically selecting WPA or WPA2 according to the wireless station's capability and request.",
                                "For WEP, there are three authentication types including Automatic,  Open System and Shared Key. It is recommended to choose Automatic for automatically selecting Open System or Shared Key according to the wireless station's capability and request."
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Encryption',
                    content: 'Select the encryption algorithm when using WPA-PSK/WPA2-PSK or WPA/WPA2 as the security option. ',
                    children: [
                        {
                            type: 'step',
                            content: [
                                "For WPA-PSK/WPA2-PSK, there are three encryption algorithms including Automatic, TKIP (Temporal Key Integrity Protocol) and AES (Advanced Encryption Standard). It is recommended to choose Automatic for automatically selecting TKIP or AES according to the wireless station's capability and request.",
                                "For WPA/WPA2, there are three encryption algorithms including Automatic, TKIP (Temporal Key Integrity Protocol) and AES (Advanced Encryption Standard). It is recommended to choose Automatic for automatically selecting TKIP or AES according to the wireless station's capability and request."
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'PSK Password',
                    content:
                        'Specify a password when you select WPA-PSK/WPA2-PSK as the security option. Please enter 8 to 63 ASCII characters or 8 to 64 hexadecimal characters. '
                },
                {
                    type: 'name',
                    title: 'Group Key Update Period',
                    content:
                        'Specify the group key update period in seconds. The period should be 0 or a value more than 30. 0 means no update.'
                },
                {
                    type: 'name',
                    title: 'RADIUS Server IP',
                    content: 'Specify the IP address of the RADIUS Server when you select WPA/WPA2 as the security option.'
                },
                {
                    type: 'name',
                    title: 'RADIUS Port',
                    content: 'Specify the port number of the RADIUS Server when you select WPA/WPA2 as the security option.'
                },
                {
                    type: 'name',
                    title: 'RADIUS Password',
                    content:
                        'Specify the password for the RADIUS Server when you select WPA/WPA2 as the security option. Please enter 8 to 63 ASCII characters or 8 to 64 hexadecimal characters. '
                },
                {
                    type: 'name',
                    title: 'WEP Key Format',
                    content:
                        'Select Hexadecimal or ASCII as the WEP key format.<br>Hexadecimal format stands for any combination of hexadecimal digits (0-9, a-f, A-F) in the specified length. <br>ASCII format stands for any combination of keyboard characters in the specified length. '
                },
                {
                    type: 'name',
                    title: 'Key Selected',
                    content: 'Select the key to be used according to your actual needs.'
                },
                {
                    type: 'name',
                    title: 'WEP Key',
                    content:
                        'Select which of the four keys will be used and enter the matching WEP key that you create. Make sure these values are identical on all wireless stations in your network.  '
                },
                {
                    type: 'name',
                    title: 'Key Type',
                    content:
                        'Select the WEP key length (64-bit, 128-bit or 152-bit) for encryption. "Disable" means this WEP key entry is invalid.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                '64-bit: You can enter 10 hexadecimal digits (any combination of 0-9, a-f, A-F, zero key is not promoted) or 5 ASCII characters.',
                                '128-bit: You can enter 26 hexadecimal digits (any combination of 0-9, a-f, A-F, zero key is not promoted) or 13 ASCII characters.',
                                '152-bit: You can enter 32 hexadecimal digits (any combination of 0-9, a-f, A-F, zero key is not promoted) or 16 ASCII characters.'
                            ]
                        }
                    ]
                }
            ]
        },
        WIRELESS_WDS: {
            TITLE: 'WDS',
            CONTENT: [
                {
                    type: 'paragraph',
                    content:
                        'You can configure the WDS (Wireless Distribution System) Bridging function to extend your wireless network on this page.'
                },
                {
                    type: 'name',
                    title: 'WDS',
                    content: 'Check the box to enable WDS function. With this function, the router can bridge two or more WLANs. '
                },
                {
                    type: 'name',
                    title: 'Scan',
                    content:
                        'Scan the SSID to be bridged and the scanning result will be displayed in the wireless network list. Please try the following:',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Click Scan to search for the wireless network nearby.',
                                'Locate the SSID of the router to be bridged in the Wireless Network List and click Connect.',
                                'Enter the key (wireless password) of the router to be bridged.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'SSID (to be bridged)',
                    content: 'Enter the network name (SSID) of the router to be bridged.'
                },
                {
                    type: 'name',
                    title: 'MAC Address (to be bridged)',
                    content: 'Enter the MAC address of the router to be bridged.'
                },
                {
                    type: 'name',
                    title: 'Security',
                    content: 'Select the security option of the router to be bridged.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'No Security: Select this option to disable the network security. It is not recommended to choose this option for security.',
                                'WEP (ASCII format): Select WEP (ASCII format) as the security option. ASCII format stands for any combination of keyboard characters in the specified length.',
                                'WEP (Hexadecimal format): Select WEP (Hexadecimal format) as the security option. Hexadecimal format stands for any combination of hexadecimal digits (0-9, a-f, A-F) in the specified length.',
                                'WPA-PSK/WPA2-PSK (Recommended): Select WPA-PSK/WPA2-PSK as the security option. This option requires a PSK password for authentication and you do not need to configure the authentication server.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'Key Selected',
                    content: 'Select the key according to the WEP Key Index of the AP your router is going to connect to.'
                },
                {
                    type: 'name',
                    title: 'Authentication Type',
                    content:
                        'Specify the authentication type according to the Authentication Type of the AP your router is going to connect to.'
                },
                {
                    type: 'name',
                    title: 'Key',
                    content: 'Enter the wireless password if the wireless network to be bridged has a wireless password.'
                }
            ]
        },
        WIRELESS_WDS_STATUS: {
            TITLE: 'WDS Status',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can check the WDS connection status.'
                }
            ]
        },
        WIRELESS_ADVANCED: {
            TITLE: 'Advanced Settings',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can configure the wireless advanced parameters according to your actual needs.'
                },
                {
                    type: 'name',
                    title: 'Channel',
                    content:
                        'Select the frequency to be used. It is recommended to choose automatic. Under automatic mode, the router will choose the best channel automatically. It is not necessary to change the wireless channel unless you notice interference problems with another nearby access point. The channel cannot be configured when the WDS function is enabled.'
                },
                {
                    type: 'name',
                    title: 'Mode',
                    content:
                        'Select the desired wireless mode. It is recommended to keep the default option. Changing the wireless mode may affect the wireless speed. The mode cannot be configured when the WDS function is enabled.'
                },
                {
                    type: 'name',
                    title: 'Channel Width',
                    content:
                        'Select the bandwidth of the wireless channel. The channel width cannot be configured when the WDS function is enabled.'
                },
                {
                    type: 'name',
                    title: 'Transmit Power',
                    content:
                        'Specify the transmit power of router. High is suitable for large wireless coverage or an environment with multi obstacles . Middle is suitable for medium wireless coverage or an environment with fewer obstacles.  Low is suitable for small wireless coverage or an environment without obstacles.'
                },
                {
                    type: 'name',
                    title: 'Beacon Interval',
                    content:
                        'Specify the time interval of the beacons ranging from 40 to 1000 milliseconds. The default value is 100. The beacons are the packets sent by the router to synchronize a wireless network. '
                },
                {
                    type: 'name',
                    title: 'RTS Threshold',
                    content:
                        'Specify the RTS (Request to Send) Threshold. If the packet is larger than the specified RTS Threshold size, the router will send RTS frames to a particular receiving station and negotiate the sending of a data frame. The default value is 2346.'
                },
                {
                    type: 'name',
                    title: 'Fragmentation Threshold',
                    content:
                        'Specify the maximum size determining whether packets will be fragmented. Setting the Fragmentation Threshold too low may result in poor network performance since excessive packets. It is recommended to keep the default value 2346.  '
                },
                {
                    type: 'name',
                    title: 'DTIM Interval',
                    content:
                        'Specify the interval of the Delivery Traffic Indication Message (DTIM). You can specify the value between 1-255 Beacon Intervals. The default value is 1.'
                },
                {
                    type: 'name',
                    title: 'Short GI',
                    content:
                        'It is recommended to enable Short GI for it will increase the data capacity by reducing the guard interval time.'
                },
                {
                    type: 'name',
                    title: 'WMM',
                    content:
                        'WMM (Wi-Fi MultiMedia) can guarantee the packets with high- priority messages transmitted preferentially. It is recommended to enable this function.  This option is unavailable if the mode is selected as 802.11n only or 802.11b/g/n mixed.'
                }
            ]
        },
        WIRELESS_VISITOR: {
            TITLE: 'Guest Network',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can configure the parameters of Guest Network on this page.'
                },
                {
                    type: 'name',
                    title: 'Guest Network',
                    content: 'Check the box to enable Guest Network.'
                },
                {
                    type: 'name',
                    title: 'SSID',
                    content: 'Specify the name of the Guest Network.'
                },
                {
                    type: 'name',
                    title: 'SSID Encoding',
                    content:
                        'Set the SSID Encoding as UTF8 or GBK. Only when the SSID contains Chinese charaters can you configure this parameter.'
                },
                {
                    type: 'name',
                    title: 'Security',
                    content: 'Select one of the following security options.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'No Security: Select this option to disable the network security. It is not recommended to choose this option for security.',
                                'WPA-PSK/WPA-PSK/WPA2-PSK (Recommended): Select WPA-PSK/WPA2-PSK as the security option. This option requires a PSK password for authentication and you do not need to configure the authentication server.'
                            ]
                        }
                    ]
                },
                {
                    type: 'name',
                    title: 'PSK Password',
                    content:
                        'Specify a password when you select WPA-PSK/WPA2-PSK as the security option. Please enter 8 to 63 ASCII characters or 8 to 64 hexadecimal characters. '
                }
            ]
        },
        WIRELESS_VISITOR_ADVANCED: {
            TITLE: 'Advanced Settings',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can configure advanced parameters for the Guest Network.'
                },
                {
                    type: 'name',
                    title: 'Upstream/Downstream Bandwidth',
                    content:
                        'Specify the maximum upstream/downstream bandwidth in Kbps for the Guest Network. The value should be 100 to 1000000 or 0 and 0 means no limit.'
                },
                {
                    type: 'name',
                    title: 'Maximum number of access devices',
                    content:
                        'Specify the maximum number of wireless devices allowing to access the Guest Network. The number should be 1 to 20.'
                }
            ]
        },
        WIRELESS_MACFILTER: {
            TITLE: 'Wireless MAC Filtering',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can control the wireless access by configuring the Wireless MAC Filtering on this page.'
                },
                {
                    type: 'name',
                    title: 'Wireless MAC Filtering',
                    content: 'Check the box to enable Wireless MAC Filtering function.'
                },
                {
                    type: 'name',
                    title: 'SSID',
                    content:
                        'Select an SSID in the drop-down list. The related MAC Address Filtering rules can be applied to the SSID you select. A new SSID can be created on the Wireless > Wireless Settings > Multi-SSID page.'
                },
                {
                    type: 'name',
                    title: 'Filtering Rules',
                    content: 'Select the filtering rule.',
                    children: [
                        {
                            type: 'step',
                            content: [
                                'Blacklist (Deny access of devices): The router will deny the host with the MAC Address in the rule list to access the local wireless network.',
                                'Whitelist (Allow access of devices): The router will allow the host with the MAC Address is in the rule list to access the local wireless network.'
                            ]
                        }
                    ]
                }
            ]
        },
        WIRELESS_MACFILTER_LIST: {
            TITLE: 'Rule List',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the MAC Filtering list or configure the current entries.'
                },
                {
                    type: 'name',
                    title: 'MAC Address',
                    content: 'Enter the MAC address in the format xx-xx-xx-xx-xx-xx.'
                },
                {
                    type: 'name',
                    title: 'Description',
                    content: 'Give a description for the MAC filtering entry. It ranges from 1 to 50 characters.'
                }
            ]
        },
        WIRELESS_HOST_STATUS: {
            TITLE: 'Wireless Host Status',
            CONTENT: [
                {
                    type: 'paragraph',
                    content: 'You can view the information of all the hosts connected to the wireless network on this page.'
                },
                {
                    type: 'name',
                    title: 'SSID',
                    content: 'Select an SSID, the status of the host in this wireless network will display on the following table. '
                },
                {
                    type: 'name',
                    title: 'Host Name',
                    content: 'Displays the name of the host connected to the router wirelessly. '
                },
                {
                    type: 'name',
                    title: 'MAC Address',
                    content: 'Displays the MAC address of the host connected to the router wirelessly. '
                },
                {
                    type: 'name',
                    title: 'Host SSID',
                    content: 'Displays the name of the SSID to which the host connects.'
                },
                {
                    type: 'name',
                    title: 'Upstream/Downstream Bandwidth (KB/s)',
                    content: 'Displays the upstream/downstream bandwidth of the host.'
                },
                {
                    type: 'name',
                    title: 'Status',
                    content: 'Displays the status of the wireless connection.'
                }
            ]
        },

        '': ''
    }
})(jQuery)
